commit 2d8a388de215d9959d72bb11f03e07a6eb2e4614
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Oct 10 13:37:07 2025 +1100

    depend

commit 1d2676f4ffae35e2db37a35c385efaf2932cd639
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Oct 9 14:53:04 2025 +1100

    update versions

commit ecd65a492bd0ed3a44a1c07428107b2e148bfee4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 8 00:32:52 2025 +0000

    upstream: openssh-10.2
    
    The only change since 10.1 is the channels.c fix
    
    OpenBSD-Commit-ID: 5eebeb0db14c694efd4ee96b5f16112e3e5d5ba9

commit ea9af2921cb6af8e65341531db3a7351917f0a92
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 8 21:02:16 2025 +0000

    upstream: fix crash at exit (visible via ssh-keygen -D) when
    
    multiple keys loaded. ok markus deraadt dtucker
    
    OpenBSD-Commit-ID: baa9763ec69d162108dafd962792ec5610ff45c9

commit e49013576074ccd2d7ae75fb824170c739ce97a1
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Oct 9 10:07:40 2025 +1100

    link ssh-keygen directly against ssh-pkcs11.c
    
    Matches what OpenBSD does and fixes ssh-keygen regression in
    certifying keys using a CA key hosted via ssh-agent (bz3877)

commit 684f2ceff8c0eeb775e8653cf32609f8fbfe07b1
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Oct 9 13:10:27 2025 +1100

    some fixes to p11_setup
    
    1. Use the ssh-keygen under test and not the one in $PATH
    2. Include a test PKCS#11 operation to ensure that the P11 stack is
       working correctly.
    
    Previously, it was possible for p11_setup to return success on
    configurations with PKCS#11 support disabled.

commit af17ae64a5cfee42334883d2802f40f779131740
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Oct 9 13:12:15 2025 +1100

    complete PKCS#11 stubs and move to ssh-pkcs11.c
    
    Should unbreak --disable-pkcs11 builds

commit bcf7c05a473f92a35f4f3b561fd7a1e339e0a30f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Oct 8 11:26:52 2025 +1100

    Fix header name and move return outside of ifdef.
    
    Fixes from Mike Frysinger via Github PR#597.

commit b937061fe4922caced7b91442b3233c0bd763492
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 7 21:10:33 2025 +1100

    Check HAVE_MMAP too now that configure sets it.

commit 8d57083c062f03098c9f767ec8d6278dc549a2f6
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 7 21:07:05 2025 +1100

    Use calloc for sshkeys if mmap is not supported.
    
    Based on Github PR#597 from Mike Frysinger, any bugs added by me.

commit c97b931bffa481c72ff4bfddd9d59a2110899289
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 7 20:25:07 2025 +1100

    Add fcntl.h to includes.
    
    From FreeBSD via bz#3874: "This was previously included due to nested
    includes in Heimdal's headers.  Without this, the build fails with an
    error due to redefining AT_FDCWD."

commit 8aa13832315e52c4404c993a59c6139b44ac6114
Author: Daan De Meyer <daan.j.demeyer@gmail.com>
Date:   Mon Mar 20 20:22:14 2023 +0100

    Only set PAM_RHOST if the remote host is not "UNKNOWN"
    
    When using sshd's -i option with stdio that is not a AF_INET/AF_INET6
    socket, auth_get_canonical_hostname() returns "UNKNOWN" which is then
    set as the value of PAM_RHOST, causing pam to try to do a reverse DNS
    query of "UNKNOWN", which times out multiple times, causing a
    substantial slowdown when logging in.
    
    To fix this, let's only set PAM_RHOST if the hostname is not "UNKNOWN".

commit 0bd6649ea80ead0cd6404dbc25b64937421b556e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 7 20:10:56 2025 +1100

    Don't copy native host keys for hostbased test.
    
    Some github runners (notably macos-14) seem to have host keys where
    public and private do not match, so generate our own keys for testing
    purposes.

commit 33b63718d40ccc555b8c7a24331a3790b2efc6c5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 7 20:10:07 2025 +1100

    Add 10.1 branch to ci-status page.

commit 52411f15353257e9ec883fc044b7a56b6fca242d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 7 20:04:40 2025 +1100

    Add clock_gettime compat shim.
    
    This fixes the build on macOS prior to 10.12 Sierra, since it does not
    have it.  Found and tested by Sevan Janiyan.

commit beae06f56e0d0a66ca535896149d5fb0b2e8a1b4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Oct 7 08:02:32 2025 +0000

    upstream: don't reuse c->isatty for signalling that the remote channel
    
    has a tty attached as this causes side effects, e.g. in channel_handle_rfd().
    bz3872
    
    ok markus@
    
    OpenBSD-Commit-ID: 4cd8a9f641498ca6089442e59bad0fd3dcbe85f8

commit 476bab6259d5a6ea0402ec79bc47ed61e2c15e86
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 6 12:52:25 2025 +1100

    depend

commit af956575eba6bf6b6d6bc817e1aa6ed73a365984
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 6 12:51:13 2025 +1100

    update versions

commit 2fd0945913a30fbbe7c02503347961df03f28e66
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 6 12:48:16 2025 +1100

    sync ssh-copy-id to upstream version 527be673f4d

commit 981bb32bc6062fa5d6f11de7ffb732967463bf57
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Oct 6 01:45:22 2025 +0000

    upstream: openssh-10.1
    
    OpenBSD-Commit-ID: 2a232c2d2fc05a23519f69bc29e6d8c076b97d97

commit b9a640a1a0dccfb56be684cc7ade402f57cf7ebd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Oct 3 01:03:45 2025 +0000

    upstream: If write() returned short, the subsequent write would restart
    
    from the beginning of the buffer not the end of what was written.  Fix, since
    we want modpipe to corrupt data for testing purposes deliberately not
    accidentally.  ok djm@
    
    OpenBSD-Regress-ID: 50ca74d287445c58944f070bb92dc13b1d054b43

commit a0e5446ac85aca5a3ef9844eeedf787300fdb8b3
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Sat Oct 4 21:41:35 2025 +0000

    upstream: typos: a ssh* -> an ssh*
    
    ok dtucker@
    
    OpenBSD-Commit-ID: a70fd2e1b23089260e8f5a7921b0debc06b011cb

commit ade92f53c3bd4ad7dcd95334a194add57ec9ff71
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 3 00:09:26 2025 +0000

    upstream: stray newline
    
    OpenBSD-Commit-ID: b47ed4fa93b781c7ec8ae2936526a290f4e17e1f

commit a9cbe10da2be5be76755af0cea029db0f9c1f263
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 3 00:08:02 2025 +0000

    upstream: include openssl/bn.h explicitly in files where we use BN_*
    
    makes things simpler for portable; from Mike Frysinger
    
    OpenBSD-Commit-ID: 717e93403fd1108e175afd7451b5a4ab46a598fe

commit 3957cc2914cdc88932c972413853f8b68c1ffba5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Oct 2 08:38:43 2025 +0000

    upstream: Relax array check slightly. Prevents compiler warnings
    
    in -portable when there are no kbdint devices present.  ok djm@
    
    OpenBSD-Commit-ID: c1c050cecd642d6073c792201908fd225191df93

commit 6a239b057be2897d7a597daaf5394f2e7312dc65
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 2 04:23:11 2025 +0000

    upstream: backout r1.243 (fix for fatal during tab-completion with
    
    some multibyte sequences) as it breaks the common case for tab completion.
    
    Will deal with it properly after release.
    
    OpenBSD-Commit-ID: 196d00f5ff19579214de45357f16a1fb2d624be1

commit b9f6a84ea383d811216de38219472214963c10b2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Oct 2 10:48:04 2025 +1000

    Pass COMPATINCLUDES down to openbsd-compat too.
    
    Fixes build on Solaris, AIX and probably others.

commit 047e0221eaf9815775e8ea78c6d6add5ab0f68c7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Oct 1 14:34:02 2025 +1000

    Pass new "compat includes" path via AC_SUBST.
    
    This fixes the build when the directory path containing a space.
    Found by Sevan Janiyan, tested by Job Snijders.  This doesn't fix
    "make tests", however that is a different, pre-existing problem
    that needs to be addressed separately.

commit 5c50ddbe4deac83995edc1d014e9ba0d5efa18a6
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Oct 1 13:37:35 2025 +1000

    Remove compat "include" dir during distclean.

commit aceabd62ce5833716dd2e99d4be4fcb603d263cc
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Oct 1 00:33:37 2025 +0000

    upstream: Set keys to NULL after freeing in tests where the
    
    variables will be used again.  Should prevent Coverity "potential use after
    free" warnings.
    
    OpenBSD-Regress-ID: 24d141657d25977e41dfb0c58e9b74ab093972bf

commit eb30a0d1493a97b5c14728846576dc6af5d442da
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Oct 1 00:30:19 2025 +0000

    upstream: Get rid of utf8 droppings in commment since it confuses
    
    older shells. From Sevan Janiyan via openssh-unix-dev.
    
    OpenBSD-Regress-ID: 67c11a5cff6ef23538c77e9b29d538e175e6cfe3

commit d478e250230e917eeb5032238df0b9af357404ee
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Oct 1 12:17:54 2025 +1000

    Update OpenSSL & LibreSSL versions we test against.

commit 2c504a74ed81d13c8198a89ed1040d0fc5f73129
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 30 00:10:42 2025 +0000

    upstream: during sftp uploads, avoid a condition where a failed write
    
    could be ignored if a subsequent write succeeded.
    
    This is unlikely but technically possible because sftp servers are
    allowed to reorder requests.
    
    Reported by Graziano Stefani, ok tb@
    
    OpenBSD-Commit-ID: 03904bce2c7f787223d01d7e1179fde15753eca3

commit 1f7556753869654ba5e2bf61e384c5da2db5ca6a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 30 00:06:06 2025 +0000

    upstream: avoid a fatal() when sftp tab-completes filenames that
    
    share common utf-8 characters that don't encode to a complete codepoint
    
    from menthu.zhou via GHPR#587; ok dtucker@
    
    OpenBSD-Commit-ID: e07e4d8a8cac032ab536570b8214e6ef6839b585

commit 42b14ff1e06fd683c7d15a6b2816c16108873a5a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 30 00:03:09 2025 +0000

    upstream: fix memory leak in mux_client_request_stdio_fwd GHPR#575
    
    by Boris Tonofa; ok dtucker
    
    OpenBSD-Commit-ID: 410cdd05242304bd0196b9172ce5fcaf89d2d8ce

commit e5055ef26abcffd3f99669e411ea6b35ca166111
Author: Allison Karlitskaya <allison.karlitskaya@redhat.com>
Date:   Wed Sep 3 20:07:55 2025 +0200

    Don't log audit messages with UNKNOWN hostname
    
    The `host` parameter to audit_log_acct_message() is documented as
    follows:
    
          host - The hostname if known. If not available pass a NULL.
    
    but we pass the string "UNKNOWN" in case we don't know the hostname.
    Make sure we pass NULL instead.
    
    This avoids having the audit system attempt to perform a DNS lookup on
    the hostname "UNKNOWN", which tends to result in long delays when
    attempting to login.

commit d343df4019b4369ce7f87e9bf6bbc80b81cd263d
Author: zhangjun <zhangjun-tc@dfmc.com.cn>
Date:   Fri Aug 22 16:49:07 2025 +0800

    ensure struct passwd fields are non-NULL in pwcopy
    
    Android libc can return NULL pw_gecos, for example.

commit 893a579e4b37e6bd89d206dc8e7ac2a906ccf114
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Sep 29 21:37:52 2025 +0000

    upstream: Add explicit check for array overflow.
    
    The array is bounded by a NULL sentinel which already prevents this,
    however since we check the bit vector for overflow Coverity assumes that
    check is for the devices array and flags it as a potential overflow.
    Adding this additional check on the array placates CID 896018.  ok djm@
    deraadt@
    
    OpenBSD-Commit-ID: e92fff41341b38e4206a70655cc9acaaa032ebee

commit 90f49a185ac1a786d9f7e9a710b369afb3692a65
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Sep 29 21:30:15 2025 +0000

    upstream: Move ifdef to start of file. Removes diff vs portable.
    
    OpenBSD-Commit-ID: 55058ac3d477e4c696575039f5b275522b99ffea

commit 2f71b44d48dc8da7fb743d6ffe609aea5a645edb
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Sep 29 21:29:22 2025 +0000

    upstream: Include misc.h. Removes diff vs portable.
    
    OpenBSD-Commit-ID: 8aa48451fe5c37f04a339450c4ed9cfb8f4c288f

commit dfb991bdd826517bbce1cf62ce07bcb3e48a2f27
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Sep 29 21:28:33 2025 +0000

    upstream: Sort headers as per KNF. Removes diff vs portable.
    
    OpenBSD-Commit-ID: 55f5b9eaeb826a25cfb506a78136094275a71bcb

commit c82f4dd6b723a8365b4c538d7c99fe8e46985ed0
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Sep 29 07:40:55 2025 +0000

    upstream: Null out keys after freeing in tests in the case where we
    
    potentially reuse the variable.  Fixes Coverity CID 405057.
    
    OpenBSD-Regress-ID: c52e86502b33bfa6e448448a74a0217dd519dd58

commit fda31e1e5179b4e70c27094ebb303ee47c11a5a7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 29 03:17:54 2025 +0000

    upstream: avoid spurious error message when loading certificates
    
    only bz3869
    
    OpenBSD-Commit-ID: e7848fec50d15cc142fed946aa8f79abef3c5be7

commit bcd88ded2fff97652d4236405a3354ca66f90f7e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 29 02:32:15 2025 +0000

    upstream: kbd-interactive device names should be matched against
    
    the full device name, not a prefix. Doesn't matter in practice as there is
    only one kbd-int device supported (PAM xor BSD auth), and an attacker would
    still need to successfully authenticate against an incorrectly-selected
    device.
    
    reported by ashamedbit, NobleMathews; ok deraadt@
    
    OpenBSD-Commit-ID: cf75d4f99405fbb41354c4ae724a3b39a3b58f82

commit b1c4bf5c2f1c2b30698dbaadc5d823862213f1fc
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Thu Sep 25 12:52:21 2025 +0000

    upstream: avoid use-after-free in update_krl_from_file() found with
    
    clang scan-build, ok dtucker@
    
    OpenBSD-Commit-ID: 8ec86eca573740c94d5bc7e252959174555f4eb8

commit b06a150bc903a0cf898406384d5a34059d0f2d8f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Sep 27 20:20:34 2025 +1000

    Stop testing OpenBSD ubsan until fixed upstream.

commit 97b32fa2af25c16aec4de85c5cbb63fd038b4dfa
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 26 04:40:45 2025 +0000

    upstream: Use $OBJ for temp file in maxstartups idempotence test.
    
    Fixes test in -portable when run out-of-tree.
    
    OpenBSD-Regress-ID: 8578be08238af4abe2dc91af1c199f7f71f1a7a2

commit b4ceca952b85752958d849508294afdc56dfcb9f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 26 22:28:13 2025 +1000

    Shorten workflow names to fit in a single line.

commit 9824ec515ed6256c1a98d66049471053f965b75e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 26 22:26:33 2025 +1000

    Update link to oss-fuzz bug tracker.
    
    Remove 9.8 branch.

commit 37d996bd0537837f15fc540d5aebb1ef2faf2268
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Sep 25 22:17:29 2025 +0000

    upstream: Check return codes of sshbuf functions.
    
    Fixes Coverity CIDs 405059 and 405061.
    
    OpenBSD-Regress-ID: defa55d32892172251bbd5efd15731ce55888247

commit 6c3c9f03c3c2cc4e40decbb49b8486abfb9e57df
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 26 08:23:21 2025 +1000

    Replace hand-rolled modulo with arc4random_uniform.
    
    Fixes potential modulo-by-zero UB flagged by Coverity CID 405068

commit e914e61eb88e22e5b725c399698256c54589ca32
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Sep 25 17:50:07 2025 +1000

    Remove status bits from OpenSSL >=3 version check.
    
    OpenSSL traditionally did not guarantee ABI compatibility across release
    (and development) versions.  Because of this, OpenSSH checked the lower 4
    "status" bits returned by OpenSSL_version_num(), which were originally
    set to 0 for development versions and 0xf for release versions and, if
    they did not match, would report the discrepancy and exit.
    
    OpenSSL (unintentionally) changed these bits in the 3.0.0 and subsequent
    3.x releases, setting them to zero in the release versions (which happened
    to also match the documentation), then changed them back in the 3.5.3
    release.  If OpenSSL was upgraded to (or from) this version without
    recompiling OpenSSH, it would cause OpenSSH flag it as potentially
    incompatible and refuse to use it.  Ultimately OpenSSL rolled this
    back, but the check now has no value so is being removed for OpenSSL
    versions >=3.
    
    bz#3865 and https://github.com/openssl/openssl/issues/28575, ok djm@

commit 35f3e2a41c2afe7a68a8a4efb3eb385e7f8d247d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Sep 25 18:06:55 2025 +1000

    Update pledge() interface to match current OpenBSD.
    
    ok djm@

commit 7ce3823547578a3b083085744c1fea39237197a2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 23 22:12:19 2025 +1000

    Merge all putty tests into a single test.
    
    The lets us reuse the built OpenSSH binaries and replaces 12*4min of
    tests with a single 14min one.

commit 1362f6c0f4ca3306a201a6572bb9ec0d47d8edb3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Sep 25 18:20:53 2025 +1000

    Add #ifdefs in pwfree to match those in pwcopy.
    
    Fixes build on many platforms.

commit 8235dc3d82c0ac347a3600df0907c6573720fbaa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 07:05:11 2025 +0000

    upstream: fix some one-off leaks in ssh.c; ok dtucker@
    
    OpenBSD-Commit-ID: bf3c27ffe4b3cccb6553b554ec4c04929065a2bc

commit 846987d1233f24bbe87ebed347e328f45525388a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 07:04:38 2025 +0000

    upstream: fix some one-off leaks in ssh-keygen; ok dtucker@
    
    OpenBSD-Commit-ID: 32f51289c93246474659aa49067926fcab9e02e8

commit a1a7df8b3694fdd7b55ad6bb8fa7b3d5d7f5b89a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 07:00:43 2025 +0000

    upstream: fix some leaks in ssh-add; feedback/ok dtucker@
    
    OpenBSD-Commit-ID: 441302917de31a128c1d6d63acccc67042fcf349

commit a8a2702bcd9e81a086e6d2c278f1b62f9d8bf3a1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 06:57:54 2025 +0000

    upstream: fix some leaks; feedback/ok dtucker@
    
    OpenBSD-Commit-ID: 05bdbc2e494b87a4a79e509020bd8249c86a4ff0

commit a071af0682d686de85cf471f5e04deaee4d90adb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 06:45:50 2025 +0000

    upstream: wait for the unprivileged sshd-auth process to exit
    
    before closing the fd it uses to report log messages
    
    This avoids a race where the child process notices the
    fd was closed before exiting and spams the logs.
    
    ok dtucker@
    
    OpenBSD-Commit-ID: 7cddaa41be3b955e6bed570900db7ab8817b1e76

commit 4fddebe7f524b3403c876c3b399d5ce7ce3390a6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 06:33:19 2025 +0000

    upstream: add some functions to free various structs, including
    
    channels data and packet state; ok dtucker@ tb@
    
    OpenBSD-Commit-ID: a8b3705309d632cdae370d4147a03e703087b0d1

commit d0c1e73d408a24b2db18c0aa1a0108bea0f24210
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 06:31:42 2025 +0000

    upstream: fix leaks of config objects in
    
    mm_decode_activate_server_options ok dtucker@ tb@
    
    OpenBSD-Commit-ID: 211f4d7d02e847bd1bcb460f6beb11658809a742

commit b62aa85dcbc8f03bf91d26d14fbf8fd5e172d882
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 25 06:25:38 2025 +0000

    upstream: clarify intent and avoid (harmess, defined behaviour)
    
    unsigned underflow. ok tb@
    
    OpenBSD-Commit-ID: b73bf5f1f381c3e4561a6cc706fb1cd77c939cd8

commit 6f28a935cc7d073e6647643e81d98b5831df204f
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Thu Sep 25 06:23:19 2025 +0000

    upstream: consistently use NULL for null pointer constants found
    
    with sparse, ok djm@
    
    OpenBSD-Commit-ID: 1067504b63732d809d0d57ad4bc626818d112772

commit 0af7e5b690e2cfe8824f04f154b0e543509dbefd
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Thu Sep 25 02:15:39 2025 +0000

    upstream: remove unneeded externs ok djm@
    
    OpenBSD-Commit-ID: fe553193e910a122505142a4e1db7358cc1ae653

commit ae62a16118bb96a8e449ef25f5e55ef86a52cefb
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Thu Sep 25 02:12:16 2025 +0000

    upstream: remove prototype for removed ssh_packet_set_tos() ok
    
    djm@
    
    OpenBSD-Commit-ID: 396f82995074ef4d7b9ce44168266ef4640d9985

commit d8588478850463f8945aa18d0358b2b227f8b57a
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Wed Sep 24 00:51:28 2025 +0000

    upstream: spelling; ok dtucker@
    
    OpenBSD-Commit-ID: 93870117b0153859dd8baa80b97e44d4558c786b

commit eff358890a7cab1e7c2fec62e5b9914d2c1c8703
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 23 16:51:34 2025 +1000

    Merge VM tests into a single workflow file.
    
    Should make it easier to manage, although it may cause a few extra runs.

commit d00015d21190517a1f505eb8120f716b1c2e4055
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 23 16:38:45 2025 +1000

    Test openssl-3.6 branch not beta1.

commit 31fce4fc5aaf79b9a4bccf09467e86c56b482bde
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 23 15:51:14 2025 +1000

    Test openssl-3.6.0-beta1.

commit b94e7251a17a497669e825cb70ac79c96bdc3472
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 23 11:32:57 2025 +1000

    Specify rpath when building OpenSSL.

commit 83853aa5e35f3da0690bccd2983764d4e749a670
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Sep 22 15:26:17 2025 +1000

    Factor out OpenSSL install and test more versions.
    
    Move OpenSSL installation into its own script with a "-a" option to
    install the "next" version to test for ABI compatibility.

commit 2c1d38f7ffc8b8ec244bfe17ec8a85b3d737dcab
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Sep 22 16:55:49 2025 +1000

    Exclude generated openbsd-compat/include directory.

commit 67b3ed101a18348b564507f55e3ed4b7e0d23ff9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Sep 20 15:07:36 2025 +1000

    Add OpenSSL 3.x ABI cross-compatibility test.

commit c682c9f45a10ee0dc37fd716cfccd42271f92ddc
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Sep 20 15:05:19 2025 +1000

    Add tests for OpenSSL 3.4 and 3.5 versions.

commit 1659d0ac095608b809fd3173d2c48b7b39d40b02
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Sep 20 15:53:04 2025 +1000

    Build OpenSSL with -j4 to speed it up.

commit ca9ac1109e2c875ea33da6818c1841aa2181e962
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Sep 20 15:16:30 2025 +1000

    Rerun tests if run_tests.sh changes.

commit bc328144f149af07139a0f2c1329018cd85b86b7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Sep 19 01:32:45 2025 +0000

    upstream: log at level INFO when PerSourcePenalties actually blocks
    
    access to a source address range. Previously this was logged at level
    VERBOSE, which hid enforcement actions under default config settings.
    
    ok dtucker, markus
    
    OpenBSD-Commit-ID: ea2b0d7c2253ff5205719d74b526cf2870df894d

commit 80993390bed15bbd1c348f3352e55d0db01ca0fd
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Sep 17 17:41:41 2025 +1000

    Whitespace.

commit fc704057ce6b75637645a4b9c917565b3563e21b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Sep 17 17:33:25 2025 +1000

    Move Gihub VMs to their own status line.

commit 2202e5f9008003044cac01ed70d83deec42ad4e0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 16 23:00:14 2025 +1000

    Use relative URLs for status

commit 7c32e09ea3e5c7e1fa0b7e2d4ddc83f8beadafed
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Sep 15 17:21:15 2025 +1000

    Add VM test targets via vmaction on Github.

commit a4aa090a3d40dddb07d5ebebc501f6457541a501
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 03:00:22 2025 +0000

    upstream: memory leaks in unit tests
    
    OpenBSD-Regress-ID: af11ac7b8034b99ca324af4dae1ef5cd7700b273

commit 6f5942454ad6756355f3b4983ab882cf15e44440
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 05:17:37 2025 +0000

    upstream: fix leaks of struct sftp_conn in scp; ok dtucker@
    
    OpenBSD-Commit-ID: 76bea50b5b87b750c3771bf80feb6067d994a9d2

commit 52f38c76fcb38dfe619d8caa3bb4bb782c785026
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:52:41 2025 +0000

    upstream: leak of principals file lines; ok dtucker@
    
    OpenBSD-Commit-ID: 918bf1b70e5a969059300f3c23d45911690d9015

commit b9464cee0fd084d89d91696a17b3621b4cf512bf
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:52:12 2025 +0000

    upstream: leak of authentication options at exit; ok dtucker@
    
    OpenBSD-Commit-ID: ba559799c2ff9b10afc3abefb1797c0843a6ff24

commit 0bb37080c86674de7cdfb56c80add3cd316c68a8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:51:35 2025 +0000

    upstream: memleak of keys not used for authentication; ok
    
    dtucker@
    
    OpenBSD-Commit-ID: ddfda79d243150fbd382d8f2cd75a90a072b3669

commit ee99f6e93e0ee90eedbd27ffb9b7f9fef7b98010
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:50:42 2025 +0000

    upstream: memleak of certificate path; ok dtucker@
    
    OpenBSD-Commit-ID: 90dc5390f2756ba339e2e6df54d4b8651d64c1e7

commit 42fc6b6f9fbf58293b070f4de377c7695c275a8a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:49:41 2025 +0000

    upstream: memleak of hostkey when downgrading host cert->key; ok
    
    dtucker
    
    OpenBSD-Commit-ID: f6f1f38a8ec144fb615434f6877066cf4610b826

commit bc60bd55cbc1f8139c840668733b51475cbefd93
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:49:00 2025 +0000

    upstream: memleak of editline history; ok dtucker@
    
    OpenBSD-Commit-ID: a244c54eb074cf7fbe28f7ac4f03ace270f7a999

commit ee77ab9b2ca2d70daf8d4352f5daffa8036ece64
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:48:29 2025 +0000

    upstream: memleak of rfwd callback context; ok dtucker@
    
    OpenBSD-Commit-ID: 70b2aafeaace90703dd16a44a2a0b723d9155f33

commit 0088b3f0ab2c615ae95b9f374963abaa0ab837ec
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:47:49 2025 +0000

    upstream: memleaks of request packet and hostkeys blob; ok
    
    dtucker@
    
    OpenBSD-Commit-ID: 313b13a8e36b4ca8e064ee56792e67e0670a386a

commit d68451a25808c4eee74b898873cd4761f73651ed
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:41:20 2025 +0000

    upstream: memleak of KRL revoked certs struct; ok dtucker
    
    OpenBSD-Commit-ID: f319868e0b2de49c41c735e75b87c403f009f5f9

commit 67940cc2f329427d3acb64d4893faf4527e58d5c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:40:34 2025 +0000

    upstream: memleak of kex->server_sig_algs; ok dtucker@
    
    OpenBSD-Commit-ID: 41a3f64edd2c9b8addb2e445514ae25c24819e2c

commit fae8e41741d23298c94a1ea3ef8704a1cc186cb5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:39:58 2025 +0000

    upstream: fix memleak of channel forwarding permissions; ok
    
    dtucker@
    
    OpenBSD-Commit-ID: 069745547109bc8fcc09fab5b19c53599cae99fd

commit 03872018c14ed943bc01a4e88be59195a742f106
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:39:15 2025 +0000

    upstream: when merging auth options into the active set, don't
    
    leak the old struct sshauthopt; ok dtucker@
    
    OpenBSD-Commit-ID: c6bfd7bc2932e37f811b3c53272c3b919d33e75b

commit efed5da4ced88170cf474246eff771dd16c7092f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 15 04:38:00 2025 +0000

    upstream: fix memleak when applying certificate options; ok
    
    dtucker
    
    OpenBSD-Commit-ID: 36c219dcc05f4df82a0f9c500bdf5dbfea925289

commit edc601707b583a2c900e49621e048c26574edd3a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 11 07:23:32 2025 +0000

    upstream: disable ssh-add autoexpiry of certificates when testing
    
    expired certificates
    
    OpenBSD-Regress-ID: 64aadd23d37fd0b3a06498151f2cf83be7ac342c

commit c60153e4878f3a6700af69adbdd1863003e78abf
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 11 07:22:37 2025 +0000

    upstream: correct getopt() string
    
    OpenBSD-Commit-ID: 05ef9581a3dab32ec93aa5b9c3349ed1e7da9ec8

commit 7a4738af45201c115a9e20f830f30ed38ce6be76
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 11 03:29:58 2025 +0000

    upstream: need time.h for time(3)
    
    OpenBSD-Commit-ID: 530964039cccab679432b6c5b28d2b0aa9760b00

commit 0c719c6aabc061f02a907fc96c390d0449b49f26
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 11 02:54:42 2025 +0000

    upstream: When adding certificates to an agent, set the expiry to
    
    the certificate expiry time plus a short (5 min) grace period.
    
    This will cause the agent to automtically remove certificates shortly
    after they expire.
    
    A new ssh-add -N option disables this behaviour.
    
    Feedback/ok deraadt@
    
    OpenBSD-Commit-ID: 92fed1bba1025069ad45deebb534be7530e181df

commit e9dcccc3541b0ae1c43581ed26215d5cc82e4be0
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Mon Sep 8 00:31:54 2025 +0000

    upstream: remove unused 0-sized files; ok deraadt@
    
    OpenBSD-Commit-ID: 7e8178786157e863f6ff63c5d55200d7b6b04f9e

commit d16b1b484a024ee6b35094e7d9d55bf96b96253b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 10:34:35 2025 +0000

    upstream: Tabs->spaces. Removes diff vs portable.
    
    OpenBSD-Commit-ID: 06598021a9f08188dab29ac956b2baa002a0ff85

commit 3d8ae7f235b96da604b08c44ae83420e367eeab4
Author: Tim Rice <tim@multitalents.net>
Date:   Mon Sep 8 12:53:10 2025 -0700

            modified:   regress/rekey.sh
            Fix for when building out of tree.

commit 54abadd3f286efea0dbbdbfea8011d5e1e30c074
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Sep 7 13:35:22 2025 +1000

    Accept OpenSSL 4.0.0-dev versions.
    
    They seem to work, at least for now.

commit 67a8bf4e4057597170bfa923fe2ce5bf90c43974
Author: Maxim Khon <fjoe@samodelkin.net>
Date:   Mon Aug 18 12:05:42 2025 +0000

    Use SSH_TUN_COMPAT_AF on FreeBSD.
    
    Otherwise tun forwarding from other OSes fails as soon as the first IPv6
    message is sent by the other side (which is usually a Router Solicitation
    ICMPv6 message which is sent as soon as the interface is up): all other
    OS'es use SSH_TUN_COMPAT_AF or SSH_TUN_PREPEND_AF which effectively uses
    OpenBSD AF_INET/AF_INET6 values.

commit 3ca274e44cb2c2351376fc14e4c3e92ba4a8f87b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 21:32:30 2025 +1000

    Check for nlist function.
    
    Check for nlist function presence before attenmpting to use it instead
    of relying on the presence of the nlist.h header.  Mac OS X, in particular
    has the header, but only has the function in the 32bit libraries.

commit ee32a36c62424f13907023595bfa8b23a528ced1
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 10:23:55 2025 +0000

    upstream: Order includes as per KNF and add time.h. Removes diff
    
    vs portable.
    
    OpenBSD-Commit-ID: 38043f0bfa17c48ef6d1a744c2834b4405bc9311

commit 0ac179c9540e2b05b4c1194db69ce01306c253d3
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 10:17:21 2025 +0000

    upstream: Order headers as per KNF. Removes diff vs portable.
    
    OpenBSD-Commit-ID: 4df519fd9fa13ce9653adf7a3d1076e20591d886

commit e80322284f3ee70b6b760a9f83179470d675e5ba
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 10:01:35 2025 +0000

    upstream: Order headers as per KNF.
    
    OpenBSD-Commit-ID: 7156b69b0364c68e181e0f6fa17c0f05c72e8670

commit bb8ac0515e68cab63db2d026eb60127185a3d2b8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 20:39:16 2025 +1000

    Resync header order with upstream.

commit 024b694249482698b0c73d24da0eaec696fca8c8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 20:37:04 2025 +1000

    Resync header order with upstream.

commit aed6a958bc108faab64bc2855d6ed93894cfc6ff
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 20:30:20 2025 +1000

    Sync includes with upstream.

commit 22cfd2dd32f34f0cea218dd651f3aa9544b6e3b5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 20:26:14 2025 +1000

    Move ssh-pkcs11.h include to match upstream.

commit b34c16bc4cac2962cc6a7517efbc4fed2c8a2d9a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 20:20:27 2025 +1000

    Reorder includes to match upstream.

commit 441a8fa9a0178704bce497bff92ca43fcf04bf7a
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 09:58:08 2025 +0000

    upstream: Order headers as per KNF. Removes diff vs portable.
    
    OpenBSD-Commit-ID: db72be57429418f6a4319bbe34c98fc103e11ce0

commit 19d6a7afb256c4afc571dbf56a013ef91cd9596f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 09:49:26 2025 +0000

    upstream: Order headers as per KNF. Also removes diff vs
    
    -portable.
    
    OpenBSD-Commit-ID: 2061307dc938712e524bc9da48a52f545e43670e

commit 932e9f200bd48b7568eb21ec456c67ec92d517e2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Sep 5 09:31:31 2025 +0000

    upstream: Remove unused rmd160.h header. ripemd160 support was
    
    removed in 2017.
    
    OpenBSD-Commit-ID: 937fca21498b921adf6e04bac120f4a2e7975b3c

commit f93de828b9b0f29bff51d38ea92d0759595ec30b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 20:07:16 2025 +1000

    Create replacement nlist.h if needed.
    
    Remove #ifdef HAVE_NLIST_H wrapper.  ok djm@

commit 6aac2beaa53467e83f6a137376b6dcf423ab6f6c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 19:55:20 2025 +1000

    Create replacement endian.h if needed.
    
    Remove #ifdef HAVE_ENDIAN_H wrapper.  ok djm@

commit a60721c894f0a2ce973876d0f55617e187e6fab1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 19:52:48 2025 +1000

    Add /* WITH_OPENSSL */ comments.
    
    Removes diffs vs upstream.

commit c729a833298d9d55ffb22771cf1400dfdc640164
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 19:22:37 2025 +1000

    Move sys/time.h include to match upstream.

commit caa973dd06a7be43c29353b256c9a473f5ad9882
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 19:13:52 2025 +1000

    Create replacement netgroup.h if needed.
    
    Remove #ifdef HAVE_NETGROUP_H wrapper.  ok djm@

commit 7d30526b7df14d960a5de63d6af823ffdab86518
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 18:24:59 2025 +1000

    Remove stray #endif left from previous.

commit 4911f2600fdbb1959311bb1886bfe51f7dd4a74e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 18:08:51 2025 +1000

    Create replacement libgen.h if needed.
    
    Remove #ifdef HAVE_LIBGEN_H wrapper.  ok djm@

commit 65dcdb56f5daee519ec824ae17e64412d2492f90
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 18:05:15 2025 +1000

    Create replacement sys/un.h if needed.
    
    Remove #ifdef HAVE_SYS_UN_H wrapper.  ok djm@

commit 60334af5a908ac3b263d2ec696f9977e20b739cb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 18:03:55 2025 +1000

    Reformat replacement header check one per line.

commit cd9ba068e36b0f37374d2eba2d19dacc7ea9a167
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:55:33 2025 +1000

    Create replacement time.h if needed.
    
    Remove #ifdef HAVE_TIME_H wrapper.  ok djm@

commit ea586edbcbec7089f768ed682a79a399eaa1e5b1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:50:18 2025 +1000

    Create replacement sys/stat.h if needed.
    
    Remove #ifdef HAVE_SYS_STAT_H wrapper.  ok djm@

commit 59b80707c6cf45230597a800e7d2ce6b00ce35b5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:44:07 2025 +1000

    Create replacement sys/time.h if needed.
    
    Remove #ifdef HAVE_SYS_TIME_H wrapper.  ok djm@

commit 82fed5110fe09e9af258a8f5a2f92ffb397fff5b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:31:15 2025 +1000

    Create replacement ifaddrs.h if needed.
    
    Remove #ifdef HAVE_IFADDRS_H wrapper.  ok djm@

commit 53887d8ebc583b51e996cb2bdeb11e054d36343b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:27:43 2025 +1000

    Create replacement util.h if needed.
    
    Remove #ifdef HAVE_UTIL_H wrapper.  ok djm@

commit 5f09983d1e724097bd577097fb0f2c00c2436f21
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:24:50 2025 +1000

    Create replacement paths.h if needed.
    
    Remove #ifdef HAVE_PATHS_H wrapper.  ok djm@

commit d45b17dc5a0598dda2b11dc89598203408d2d59c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:17:52 2025 +1000

    Create replacement poll.h if needed.
    
    Remove #ifdef HAVE_POLL_H wrapper.  ok djm@

commit 9b2c5a2db0650e394597839ef00d797f57568937
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 5 17:06:14 2025 +1000

    Fill in missing system header files.
    
    Create replacement header files inside openbsd-compat for common headers
    that are missing on a given platform.  Usually these are just empty,
    but in some cases they'll include the equivalent file.  This avoids
    having to wrap those includes in '#ifdef HAVE_FOO_H' and reduces the
    diff vs OpenBSD.
    
    If we create any such headers, add the path to includes.
    
    Initially just stdint.h, more to follow.
    
    ok djm@

commit f64701ca25795548a61614d0b13391d6dfa7f38c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 03:04:44 2025 +0000

    upstream: repair test after changes to percent expansion of usernames
    
    on the commandline.
    
    Test more cases that should/shouldn't expand and lightly test
    username validity checks.
    
    OpenBSD-Regress-ID: ad4c12c70bdf1f959abfebd1637ecff1b49a484c

commit 45698669d49949868b1f3d13dfda1b7cb70060ad
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 00:37:10 2025 +0000

    upstream: unit tests for sshbuf_equals and sshbuf_dtourlb64; ok
    
    deraadt@
    
    OpenBSD-Regress-ID: bab54e2d4caa813036a63ee67e92c93e6712a5b9

commit 4be445116f1b56f14254b98d8b132bb25777e160
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 00:34:17 2025 +0000

    upstream: unit tests for a bunch of misc.c functions; ok deraadt@
    
    OpenBSD-Regress-ID: 886cf142605405e777ee77a96b48694dc2e9235d

commit e3699ff47df336f57da2e78188d0057f8368af56
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 00:32:31 2025 +0000

    upstream: fix sshbuf_dtourlb64() to not choke on empty buffers;
    
    previously it incorrectly returned an error in this situation; ok deraadt
    
    OpenBSD-Commit-ID: e62773d6e8cb95a19aab54f0af0edbcd47b345c0

commit 8e85ad33cfcc71e03594e53f2e19d8ce2e27dcc6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 00:31:49 2025 +0000

    upstream: fix rtrim() function to not attempt to delete whitespace
    
    inside a string, just at the end. ok deraadt@
    
    OpenBSD-Commit-ID: d44deaa43580cd88de978dd5509b14e905b67b84

commit 43b3bff47bb029f2299bacb6a36057981b39fdb0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 00:30:06 2025 +0000

    upstream: don't allow \0 characters in url-encoded strings.
    
    Suggested by David Leadbeater, ok deraadt@
    
    OpenBSD-Commit-ID: c92196cef0f970ceabc1e8007a80b01e9b7cd49c

commit 35d5917652106aede47621bb3f64044604164043
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 4 00:29:09 2025 +0000

    upstream: Improve rules for %-expansion of username.
    
    Usernames passed on the commandline will no longer be subject to
    % expansion. Some tools invoke ssh with connection information
    (i.e. usernames and host names) supplied from untrusted sources.
    These may contain % expansion sequences which could yield
    unexpected results.
    
    Since openssh-9.6, all usernames have been subject to validity
    checking. This change tightens the validity checks by refusing
    usernames that include control characters (again, these can cause
    surprises when supplied adversarially).
    
    This change also relaxes the validity checks in one small way:
    usernames supplied via the configuration file as literals (i.e.
    include no % expansion characters) are not subject to these
    validity checks. This allows usernames that contain arbitrary
    characters to be used, but only via configuration files. This
    is done on the basis that ssh's configuration is trusted.
    
    Pointed out by David Leadbeater, ok deraadt@
    
    OpenBSD-Commit-ID: e2f0c871fbe664aba30607321575e7c7fc798362

commit f38a552dc71f20df2544338099e3fe2563f1a9ca
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Sep 3 09:42:39 2025 +1000

    missing header

commit cc4eb3d6943cb57e08ab3abbcf92644deb429e46
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 11:08:34 2025 +0000

    upstream: simplify algorithm list functions using xextendf(); ok
    
    dtucker@
    
    OpenBSD-Commit-ID: ffc5f8d0c25b95705a8a66c8b634f98d23bd92dc

commit 8866d24cdd1d6e73bb3220b753f94e255c49ff96
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 11:04:58 2025 +0000

    upstream: unit test for xextendf()
    
    OpenBSD-Regress-ID: ddb3b4db1a52dda23696b967470882fe2b9c3af7

commit 2f369d3fd0ff3715c2b32dff5cb35c0330272445
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 09:41:23 2025 +0000

    upstream: fix comment on sshbuf_froms() - it *returns* an error
    
    code, the allocated buffer is passed via argument
    
    OpenBSD-Commit-ID: b2b0a76df71328f39c3e2ad941a4d87085d8335d

commit 6fd93060bb2ec35a7f0bf96d1a74104bab49e017
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 09:40:19 2025 +0000

    upstream: GssStrictAcceptor was missing from sshd -T output; fix
    
    OpenBSD-Commit-ID: 6014049ccfedc48a208e37d5488ade6bdc2d1c44

commit d94a9a8c54e9036961c1100c6f445c50ab9b6b40
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Sep 2 19:38:39 2025 +1000

    portable-specific comment grammer/spelling fixes

commit a0b095fa03d3c08d723a803ce25540fddd955c53
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 09:34:48 2025 +0000

    upstream: grammar and typos in comments
    
    OpenBSD-Commit-ID: de954daffcd0147ce142d55e8a374810cd19d7ed

commit 23a2bb750547a9a5251cbc44c5ceb1d05303befe
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Sep 2 19:30:07 2025 +1000

    replace remaining manual logging of __func__
    
    Use the appropriate log macro that prepends the function name
    (e.g. logit_f/debug2_f/etc).

commit a9b0b69f15e63bc4e8c8b38e24ee85ea076a7e11
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 09:26:21 2025 +0000

    upstream: replace remaining cases where we manually included __func__
    
    in a debug or error log with the respective *_f log variant
    
    OpenBSD-Commit-ID: 46a280d78bcc0bc98f28e65a30b613366600328f

commit 19f7cb39eecb4b8f768f37e8294dc3a9142e022b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 1 23:55:29 2025 +0000

    upstream: test MaxStatups idempotency; ok dtucker@
    
    OpenBSD-Regress-ID: b5d713c2709000fa5e41d82c0cf8627e13cb43f9

commit c357c4a1e626feba9a968b5f0cb832b989b2d433
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 21 05:55:30 2025 +0000

    upstream: benchmark more diffie-hellman-group* KEXs
    
    use current KEX names, i.e. remove the "@openssh.com" where the KEX
    has been standardised
    
    OpenBSD-Regress-ID: a67e9da4efd9a971d39cb2481093f836046f9b7f

commit 9313233a735733821dfd170b70782fb7da492962
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 2 01:03:43 2025 +0000

    upstream: fix previous
    
    OpenBSD-Commit-ID: 09d95dfb5e064a1d0e74afba8d77474cc1d110a4

commit 683d0abe596b069a896f1688f86256f1beeb0cdc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 1 23:53:16 2025 +0000

    upstream: Make MaxStartups and PerSourceNetBlockSize first-match-wins
    
    as advertised. bz3859 reported by jan.v.hofmann; ok dtucker
    
    OpenBSD-Commit-ID: 08f7786f1b3b4a05a106cdbd2dc5f1f2d8299447

commit a9a3f025d76f06a6601e6e8d52b468ec467865d9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Aug 29 03:50:38 2025 +0000

    upstream: remove experimental support for XMSS keys;
    
    ok deraadt markus
    
    OpenBSD-Commit-ID: 38eaf4df6189acad9e46eddf7cf32d7f6d07df35

commit 908e9d55139bed19ed87d6fec749974eb42702c6
Author: caspar@openbsd.org <caspar@openbsd.org>
Date:   Mon Aug 18 18:39:33 2025 +0000

    upstream: ssh_config.5: say "post-quantum" instead of "post quantum
    
    safe", and rephrase the sentence to make it easier to read.
    
    Input djm@, input and OK deraadt@, OK dtucker@
    
    OpenBSD-Commit-ID: c3ee4d1cafdcfc20cc0d2f086021efce4b19c075

commit ceca966bde4ab38b2434876416da12fe16747459
Author: job@openbsd.org <job@openbsd.org>
Date:   Mon Aug 18 09:16:36 2025 +0000

    upstream: Delete unused accessor function
    
    OK dtucker@
    
    OpenBSD-Commit-ID: 93b59ac088fb254e1189729ece5bb9656d6e810b

commit 3ef1a87d0a29eac94f32371af628e81eb2e2d817
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 17:00:26 2025 +1000

    Fix pledge(2) special casing
    
    Unbreaks non-OpenBSD platforms

commit 5e9ca80fe65e407428dc46ed45804724d08b91b7
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 16:47:23 2025 +1000

    Match version instead of groups in connect-bigconf
    
    The connect-bigconf makes a giant config file to test config passing
    between the sshd subprocesses. Previously it used a bunch of "Match
    group" lines to construct a large file. However checking group
    membership can be expensive (e.g. if a large groups database is
    present or if group lookup is remote via NSS). This could be slow
    enough to exceed LoginGraceTime.
    
    This switches it to "Match version" which is just a string compare
    and does just as well for making a giant nonsense config file.

commit 6c84609e5f9ddd49e250d5cf190b2820dbeca178
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 16:47:00 2025 +1000

    depend

commit 9184fa363687fcb5dac056b093fb3b8e9d327242
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 16:45:15 2025 +1000

    check for setsockopt IP_TOS in OpenBSD pledge
    
    OpenBSD has recently relaxed the pledge(2) sandbox to allow some
    setsockopt options to be changed without the "inet" promise.
    
    This adds compatibility for OpenBSD that predates this relaxation.

commit ae44cd74f3a4ac711152f50b2712803ccf785593
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 04:50:35 2025 +0000

    upstream: cast
    
    OpenBSD-Commit-ID: d69bd2328513c2dcd99f4f346b77e2bd90cf1964

commit c2c8bae39380392449ac3297061cbfc486126ad5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 04:38:21 2025 +0000

    upstream: missing set_log_handler() call in ssh-auth.c, exposed after
    
    last commit
    
    OpenBSD-Commit-ID: 09f5c3cf33c18b8ad321edbf96c30ae3deada2b0

commit 056022261e6cf7eb65bbacac72afe5f4d5945f2c
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 14:22:32 2025 +1000

    depend

commit b7ee13fbbb4ebafcf71f29685f053ecb97d1bcef
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 14:22:18 2025 +1000

    wrap SIGINFO in ifdef

commit 289239046b2c4b0076c14394ae9703a879e78706
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 03:43:01 2025 +0000

    upstream: Make ssh(1) and sshd(8) set IP QoS (aka IP_TOS, IPV6_TCLASS)
    
    continually at runtime based on what sessions/channels are open.
    
    Previously, ssh(1) and sshd(8) would pick a QoS value when they
    were started and use it for the whole connection. This could
    produce suboptimal choices for the QoS value, e.g. for multiplexed
    sessions that started interactive but picked up a sftp client,
    or sessions that moved large amounts of data via port forwarding.
    
    Now the QoS value will change to the non-interactive IPQoS whenever
    a "non-interactive" channel is open; basically any channel that lacks
    a tty other than agent forwarding.
    
    This is important now that the default interactive IPQoS is EF
    (Expedited Forwarding), as many networks are configured to allow
    only relatively small amounts of traffic of this class and they will
    aggressively deprioritise the entire connection if this is exceeded.
    
    NB. because ssh(1) and sshd(8) now change IP_TOS/IPV6_TCLASS
    continually via setsockopt(), this commit requires a recent pledge(2)
    change that landed recently in the OpenBSD kernel. Please ensure
    you have updated to a kernel from within the last two weeks before
    updating OpenSSH.
    
    with job@ deraadt@
    
    OpenBSD-Commit-ID: 325fc41717eecdf5e4b534bfa8d66817425b840f

commit dc5147028ff19213a32281dad07bba02e58da3fa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 03:29:11 2025 +0000

    upstream: SIGINFO handler for sshd(8) to dump active
    
    channels/sessions ok deraadt@
    
    OpenBSD-Commit-ID: 9955cb6d157c6d7aa23a819e8ef61b1edabc8b7d

commit f807a598c96be683d97810481e954ec9db6b0027
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 03:28:36 2025 +0000

    upstream: SIGINFO handler for ssh(1) to dump active
    
    channels/sessions ok deraadt@
    
    OpenBSD-Commit-ID: 12f88a5044bca40ef5f41ff61b1755d0e25df901

commit 9b61679d73a8a001c25ab308db8a3162456010cf
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 03:28:02 2025 +0000

    upstream: add channel_report_open() to report (to logs) open
    
    channels; ok deraadt@ (as part of bigger diff)
    
    OpenBSD-Commit-ID: 7f691e25366c5621d7ed6f7f9018d868f7511c0d

commit 80b5ffd22abd4093201939e31d1ea6dc8cc7913a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 18 01:59:53 2025 +0000

    upstream: make -E a no-op in sshd-auth. Redirecting logging to a
    
    file doesn't work in this program as logging already goes via the parent
    sshd-session process. ok dtucker@
    
    OpenBSD-Commit-ID: 73325b9e69364117c18305f896c620a3abcf4f87

commit 3a039108bd25ff10047d7fa64750ed7df10c717c
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 13:46:37 2025 +1000

    allow some socket syscalls in seccomp sandbox
    
    Allow getsockname(2), getpeername(2) and getsockopt(2).
    
    Also allow setsockopt(2) but only IP_TOS and IPV6_TCLASS.
    
    Note that systems that use the older socketcall(2) mux syscall will
    not have IP_TOS and IPV6_TCLASS allowlisted. On these platforms,
    these calls will be soft-blocked (i.e. will fail rather than
    terminate the whole process with a sandbox violation).
    
    Needed for upcoming IPQoS change; ok dtucker@

commit a00f5b02e171bc6d6fb130050afb7a08f5ece1d8
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 18 13:44:53 2025 +1000

    handle futex_time64 properly in seccomp sandbox
    
    Previously we only allowed __NR_futex, but some 32-bit systems
    apparently support __NR_futex_time64. We had support for this
    in the sandbox, but because of a macro error only __NR_futex was
    allowlisted.
    
    ok dtucker@

commit 32deb00b38b4ee2b3302f261ea1e68c04e020a08
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Aug 14 10:03:44 2025 +0000

    upstream: Cast serial no for %lld to prevent compiler warnings on some
    
    platforms.
    
    OpenBSD-Commit-ID: afadd741622f16c6733d461c0d6053ed52868a57

commit 883886c959ecab152650e231335857eb3193c662
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Aug 14 09:44:39 2025 +0000

    upstream: Cast serial no for %lld to prevent compiler warnings on some
    
    platforms.
    
    OpenBSD-Commit-ID: 46c6063284d318f7e4dc922479a3e394c94b0588

commit fde5a4d2cd01bea700439fa6d5bbad88e65c99bd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Aug 14 09:26:53 2025 +0000

    upstream: Cast serial no for %lld to prevent compiler warnings on some
    
    platforms.
    
    OpenBSD-Commit-ID: 15644234b58abc9c6da2994f0422a5aa344a9e89

commit ab5074dfb614e3801fecbd376d8ed4cea613c629
Author: sthen@openbsd.org <sthen@openbsd.org>
Date:   Tue Aug 12 11:09:48 2025 +0000

    upstream: fix typo, ok markus dtucker
    
    OpenBSD-Commit-ID: 8f223da7633752162c64a659c6cf55202703d870

commit 8b6c1f402feb9eb6438003a312d7ffe8d5669896
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Mon Aug 11 14:37:43 2025 +0000

    upstream: Handle localtime_r() failure by return "UNKNOWN-TIME"
    
    which is only used in user-visible contexts.  freebsd 288773 shows their
    localtime_r() has failed at least once for unknown reason. discussed with djm
    
    OpenBSD-Commit-ID: 68f4c92d46b2578d4594b0ed940958d597fd61ac

commit 0e1b8aa27f7c86d412c9e54ad9e2cae30d9ddab4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 11 10:55:38 2025 +0000

    upstream: ssh(1): add a warning when the connection negotiates a
    
    non-post quantum safe key agreement algorithm.
    
    Controlled via a new WarnWeakCrypto ssh_config option, defaulting
    to on. This option might grow additional weak crypto warnings in
    the future.
    
    More details at https://openssh.com/pq.html
    
    mostly by deraadt@ feedback dtucker@ ok deraadt@
    
    OpenBSD-Commit-ID: 974ff243a1eccceac6a1a9d8fab3bcc89d74a2a4

commit 2ebc6384258b58ace0ad2adb2593744f62749235
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 6 23:44:09 2025 +0000

    upstream: all state related to the ssh connection should live in
    
    struct ssh or struct packet_state; one static int escaped this rule, so move
    it to struct packet_state now.
    
    ok millert tb
    
    OpenBSD-Commit-ID: bd6737168bf61a836ffbdc99ee4803468db90a53

commit 60b909fb110f77c1ffd15cceb5d09b8e3f79b27e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Aug 6 11:22:53 2025 +0000

    upstream: Improve sentence. ok djm@
    
    OpenBSD-Commit-ID: 9c481ddd6bad110af7e530ba90db41f6d5fe2273

commit 9ffa98111dbe53bf86d07da8e01ded8c5c25456b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 6 04:53:04 2025 +0000

    upstream: when refusing a certificate for user authentication, log
    
    enough information to identify the certificate in addition to the reason why
    it was being denied. Makes debugging certificate authz problems a bit easier.
    
    ok dlg@
    
    OpenBSD-Commit-ID: 4c4621b2e70412754b3fe7540af8f4bf02b722b1

commit 2a31009c36eb2da412c2784fe131fcb6ba800978
Author: job@openbsd.org <job@openbsd.org>
Date:   Tue Aug 5 09:08:16 2025 +0000

    upstream: Use the operating system default DSCP marking for
    
    non-interactive traffic
    
    It seems the CS1 traffic class mark is considered ambiguous and therefore
    somewhat unhelpful (see RFC 8622 for more considerations). But, the new
    'LE' scavenger class (also proposed in RFC 8622) offers high probability
    of excessive delays & high packet loss, which would be inappropriate
    for use with, for example, X11 forwardings. In fact, it is not known to
    SSH what's appropriate because SSH is not aware of the content of what
    passing through session forwardings. Therefore, no marking is appropriate.
    Non-interactive traffic simply is best effort.
    
    OK djm@ deraadt@
    
    OpenBSD-Commit-ID: db1da1a432ecd53fc28feb84287aedb6bec80b01

commit 6ebd472c391a73574abe02771712d407c48e130d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 5 04:00:15 2025 +0000

    upstream: a bunch of the protocol extensions we support now have RFCs
    
    and I-Ds that are more complete and detailed than what we have in the
    PROTOCOL.* files. Refer to these when possible instead of documenting them
    here.
    
    OpenBSD-Commit-ID: 4fa5b0fcf5d5f24093d33d9e82c7ca4850d50d70

commit ec3465f59c651405e395092f3ad606f8992328d8
Author: job@openbsd.org <job@openbsd.org>
Date:   Thu Jul 31 11:23:39 2025 +0000

    upstream: Deprecate support for IPv4 type-of-service (TOS) IPQoS
    
    keywords
    
    Type of Service (ToS) was deprecated in the late nineties and replaced
    with the Differentiated Services architecture. Diffserv has significant
    advantages for operators because this mechanism offers more granularity.
    
    OpenSSH switched its default IPQoS from ToS to DSCP values in 2018.
    
    IPQoS configurations with 'lowdelay', 'reliability', or 'throughput' will be
    ignored and instead the system default QoS settings apply. Additionally, a
    debug message is logged about the deprecation with a suggestion to use DSCP.
    
    with/OK deraadt@ sthen@ djm@
    
    OpenBSD-Commit-ID: 40c8c0c5cb20151a348728703536af2ec1c754ba

commit 65909fa114e7dd7511800db2b7bacb8774afe887
Author: job@openbsd.org <job@openbsd.org>
Date:   Thu Jul 31 09:38:41 2025 +0000

    upstream: Set default IPQoS for interactive sessions to Expedited
    
    Forwarding (EF)
    
    Marking interactive session data with DSCP value EF (RFC3246, RFC3247)
    helps inform the network on relative priority compared to other traffic.
    This is especially useful for differentiated treatment over wireless media.
    
    Following the reconciled IETF Diffserv to IEEE 802.11 mappings (RFC 8325),
    traffic marked with DSCP value EF maps to User Priority 6 in QoS Control,
    in turn mapping to the high priority WMM AC_VO access category.
    
    OK djm@
    
    OpenBSD-Commit-ID: aadda7b9da794d70d7c6b381a861a0610afce1b3

commit d1c6c67a50fc957010fa027c6ab970424e9b9142
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Aug 2 14:49:00 2025 +1000

    Disable security key tests for bigendian interop

commit e85248df3f1073343da87a6b00512e6a1e4a863d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Aug 2 12:51:42 2025 +1000

    Comment out atime restore test.
    
    This works on filesystems mounted 'noatime', but on others the stat()
    resets atime causing the test to fail.

commit b1c4cedbee107dc611ce091f27ea9f1de28ee378
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 1 19:29:00 2025 +1000

    Replace fbsd64ppc VM with physical host.
    
    Run 64bit bigendian interop test on NetBSD arm64be instead.

commit 284abbed9a8d815b1ec5e96aff885d77e26537e7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jul 30 10:17:13 2025 +0000

    upstream: Plug leak in case where sigp is passed as NULL. Coverity CID
    
    483725, ok djm@
    
    OpenBSD-Commit-ID: 47cf7b399c84e102b670b9f97ab6926c9a7256b5

commit dc630e6d81be8aa495254839731e4f3521cf9e31
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 30 04:27:42 2025 +0000

    upstream: unbreak WITH_OPENSSL=no builds, also allowing ed25519
    
    keys to be used via PKCS#11 when OpenSSH is built without libcrypto.
    
    OpenBSD-Commit-ID: ecf26fdf7591bf2c98bac5136fbc36e0b59c3fc2

commit a5bec2cdfc4f38ddb6211809851aae29ba99a35a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 30 04:19:17 2025 +0000

    upstream: fix variable name in disabled code
    
    OpenBSD-Commit-ID: 5612e979575d5da933c8b720d296423fd84392f5

commit 5e4bfe6c16924b1c21a733f3e218cfcba98e301e
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jul 26 19:19:46 2025 +1000

    more ec/ed25519 fixing

commit 2603098959eff55cbe188c3dfcbe5302808a80fc
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jul 26 14:27:53 2025 +1000

    repair build for libcrypto without ed25519 support

commit a729163c56ecc002c0cb04db56e7d86ceec2e8b0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jul 26 01:53:31 2025 +0000

    upstream: regression tests for Ed25519 keys in PKCS#11 tokens
    
    OpenBSD-Regress-ID: 50067c0716abfea3a526b4a0c8f1fe15e7665c0f

commit 361ff0ca308ac02449e71689fc5ea72114db43db
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jul 26 01:51:44 2025 +0000

    upstream: Support ed25519 keys hosted on PKCS#11 tokens.
    
    Tested on Yubikeys and against SoftHSM2.
    
    feedback/ok tb@
    
    OpenBSD-Commit-ID: 90ddb6529f2e12e98e8bba21d8592e60579ce2e4

commit 2b530cc3005a71c5ba6b712978872fc9c147439c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 25 13:06:07 2025 +0000

    upstream: update our PKCS#11 API header to v3.0;
    
    feedback/ok tb@
    
    OpenBSD-Commit-ID: e67fa6a26e515c2b1fb7b0d1519d138aafb3e017

commit 550d2a4a66c50f7641563a63b900761d99efb24a
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 25 23:04:33 2025 +1000

    another attempt at fixing !EC builds

commit ed1e370d84e9dc39bc31c19cca12222d991fdc6f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 25 11:50:45 2025 +0000

    upstream: Don't snprintf a NULL since not all platforms support it.
    
    OpenBSD-Commit-ID: 6e0c268e40047e96fab6bc56dc340580b537183b

commit eedab8db12d57c4f4583f6b60e48a4ce25b47b9c
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 25 16:21:43 2025 +1000

    unbreak !EC builds

commit 203f5ac6cfa0e257db7509d4bb830e8a4bba6211
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 24 06:04:47 2025 +0000

    upstream: test code now needs to link ssh-pkcs11-client.c any time
    
    sshkey.c is included
    
    OpenBSD-Regress-ID: 9d07188eae9a96801c3150b3433bb220626d4443

commit 33b4f05c8ddab24aa6c47afb313b8cbd0d4b77f4
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 25 12:47:17 2025 +1000

    update clang-16 -> clang-19

commit 03e9e993ef1ef5accc6457152278cab5988f9b3d
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 25 12:46:59 2025 +1000

    include ssh-pkcs11-client.o as common dep

commit 2f5269938a8e4769f484c9d45419a86529078ede
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 25 12:46:10 2025 +1000

    remove vestigial stub

commit bf33a73c40522ce60961d4fff316a7187fb06ca0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 24 23:27:04 2025 +0000

    upstream: this should include stdlib.h explicitly
    
    OpenBSD-Commit-ID: 1c0cc5c3838344b33ae4ab7aa62c01530357bf29

commit 9f8ccc3b81b53324cc489f3fe00f03c329c0acb2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 24 06:59:51 2025 +0000

    upstream: less stale reference to PKCS#1 1.5 hash OIDs; feedback
    
    from tb@
    
    OpenBSD-Commit-ID: 9fda77978491a130a7b77d87d40c79277b796721

commit 1641ab8744f500f55f12155d03f1a3116aaea374
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 24 06:12:08 2025 +0000

    upstream: factor out encoding of a raw ed25519 signature into its
    
    ssh form into a separate function
    
    OpenBSD-Commit-ID: 3711c6d6b52dde0bd1f17884da5cddb8716f1b64

commit a8c0e5c871c0c7ee5ae93e353b1499a53c09c71d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 24 05:44:55 2025 +0000

    upstream: Help OpenSSH's PKCS#11 support kick its meth habit.
    
    The PKCS#11 code in OpenSSH used the libcrypto public key method API
    (e.g. the delightfully named RSA_meth_free()) to delegate signing
    operations to external keys. This had one advantage - that it was
    basically transparent to callers, but also had a big disadvantage -
    that we'd manually have to track the method implementations, their
    state and their relationships to the underlying PKCS#11 objects.
    
    This rips this out and replaces it with explicit delegation to
    PKCS#11 code for externally hosted keys via the ssh-pkcs11-helper
    subprocess. This is very similar to how we handle FIDO keys in
    OpenSSH (i.e. via ssh-sk-helper). All we need to track now is a
    much simpler mapping of public key -> helper subprocess.
    
    Kicking our libcrypto meth dependency also makes it much easier
    to support Ed25519 keys in PKCS#11, which will happen in a subsequent
    commit.
    
    feedback / ok tb@
    
    OpenBSD-Commit-ID: a5a1eaf57971cf15e0cdc5a513e313541c8a35f0

commit 259c66aebe4e1f9d60e548f728ff74083bcccddf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jul 24 22:02:49 2025 +1000

    Remove DEBUG_ACTIONS variable.
    
    If needed it can be set in github if needed.

commit 40fb2dc4ece76c8f0c624d90a17bc1bbf47f3729
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 23 05:07:19 2025 +0000

    upstream: add a ssh_config RefuseConnection option that, when
    
    encountered while processing an active section in a configuration file,
    terminates ssh(1) with an error message that contains the argument to the
    option.
    
    This may be useful for expressing reminders or warnings in config
    files, for example:
    
    Match host foo
           RefuseConnection "foo is deprecated, use splork instead"
    
    ok djg
    
    OpenBSD-Commit-ID: 5b0072fcd08ad3932ab21e27bbaa66b008d44237

commit defc806574d2256036d69a291caf0f3484844de6
Author: miod@openbsd.org <miod@openbsd.org>
Date:   Sat Jul 12 05:28:33 2025 +0000

    upstream: Add missing inter-library dependencies to LDADD and
    
    DPADD. ok tb@ deraadt@
    
    OpenBSD-Commit-ID: a05e13a7e2c0b65bb4b47184fef731243431c6ff

commit e6805e2a6b33e001e1a7257b85ab779fd592a578
Author: Jan Tojnar <jtojnar@gmail.com>
Date:   Thu May 18 16:30:35 2023 +0200

    Add gnome-ssh-askpass4 for GNOME 40+
    
    GTK 3 has been in maintenance mode for a while now, and it is on the road
    to being abandoned. As a result, the dialogue looks out of place on modern
    systems.
    
    We could port it to GTK 4 but without the program being registered as an
    application (i.e. having a .desktop file), GNOME Shell would ask for
    permission to grab input every time.
    
    Let’s instead use the GNOME Shell’s native prompt through the unstable
    Gcr API.

commit f9dc519259804702cab0fa0ca8b193a360e3ec38
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 11 17:20:27 2025 -0700

    let ga_init() fail gracefully if getgrouplist does
    
    Apparently getgrouplist() can fail on OSX for when passed a non-existent
    group name. Other platforms seem to return a group list consisting of
    the numeric gid passed to the function.
    
    This makes ga_init() handle this failure case gracefully, where it will
    return success but with an empty group list array.
    
    bz3848; ok dtucker@

commit f01a899b92ab8c5e6ff71214658bd09636c47e87
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 11 23:26:59 2025 +0000

    upstream: add a "Match Group NoSuchGroup" to exercise groupaccess.c
    
    OpenBSD-Regress-ID: 7ff58e6f0eb21eb9064dd0cfa78c3b6f34b5f713

commit 1052fa62b35e0bb25b0c1efb9fdd7870e4a68ab6
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 11 15:36:49 2025 -0700

    more diagnostics when getgrouplist fails

commit eddd1d2daa64a6ab1a915ca88436fa41aede44d4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 4 09:51:01 2025 +0000

    upstream: Fix mistracking of MaxStartups process exits in some
    
    situations. At worst, this can cause all MaxStartups slots to fill and sshd
    to refuse new connections.
    
    Diagnosis by xnor; ok dtucker@
    
    OpenBSD-Commit-ID: 10273033055552557196730f898ed6308b36a78d

commit c971f3d93efe4c00d73b276cdbab66e7c66c9b5c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 5 20:50:50 2025 +1000

    Add include for gssapi definitions.
    
    Patch from dbelyavs at redhat.com via bz#3846.

commit 007b69f21cf9e64125b241d4411a5e47f5028aa8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 4 07:52:17 2025 +0000

    upstream: add a regress test for configurations > 256KB
    
    mostly by Dmitry Belyavskiy
    
    OpenBSD-Regress-ID: fcedb249e4cf2447e078a839877f99730ee79024

commit 0cf38d74463bcf80510e7fd1b3d9328e7d91eb00
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 4 07:47:35 2025 +0000

    upstream: the messaging layer between sshd-session and sshd-auth had a
    
    maximum message size of 256KB. Some people apparently have configurations
    larger than this and would hit this limit.
    
    Worse, there was no good logging that could help diagnose what was
    going wrong.
    
    So this bumps the maximum message size to 4MB and implements an early
    check (usable via the sshd -t test mode) that will report it to the
    user where it is hopefully more visible.
    
    bz3808, reported by Dmitry Belyavskiy, ok dtucker@
    
    OpenBSD-Commit-ID: 69c303fb68cbd1a4735936835d67a71e7b57f63b

commit fd10cea0f16e928ae2b52fbeadccd475d0438eb4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 4 00:17:55 2025 +0000

    upstream: mux: fix incorrect return value check in local forward
    
    cancellation
    
    channel_cancel_lport_listener() returns 1 on success and 0 on failure.
    The previous code incorrectly checked for `== -1`, a value the function
    never returns, so failure was not detected and the "port not found"
    error message was never shown when cancelling dynamic or local port
    forwards.
    
    From: Boris Tonofa <b.tonofa@ideco.ru>
    
    OpenBSD-Commit-ID: 3e9d2252a4d0bd318d4f25e2b518afb44acea170

commit 29cf521486bf97ab9de5b9b356f812107e0671bc
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Jul 2 13:47:38 2025 +1000

    wrap some autoconf macros in AC_CACHE_CHECK
    
    This allows skipping/overriding the OSSH_CHECK_CFLAG_COMPILE and
    OSSH_CHECK_CFLAG_LINK macros used to discover supported compiler
    or linker flags. E.g.
    
      $ ./configure ossh_cv_cflag__fzero_call_used_regs_used=no
      [...]
      checking if cc supports compile flag -ftrapv and linking succeeds... yes
      checking if cc supports compile flag -fzero-call-used-regs=used and linking succeeds... (cached) no
      checking if cc supports compile flag -ftrivial-auto-var-init=zero... yes
    
    Patch from Colin Watson, ok dtucker@

commit b28e91aff80fd24341de8cb3c34dc454d6b75228
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jun 29 08:20:21 2025 +0000

    upstream: Add shebang path to askpass script. Required for exec on
    
    some platforms (musl, probably others).
    
    OpenBSD-Regress-ID: 35cdeed12ae701afcb812f800c04d817325cd22a

commit 83d3ffc0fc0f5e4473ab43f0d42a1cf9497ce0b5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jun 29 05:35:00 2025 +0000

    upstream: Check dropbear server version for required features.
    
    Dropbear added the '-D' flag in version 2025.87.  We need that for the
    dropbear-server test, so skip on older versions.
    
    OpenBSD-Regress-ID: 9db0b84edd54d3c00ab17db1dc6d62af4644c550

commit 0b17d564cfae82f2a52e9b4d588657da47ea4e43
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jun 29 14:34:48 2025 +1000

    Encrypt temporary password we're setting.
    
    Now that we want to actually use the random password for tests, we need
    to correctly encrypt it, instead of just setting it to a random string
    that's not the "locked" value.

commit 700205bd861c25cc7564010cf63d984d8db5098a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jun 29 11:27:17 2025 +1000

    Fix env again.

commit 223a1beac7b7be9252f69055781c9c15f4d8a607
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jun 29 11:24:42 2025 +1000

    Move env again.

commit d32614b448528ac08a65caac323a34b4f559a204
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jun 29 11:22:00 2025 +1000

    Move env to where it (hopefully) belongs.

commit 8a9384de483b8fb69a800e0347273686a5715fc3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jun 29 11:14:18 2025 +1000

    Enable password tests on Github ephemeral VMs.

commit bcfe7340d9b622ecd978c87dbf885c8b5a503ca2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jun 28 13:34:08 2025 +0000

    upstream: Add simple regression test for dropbear as a server.
    
    OpenBSD-Regress-ID: 7abe1f6607d0cd49839918aade8f135d2462d389

commit 838d5ec4b12fb519ed9db76e5beccf11b7ee212f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 24 12:28:23 2025 +0000

    upstream: Add simple test for password auth. Requires some setup
    
    so does not run by default.
    
    OpenBSD-Regress-ID: d5ded47a266b031fc91f99882f07161ab6d1bb70

commit 57fb460165ae3b2d591f2468d7fe13cc1abda26d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 17 01:24:32 2025 +0000

    upstream: add RCS ID
    
    OpenBSD-Regress-ID: 6e30094e3bf0a1c65efb75c67a87093304a3e619

commit 688fa02728f2efbf18388bc1a8e94e7ba7ee4f11
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 24 09:22:03 2025 +0000

    upstream: make "Match !final" not trigger a 2nd pass ssh_config
    
    parsing pass (unless hostname canonicalisation or a separate "Match final"
    does). bz3843
    
    ok dtucker@
    
    OpenBSD-Commit-ID: ce82b6034828888f0f3f1c812e08f5e87400d802

commit 5ba8391d697740a838fd8811434f707f0e079baa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 19 05:49:05 2025 +0000

    upstream: better debug diagnostics when loading keys. Will now list
    
    key fingerprint and algorithm (not just algorithm number) as well as making
    it explicit which keys didn't load.
    
    OpenBSD-Commit-ID: ee3e77a0271ab502e653922c6d161b1e091f8fee

commit b360f3a675e24b0dbb2ec30d985e3b6756996c0d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 17 01:20:17 2025 +0000

    upstream: whitespace
    
    OpenBSD-Commit-ID: 6e96814bcf70d0edbb0749ec61cc4fd8707f286d

commit ad38ec5f1b6768944d64ed7709da8706538b5509
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 17 01:19:27 2025 +0000

    upstream: fix leak on error path; Coverity CID 481976
    
    OpenBSD-Commit-ID: 963dba2c804e2fd8efea2256092899874d0dbc7b

commit 5f761cdb2331a12318bde24db5ca84ee144a51d1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 17 21:46:37 2025 +1000

    Update obsd tests to use current images.

commit 1e8347e3543a415067ccc556aefea97656ecafb7
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Jun 17 09:48:47 2025 +1000

    add sshd-auth to RPM spec files

commit dd800444943bd64913507f6005586136d49f63db
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 16 09:09:42 2025 +0000

    upstream: Limit each moduli size to a max of 100 entries.
    
    OpenBSD-Commit-ID: 747219d54565030ff7c45298b9f5e971801f6cb2

commit 05f7bf46d1e2c101e9cbdd3df2ccee484bed969f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 16 09:07:08 2025 +0000

    upstream: Now that ssh-keygen defaults to the maximum memory for
    
    moduli generation we no longer need to run it twice to get enough.  Use mkdir
    -p instead of a conditional, which allows "make -jN" to work without error.
    
    OpenBSD-Commit-ID: c2eb57285424f819f9520fa33e0d6d3c4a361a5e

commit df3f903d616763a105570610a616dacf0f83438e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 16 09:02:19 2025 +0000

    upstream: Fix overflow check in sshbuf_dup_string. It's already
    
    constrained by SSHBUF_SIZE_MAX, but still worth fixing the check.  Patch from
    afonot via github PR#573, with & ok djm@
    
    OpenBSD-Commit-ID: 438888498e66472fc6a48133196d6538d27bff18

commit 80916d0d3794e2f92dd6998d7c45daba484e4f18
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 16 08:53:04 2025 +0000

    upstream: Plug mem leak. Patch from afonot via github PR#574, ok djm@
    
    OpenBSD-Commit-ID: 65619f14ef206028ce39bc31f704b832a0609688

commit bd1bd7e8296aa51a4b3958cef2fbb17894ba94e9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 16 08:49:27 2025 +0000

    upstream: Save return value from sshbuf_len instead of calling it
    
    multiple times. Fixes Coverity CID 470521.
    
    OpenBSD-Regress-ID: 356b8b43c8a232deaf445c1ff7526577b177a8e9

commit 2827b6ac304ded8f99e8fbc12e7299133fadb2c2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 13 07:35:14 2025 +0000

    upstream: Plug leak. Coverity CID 405058.
    
    OpenBSD-Regress-ID: 7fb2fce68d2cb063cdb94d5d66f84fa3a2902792

commit 9cdc72b829e9f0e24dedc533cbe87291d8a88c9e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 13 07:23:07 2025 +0000

    upstream: Remove dead code flagged by Coverity CID 307783. ok djm@
    
    OpenBSD-Regress-ID: e579f5ec2fd2eb2fe2bad654d16f2ba655a3e035

commit 930a45ee759728c8ba711c45a2a985b8191bd297
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 12 10:09:39 2025 +0000

    upstream: Set user, host and path to NULL immediately before calling
    
    parse_user_host_path in tests.  This ensures that we don't accidentally use
    the previous value if the function under test doesn't set them Also fixes
    Coverity CIDs 405056 405065 405066.
    
    OpenBSD-Regress-ID: 43678ff59001712f32214fe303b1c21c163c2960

commit 2314d87f9b8b430532111fd6e5e8df0cf9068c9c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 12 09:26:57 2025 +0000

    upstream: Plug mem leak on error path here too.
    
    Coverity CID 307781.
    
    OpenBSD-Regress-ID: 18e053d9b661fbb4227d3db03172077c1216bb2e

commit 567ef4e7ddc5c1e7a461560963a1dc759669821d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 12 09:19:43 2025 +0000

    upstream: Plug mem leak on error path.
    
    Coverity CID 307776.
    
    OpenBSD-Regress-ID: c44246690973e1b8643e51079a2faa7ace26490c

commit 5d415897ac04e237f1fa73b9dcb9ba8fb3ac812b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 11 13:27:11 2025 +0000

    upstream: Remove dead code ternary. We always report at least
    
    KB/s, so B/s is never used.  Coverity CID 291809, ok djm@
    
    OpenBSD-Commit-ID: a67c5bcc9e19c8965bfeace0e337b13660efa058

commit 4b3d27032ba88dd089b721f3bbe3e4a8d23b4ae1
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 11 13:24:05 2025 +0000

    upstream: Improve termination condition of while loop to compare
    
    size_t's.  Assuming read() does what it's supposed to this shouldn't matter,
    but should be more robust.  Flagged by Coverity CID 470514, ok djm@
    
    OpenBSD-Commit-ID: d7b5ad60feb797b3464964b9ea67fd78fb9d6cc6

commit 5530e5f83b3cd3425ea3dbab02da15140befdd91
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 10 18:40:56 2025 +1000

    Replace Windows 2019 runners with 2025 ones.
    
    The windows-2019 runners are being decomissioned.

commit a22ff3c6f11edd00c19981f9cb85d3b25d305a56
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 4 18:33:52 2025 +1000

    Disable _FORTIFY_SOURCE during snprintf test.
    
    Prevents mistakenly detecting snprintf as broken on FreeBSD 15 with
    _FORTIFY_SOURCE enabled.  bz#3809, patch from jlduran at gmail.com

commit 203bb886797677aa5d61b57be83cfdc1b634bc9c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 2 14:09:34 2025 +0000

    upstream: Fix x11_channel_used_recently() to return true when channel
    
    has been used within the last second, instead of more than a second ago.
    Should fix ~5s delay on X client startup when ObscureKeystrokeTiming is
    enabled. bz#3820, ok (& sigh) djm@
    
    OpenBSD-Commit-ID: b741011e81fb3e3d42711d9bd3ed8a959924dee4

commit dc6c134b48ba4bcfadedcea17b4eddac329601d9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu May 29 13:27:27 2025 +0000

    upstream: When there's more than one x11 channel in use, return
    
    lastused of most recently used x11 channel instead of the last one found. ok
    djm@
    
    OpenBSD-Commit-ID: 94a72bf988d40a5bae2e38608f4e117f712569fe

commit 73ef0563a59f90324f8426c017f38e20341b555f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat May 24 11:41:51 2025 +0000

    upstream: replace xmalloc+memset(0) with xcalloc(); from AZero13 via
    
    GHPR417
    
    OpenBSD-Commit-ID: 921079436a4900325d22bd3b6a90c8d0d54f62f8

commit 3a61f5ed66231881bee432c7e7c6add066c086af
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat May 24 09:46:16 2025 +0000

    upstream: fix punctuation around host key fingerprints to make them
    
    easier to copy and paste.
    
    Patch from Till Maas via GHPR556; ok dtucker@
    
    OpenBSD-Commit-ID: c0100182a30b6925c8cdb2225b18140264594b7b

commit b12d4ab1e16f57c6c348b483b1dbdd4530aaaddd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 08:13:29 2025 +0000

    upstream: Replace strncmp + byte count with strprefix in Penalty
    
    config parsing. ok kn@, djm@
    
    OpenBSD-Commit-ID: 34a41bb1b9ba37fb6c7eb29a7ea909547bf02a5a

commit a356d978e30dd9870c0b3a7d8edca535b0cd2809
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 08:09:32 2025 +0000

    upstream: Make the display number check relative to
    
    X11DisplayOffset.
    
    This will allows people to use X11DisplayOffset to configure much higher
    port ranges if they really want, while not changing the default behaviour.
    Patch from Roman Gubarev via github PR#559, ok djm@
    
    OpenBSD-Commit-ID: e0926af5dc0c11e364452b624c3ad0cda88550b5

commit e18983d03ab969e2f12485d5c0ee61e6d745a649
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 24 17:20:57 2025 +1000

    Remove progressmeter.o from libssh.a.
    
    It's now explicitly included by the binaries that need it (scp & sftp).
    bz#3810, patch from jlduran at gmail.com

commit f8967045ad9d588bc11426642070bf8549065e62
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 06:50:28 2025 +0000

    upstream: Null out keys between test runs.
    
    BENCH_START and BENCH_FINISH are actually a while() loop in disguise,
    so if sshkey_generate does not reset the key pointer on failure the test
    may incorrectly pass.  It also confuses Coverity (CID 551234).
    
    OpenBSD-Regress-ID: bf4d32079fc6df6dce1f26c2025f4ed492f13936

commit a26091ecdb2a3d72b77baf3c253e676a3c835a24
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat May 24 04:41:12 2025 +0000

    upstream: add some verbosity
    
    OpenBSD-Regress-ID: 11c86cda4435b5f9ab6172c4742b95899666c977

commit 484563ec70e30472ab4484d49bca9a83771d785c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat May 24 04:41:03 2025 +0000

    upstream: use start_ssh_agent() to ensure we get logging
    
    add some verbosity
    
    OpenBSD-Regress-ID: a89bf64696b9fb1b91be318e6b8940c9ab21c616

commit e3c58113ebb3397b252ff26e0e94f726b7db7a8a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat May 24 04:40:37 2025 +0000

    upstream: add a start_ssh_agent() function that sets up an agent
    
    with logging
    
    OpenBSD-Regress-ID: 7f9f30f9c64acbd4b418a5e1a19140cc988071a8

commit 3de011ef7a761751afe28ac7ef97fe330d784595
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 06:43:37 2025 +0000

    upstream: Plug leak of startup_pollfd in debug and child paths.
    
    Coverity CID 405024, ok djm@
    
    OpenBSD-Commit-ID: db46047229253e9c4470c8bbf5f82706ac021377

commit d0245389bc55f16082cadd0a39dda5af1c415dfa
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 24 17:11:38 2025 +1000

    ssh-keygen changes were fixup'ed into single commit.

commit 140bae1df2b7246bb43439d039bf994159973585
Author: Marco Trevisan (Treviño) <mail@3v1n0.net>
Date:   Mon Sep 30 13:14:11 2024 +0200

    auth-pam: Check the user didn't change during PAM transaction
    
    PAM modules can change the user during their execution, in such case ssh
    would still use the user that has been provided giving potentially
    access to another user with the credentials of another one.
    
    So prevent this to happen, by ensuring that the final PAM user is
    matching the one that initiated the transaction.

commit 216824172724a50a4a75439fb2b4b8edccf5b733
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 03:37:40 2025 +0000

    upstream: Remove ssh-keygen's moduli screen -Omemory option.
    
    This vaguely made sense 20 years ago, but these days you'd be hard
    pressed to *find* a machine small enough to not support the maximum
    (127MB), and no one is screening moduli on such machines anyway,
    so just use the max.  This also fixes Coverity CID 470522 by deleting
    code in question.  "kill it with fire" djm@.
    
    OpenBSD-Commit-ID: 39036aa406a99f0a91923aa3a96afff1205558e6

commit f5cd14e81fa29b4924959cb2e1f9c206aae2d502
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 02:33:33 2025 +0000

    upstream: Fix compile error on 32bit platforms.
    
    Spotted by & ok tb@
    
    OpenBSD-Commit-ID: cbcf518247886f3c7518fc54cb3bd911ffc69db7

commit eccc15014fe146e8590568e6737a3097bfac3415
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat May 24 02:01:28 2025 +0000

    upstream: Use pointer from strprefix in error message,
    
    missed in previous.
    
    OpenBSD-Commit-ID: d2cdec6cf0fcd4b0ee25e4e3fad8bc8cf0ee657d

commit 91903511d0597c3bea218167f9ca5a176fa0dc20
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 23 12:52:45 2025 +0000

    upstream: Replace strncmp and strncasecmp with hand-counting bytes
    
    with strprefix. nits lucas@, ok lucas@ djm@
    
    OpenBSD-Commit-ID: f0888807f151ea2bdaf6fed36303ae81f259d1d4

commit 0c64d69e4e24a3ab06f7922ef389e7399c4dfb88
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 23 11:54:50 2025 +0000

    upstream: Include stdint.h for UINT32_MAX.
    
    OpenBSD-Commit-ID: edc29ed67e8bd03bac729d9b4849066d1d3a8cb9

commit 3e11478f585408888defa56fa47e8dc6567378d0
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 23 11:25:35 2025 +0000

    upstream: Ensure args to nh_update() fit within uint32, which it
    
    should always anyway. Placates Coverity CID 470520.  While there, fix the
    upstream URL.  ok djm@
    
    OpenBSD-Commit-ID: 2478e89fde089a49fa02f9faf6287d35959c9f92

commit f097d7bd07da4634c1a723d1dc4fcf56e7d0e147
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 23 09:26:25 2025 +0000

    upstream: Don't leak the args list. Coverity CIDs 481569 & 481570,
    
    ok job@ tb@.
    
    OpenBSD-Commit-ID: becabcd00513d13d1435b68b7ccffa7151b72393

commit a4ea7f6042f25b41061a83445016a1ea4f470f7b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 23 08:40:13 2025 +0000

    upstream: Explictly set LC_ALL=C on each sort invocation.
    
    Remove it from sshd_config (where it could be overridden by shell startup
    scripts, eg on macos-15) causing random test failures.  with & ok djm@
    
    OpenBSD-Regress-ID: ad0a6678964784096e9a9e6d15ead36beed92f18

commit 7674c03caed80cb3565d14690c92068a14051967
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri May 23 16:39:18 2025 +1000

    Allow setting LTESTS in repo variables.

commit d8b5bd36078e5b6d78da4633f0cc9b90ffda8b50
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri May 23 16:26:20 2025 +1000

    Rename debugging variable RUN_ONLY_TEST.
    
    to RUN_ONLY_TARGET_CONFIG to make it more obvious what it matches.

commit a79a2c1190bd3124da21d9e1582dd94877c7f972
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri May 23 16:11:48 2025 +1000

    chown regress logs before uploading.

commit 24889a33071086b6f1f62568b0c2bd0a4955ac49
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 23 01:14:35 2025 +0000

    upstream: Import regenerated moduli.
    
    OpenBSD-Commit-ID: 07e29dc891e29b31e03e2e5493658b4a9ac19431

commit 4b8bee62d72ffb3c419c9ead6c9fb1a586283868
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Fri May 23 00:40:45 2025 +0000

    upstream: use "const char * const" for malloc_options here also
    
    OpenBSD-Commit-ID: 869715b9c7e1dd5b85efd07814e7e53f0286eea2

commit 6629eee21ca9d0a597a04dcac744a1ad882f912e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu May 22 12:14:19 2025 +0000

    upstream: Adjust debug message to prevent (unsigned) integer overflow.
    
    Fixes Coverity CID 481110, ok djm@
    
    OpenBSD-Commit-ID: 26178bf3b812707fb498ea85d076cadd1f2eb686

commit 7acb70e05e9977ceca7b33df84ceaea337b1efef
Author: bluhm@openbsd.org <bluhm@openbsd.org>
Date:   Thu May 22 04:34:18 2025 +0000

    upstream: Fix OpenBSD RCS ID typos. from Andrius V
    
    OpenBSD-Regress-ID: 5c03a2ef5323969fc4978f2eec4f1a25c48c572a

commit 2b2a7a2a0d70023b439080bb2770ff36522dbea8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 22 22:09:48 2025 +1000

    Remove debug change accidentally commited.
    
    Fixes Coverity CID 481160.

commit 450a8a1df1577ddbe68fe8da1fb8514d3781ef32
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 22 21:16:37 2025 +1000

    Collect all of regress dir on failure.
    
    This may allow us to sort through its entrails and determine the cause
    of some types of failures.

commit de25e739781c4c09d20abd410f50f0a6f192dc72
Author: Damien Miller <djm@mindrot.org>
Date:   Thu May 22 18:42:44 2025 +1000

    minimal shims for fstatat(2)/unlinkat(2) in agent
    
    Add some very minimal and task-specific replacements for
    fstatat(2) and unlinkat(2) in the ssh-agent socket cleanup
    loop, for platforms that lack these functions. ok dtucker@

commit 6d192645a613aa814d51050b0458f37265b90d6c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu May 22 04:22:03 2025 +0000

    upstream: Output the current name for PermitRootLogin's
    
    "prohibit-password" in sshd -T instead of its deprecated alias
    "without-password".  bz#3788, patch from cjwatson at debian.org.
    
    OpenBSD-Commit-ID: 2d5df18d5ad33a9b6c7547ec78a8e6ea13813df9

commit 1ccf42378df202472e7254f37f7dabb2f5723955
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu May 22 03:53:46 2025 +0000

    upstream: Copy arg to be passed to dirname().
    
    POSIX allows dirname() to modify its args and return a pointer into it,
    so this prevents an overlapping strlcpy.  bz#3819, patch from cjwatson
    at debian.org
    
    OpenBSD-Commit-ID: c32e496e6a1618aba31c8b7a9d4e1376c5ea6aa1

commit b5877b7b3e597f47578ade9dbe7e4332f112dfc4
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu May 22 03:41:10 2025 +0000

    upstream: Add $OpenBSD$ marker for easier syncing.
    
    OpenBSD-Commit-ID: 27ff3e1e2e6610d9981ebe43ae9b783236800035

commit 58d094c7cb974d7bd3ba6eb1059b186a2ac3dd55
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 21 12:12:20 2025 +0000

    upstream: Correct FILES section to mention new default path to
    
    agent sockets. Spotted by / ok jmc@
    
    OpenBSD-Commit-ID: 91d736d78d71a4276c9cbb075b1462bbc3df55a6

commit d1d5c8b9b8de8283618c18d0dafdec6a209911cc
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 22 12:25:35 2025 +1000

    Fix nc install some more.

commit 49a2412ad23162e44be9e0b2cb12f6daf6b666d7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 22 12:21:11 2025 +1000

    Fix cvs up of nc.

commit df22801b3f0ae245f825cf9c9dbb4543e41a7c5c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 22 11:34:04 2025 +1000

    Install nc during upstream test.
    
    This ensures that the installed nc matches the expectations of the
    regress tests.

commit e391c5289c2b687ff886cf780dc8fcb426e4d5d2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 22 10:52:31 2025 +1000

    Remove 9.7 branch from CI status page.
    
    It's been obsolete long enough that github no longer reports its
    status.

commit b71773c20d566fa5dcaf9edf3139bdcb3f2c4bc2
Author: Damien Miller <djm@mindrot.org>
Date:   Wed May 21 19:14:47 2025 +1000

    pull a small netcat SOCKS4A fix from upstream

commit 0adb2db25eff3fe1c90c55654387ae1e4e18a396
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 21 08:41:52 2025 +0000

    upstream: test SOCKS4A; ok tb
    
    OpenBSD-Regress-ID: d880b75280295cd581a86e39bb0996d347f122d2

commit 5699f4e9553c6a228fd9dc578d99e3aa6451c014
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 21 08:36:39 2025 +0000

    upstream: remove log tarballing "it seemed like a good idea at the
    
    time" - dtucker@
    
    ensure that log files have correct perms when running under sudo/doas
    
    ok dtucker@
    
    OpenBSD-Regress-ID: 20588c14b05de9519f85d638b374b66ae0678c89

commit 0c14e6b69a20f20d602e0e72559ca3f4dbc797fb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 21 06:44:24 2025 +0000

    upstream: use logit_f("...") instead of logit("func: ...")
    
    OpenBSD-Commit-ID: c8d49eb39a9abff3cbcaeaf7df9d48468a5a0695

commit 1743589d038476f28dc4dfb1f69317649ae22ac5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 21 06:43:48 2025 +0000

    upstream: function to make a sshbuf from a hex string; useful in
    
    tests
    
    also constify some arguments
    
    OpenBSD-Commit-ID: 00f9c25b256be0efd73f2d8268ff041bc45ffb2c

commit 83729cf503289104d7e64a69be14579523988cb6
Author: Damien Miller <djm@mindrot.org>
Date:   Wed May 21 18:47:46 2025 +1000

    merge netcat SOCKS4A support from OpenBSD
    
    Not a full sync of this file as we have diverged substantially
    from upstream (it has libtls support, etc.)

commit 750f1867476bda36879f69e25e8f52cb45c58807
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 22:17:02 2025 +1000

    Include OpenSSL compat shim where needed.

commit 6fb728df50c1afd338cb0223a84ce24579577eff
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 19:28:55 2025 +1000

    Run all tests on Cygwin again.
    
    ... now that we've fixed ci-setup on Cygwin.

commit 648a3a008cf1cfa54631d2f0457b5313c455f484
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 18:48:23 2025 +1000

    Use USERNAME rather than LOGNAME on Cygwin.
    
    LOGNAME is specified by POSIX, but Windows (or at least, github's
    Windows images) don't set it.

commit 0214e53124c09528b6ee29b9a551442b5611a454
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 18:28:52 2025 +1000

    Add debug output when setting up CI environment.

commit 9d9a2c0369419f3b4952e597db7b8696f54e7f3a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 19:16:38 2025 +1000

    Include openssl compat shims in test.
    
    Fixes tests on platforms using older LibreSSL releases prior to 3.4.

commit 1a9b1cfa4e8b807c7f82fdba8f730c2abdbba071
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 18:14:06 2025 +1000

    Add compat shims for EC_POINT affine_coordinates
    
    LibreSSL <3.4 does not have EC_POINT_[gs]et_affine_coordinates
    but does have the now-deprecated _GFp variantes.  We still support
    LibreSSL back as far as 3.2.x so add a compat shim.

commit cff2175200b412a9207a4fe5c1bdcc54e8a73d07
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Mon May 12 05:42:02 2025 +0000

    upstream: Use EC_POINT_[sg]et_affine_coordinates()
    
    It is available in all supported OpenSSL flavors/versions and the _GFp
    variants will be removed from LibreSSL.
    
    ok hshoexer jsing
    
    OpenBSD-Regress-ID: 66cf1561e7b6c49002978f2d6720956f33a882f0

commit 2d35e24739b515394017b74465a0996c384cf28f
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Mon May 12 05:41:20 2025 +0000

    upstream: Use EC_POINT_[sg]et_affine_coordinates()
    
    It is available in all supported OpenSSL flavors/versions and the _GFp
    variants will be removed from LibreSSL.
    
    ok hshoexer jsing
    
    OpenBSD-Commit-ID: ecedca0e1ffa80e0c9ef7c787bc6a972882c596b

commit 17003b9f1cd7b7bf1f52493cc4a1ab95727c3ed7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 9 02:42:03 2025 +0000

    upstream: make the progress-meter code safe against being called
    
    when not initialised; spotted by tb@ feedback/ok tb@ deraadt@
    
    OpenBSD-Commit-ID: a9fda1ee08a24c62e0981ff6d15ca93b63467038

commit 2d023e7a95d673e93ccc1978bf8931f7335b2b53
Author: tedu@openbsd.org <tedu@openbsd.org>
Date:   Thu May 8 17:32:53 2025 +0000

    upstream: convert a last quad_t to int64_t. ok deraadt djm
    
    OpenBSD-Commit-ID: 1c9e01ba1a9ccf442a9cdf10f222077f66885f1f

commit fc8c56ade809f66f7df4b5153a4d92593631c12a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 20 15:01:29 2025 +1000

    Set runner pasword to random string.
    
    The most recent version of the Github ubuntu-latest image sets the
    password field to "!" which sshd considers to be a locked account,
    breaking most of the tests.

commit c404686c17daeda7e95ca6fc14c8a4a570cf975d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun May 11 22:54:13 2025 +1000

    Debug log for why an account is considered locked.

commit ee1d31781cf0d292a50b4df4cb8cb6ffcbfbe9af
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun May 11 16:35:31 2025 +1000

    Move debug log output into separate workflow step.
    
    Should reduce the need to scroll back to find out which test actually
    failed.

commit ddfb78a15f57a33427d462b9c401de5c8e6799da
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 21:48:06 2025 +1000

    Skip sftp-perm on Cygwin too.

commit 8846caccb86b3f5a4f1c10bfffcc9cf1adc17925
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 10:23:30 2025 +1000

    Remove CYGWIN binmode as it's now obsolete.

commit cf795d55437e6c1ffe85e90e0fae00e885e50036
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 09:25:18 2025 +1000

    Also skip sftp-cmds test on Cygwin.
    
    Fails at the hardlink step.

commit d1b28639c1cb382943bd92c68992ea74af9b5773
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 08:52:11 2025 +1000

    Tell Cygwin to use native symlinks.

commit 56782dad7d7f96b4943951227515bd7904ac3cf7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 08:26:37 2025 +1000

    Skip keygen-knownhost test on Cygwin.
    
    It fails but at this time it's not clear why.

commit d5cbac2364b03e55b733a2422a07e78e16d2a118
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 07:59:44 2025 +1000

    Pass Cygwin setup location to CI setup.
    
    (instead of hard coding it, wrongly).

commit 82f1f52c5582f005761e4e200c279ddd9c6781e4
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 10 06:37:24 2025 +1000

    Add RUN_ONLY_TEST to limit which tests are run.
    
    For testing, you can set the repo variable RUN_ONLY_TEST in your repo
    (Repo -> Settings -> Security -> Actions -> Variables) to run only that test.

commit 140ba45895de8ebfb3e2517b0ddee58729979c29
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri May 9 19:32:06 2025 +1000

    Move misc-agent.o to LIBSSH_OBJS.
    
    It's needed by the fuzzer.

commit 3357bf2fe2d11b6ed4465c1ed2871bd1099cbbc5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri May 9 19:08:36 2025 +1000

    Put PRIV_ECDSA back, it's still used.
    
    Should fix oss-fuzz test.

commit f5726215957bb34e18bb872d527845c2f64e2389
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 8 18:56:39 2025 +1000

    Since it's unused, make dirfd() take void *.
    
    Some platforms (eg Old BSDs) in some configurations define DIR to "void
    *", which causes compile errors in the no-op implementation.

commit 1511f113a27d8aafe080aa6493cb3c0cf2b5abe0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 8 11:38:24 2025 +1000

    Add no-op implmentation of dirfd().
    
    Fixes build on pre-POSIX.1 2008 systems.

commit 086369736a9496b39af0d9f09443fa81b59b7f05
Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Wed Apr 16 10:18:34 2025 +1000

    ssh-agent: exit 0 from SIGTERM under systemd socket-activation
    
    When the ssh-agent service is configured to be launched under systemd
    socket-activation, the user can inspect the status of the agent with
    something like:
    
        systemctl --user status ssh-agent.service
    
    If the user does:
    
        systemctl --user stop ssh-agent.service
    
    it causes the `systemd --user` supervisor to send a SIGTERM to the
    agent, which terminates while leaving the systemd-managed socket in
    place.  That's good, and as expected. (If the user wants to close the
    socket, they can do "systemctl --user stop ssh-agent.socket" instead)
    
    But because ssh-agent exits with code 2 in response to a SIGTERM, the
    supervisor marks the service as "failed", even though the state of the
    supervised service is exactly the same as during session startup (not
    running, ready to launch when a client connects to the socket).
    
    This change makes ssh-agent exit cleanly (code 0) in response to a
    SIGTERM when launched under socket activation. This aligns the systemd
    supervisor's understanding of the state of supervised ssh-agent with
    reality.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

commit 755c3d082e59e6884f28d30e6333a1444e9173d1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed May 7 21:05:06 2025 +1000

    Skip d_type check on platforms that don't have it.
    
    On those, the subsequent stat() should catch the sockets.

commit 207289a5663bdf49903e1aeb938dcc0924e2ac63
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed May 7 10:44:26 2025 +0000

    upstream: Rename sockaddr_un sun -> sunaddr.
    
    This makes things easier in -portable, where on Solaris an derivatives
    "sun" is defined to "1", causing compilation errors.  ok deraadt@.
    
    OpenBSD-Commit-ID: 0669043afb49856b57b382f0489221bd98305d3b

commit 7cc8e150d51a4545b86d996692b541419b35d1a3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue May 6 06:05:48 2025 +0000

    upstream: remove DSA from the regression/unit test suite too.
    
    OpenBSD-Regress-ID: 4424d2eaf0bce3887318ef6d18de6c06f3617d6e

commit 0404fa799746c283325a463c363436eb152daefc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 15 05:31:24 2025 +0000

    upstream: another missing ifdef
    
    OpenBSD-Regress-ID: 4f71f8f122eac4cbf7f1d2088a9be45317dd3e4a

commit c5dbbe8805caaee132545ab4cffd3b2221e80975
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 15 05:00:13 2025 +0000

    upstream: missing ifdef
    
    OpenBSD-Regress-ID: 7260fb672de5738c17dec06c71a5be0186bb2b09

commit 93e904a673a632604525fdc98b940b7996f1ce54
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 7 04:10:21 2025 +0000

    upstream: memory leak on error path; bz3821
    
    OpenBSD-Commit-ID: 65577596a15ad6dd9a1ab3fc24c1c31303ee6e2b

commit 55b38ff4d7286c8fac2a472da664462e0f2d75e0
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Tue May 6 15:15:05 2025 +0000

    upstream: test ssh-agent with the -T flag to force the old /tmp
    
    location rather than inside the homedir.  During relink operation,
    /.ssh/agent was created which is surprising.  This test sequence could use
    some improvement so this is a temporary fix. observed by florian, change ok
    semarie
    
    OpenBSD-Commit-ID: c7246a6b519ac390ca550719f91acfdaef1fa0f0

commit a32d28d792567253bb601362f36391f155f8f772
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue May 6 05:40:56 2025 +0000

    upstream: finally remove DSA signature support from OpenSSH.
    
    feedback/ok tb@, ok deraadt@
    
    OpenBSD-Commit-ID: bfe6ee73c1b676c81a2901030c791f8ec888228f

commit 928f8dcc1bb622c25be409c34374b655d0149373
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 5 05:51:11 2025 +0000

    upstream: Now that there's an I-D for certificate keys, refer to
    
    that instead of the much more basic format description we had previously.
    
    OpenBSD-Commit-ID: cf01e0727a813fee8626ad7b3aa240621cc92014

commit fe883543bece18c975fa53aa02104f0433645d99
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Mon May 5 05:47:28 2025 +0000

    upstream: - add full stop to the text in -a - move the -U and -u
    
    text to the correct place
    
    OpenBSD-Commit-ID: 2fb484337a0978c703f61983bb14bc5cbaf898c2

commit 5fd6ef297dec23e3574646b6334087131230d0a6
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 6 19:01:00 2025 +1000

    Add minimal implementations of fstatat and unlinkat.
    
    Fixes build on some pre-POSIX.1-2008 platforms.

commit d2480827b3ef6ec119965822afdff35d734b2dee
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 6 08:15:34 2025 +1000

    New location of cygwin setup.

commit 57eb87b15bd0343372f99d661ce95efb25a16f1e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 6 08:07:23 2025 +1000

    Boringssl now puts libcrypto in a different place.

commit 61525ba967ac1bb7394ea0792aa6030bcbbad049
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon May 5 20:45:42 2025 +1000

    Handle systems that don't have st_mtim.
    
    Ignores nanoseconds, but it's checking for >1h old so a few nanoseconds
    shouldn't matter much.  Fixes build on Mac OS X.

commit 27861e9b15151898841097c14ee974c026093131
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon May 5 19:09:25 2025 +1000

    Supply timespecsub if needed.

commit 7c0e6626e4be53efcfbb92f0c6382a76f1138e38
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon May 5 19:08:48 2025 +1000

    includes.h for compat, time.h for clock_gettime.

commit 7a7cc3cf721fe7fe9f4925d92bb7c694b8550a7f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon May 5 18:51:34 2025 +1000

    Cygwin install in back on D:

commit 6ab8133c067a8e91ba69ce7ca04f95b50f2f2d7b
Author: Damien Miller <djm@mindrot.org>
Date:   Mon May 5 14:59:30 2025 +1000

    depend

commit 12912429cf39cfeca97dd18a8f875ad9824d1751
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 5 03:35:06 2025 +0000

    upstream: missing file in previous commit
    
    OpenBSD-Commit-ID: e526c97fcb2fd9f0b7b229720972426ab437d7eb

commit 80162f9d7e7eadca4ffd0bd1c015d38cb1821ab6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 5 02:48:06 2025 +0000

    upstream: Move agent listener sockets from /tmp to under
    
    ~/.ssh/agent for both ssh-agent(1) and forwarded sockets in sshd(8).
    
    This ensures processes (such as Firefox) that have restricted
    filesystem access that includes /tmp (via unveil(3)) do not have the
    ability to use keys in an agent.
    
    Moving the default directory has the consequence that the OS will no
    longer clean up stale agent sockets, so ssh-agent now gains this
    ability.
    
    To support $HOME on NFS, the socket path includes a truncated hash of
    the hostname. ssh-agent will by default only clean up sockets from
    the same hostname.
    
    ssh-agent gains some new flags: -U suppresses the automatic cleanup
    of stale sockets when it starts. -u forces a cleanup without
    keeping a running agent, -uu forces a cleanup that ignores the
    hostname. -T makes ssh-agent put the socket back in /tmp.
    
    feedback deraadt@ naddy@, doitdoitdoit deraadt@
    
    OpenBSD-Commit-ID: 8383dabd98092fe5498d5f7f15c7d314b03a93e1

commit 566443b5f5d7bc4c5310313b4e46232760850c7a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 5 02:40:30 2025 +0000

    upstream: correct log messages; the reap function is used for more
    
    than just the preauth process now
    
    OpenBSD-Commit-ID: 768c5b674bd77802bb197c31dba78559f1174c02

commit e048230106fb3f5e7cc07abc311c6feb5f52fd05
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Apr 30 05:26:15 2025 +0000

    upstream: make writing known_hosts lines more atomic, by writing
    
    the entire line in one operation and using unbuffered stdio.
    
    Usually writes to this file are serialised on the "Are you sure you
    want to continue connecting?" prompt, but if host key checking is
    disabled and connections were being made with high concurrency
    then interleaved writes might have been possible.
    
    feedback/ok deraadt@ millert@
    
    OpenBSD-Commit-ID: d11222b49dabe5cfe0937b49cb439ba3d4847b08

commit c991273c18afc490313a9f282383eaf59d9c13b9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Apr 30 05:23:15 2025 +0000

    upstream: fix a out-of-bounds read if the known_hosts file is
    
    truncated after the hostname.
    
    Reported by the OpenAI Security Research Team
    
    ok deraadt@
    
    OpenBSD-Commit-ID: c0b516d7c80c4779a403826f73bcd8adbbc54ebd

commit b5b405fee7f3e79d44e2d2971a4b6b4cc53f112e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Apr 20 09:07:57 2025 +1000

    Set Windows permssions on regress dir.
    
    Prevents "unprotected private key file" error when running tests.

commit 76631fdd04824c3e50ea6551d3611b1fe0216a41
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 18 08:18:52 2025 +1000

    Add 10.0 branch to test status page.

commit c627b468d3b99e487e2b24c90958ae57e633d681
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 18 08:14:16 2025 +1000

    cygwin-install-action now puts setup.exe on D:

commit 52bddbc1a7f53a1e5c871767913648eb639ac6d5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 18 08:10:32 2025 +1000

    Include time.h for clock_gettime().

commit 9b50cb171b5c56184ce6fa3994ce62f9882d2daf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 17 16:51:14 2025 +1000

    Add includes.h for new tests.
    
    Fixes builds on older platforms.

commit 46e52fdae08b89264a0b23f94391c2bf637def34
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 16 22:29:17 2025 +1000

    Provide INFINITY if it's not provided.
    
    INFINITY is specified in c99, so define if not provided.

commit 849c2fd894aa87a7e40c71e8d5bda5392b1205be
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Apr 15 21:58:49 2025 +1000

    Look for sqrt(), possibly in libm.
    
    The unit tests now use sqrt(), which in some platforms (notably
    DragonFlyBSD and Solaris) is not in libc but rather libm.  Since only
    the unit tests use this, add TESTLIBS and if necessary put libm in it.

commit 1ec5b39f1f673beac039bb42c98a11aa2b08a0b2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Apr 15 09:22:25 2025 +0000

    upstream: Cast signalled_keydrop to int when logging to prevent warning
    
    on platforms where sig_atomic_t is not the same as int.  bz#3811, patch from
    jlduran at gmail com.
    
    OpenBSD-Commit-ID: b6bc9e9006e7f81ade57d41a48623a4323deca6c

commit f3d465530e75cb6c02e2cde1d15e6c4bb51ebfd9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 15 04:00:42 2025 +0000

    upstream: basic benchmarking support for the unit test framework enable
    
    with "make UNITTEST_BENCHMARK=yes"
    
    ok dtucker@
    
    OpenBSD-Regress-ID: 7f16a2e247f860897ca46ff87bccbe6002a32564

commit 609fe2cae2459d721ac11d23cd27b8a94397ef3c
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Mon Apr 14 05:41:42 2025 +0000

    upstream: rework the text for -3 to make it clearer what default
    
    behaviour is, and adjust the text for -R to make them more consistent;
    
    issue raised by mikhail mp39590;
    behaviour explained by naddy
    
    ok djm
    
    OpenBSD-Commit-ID: 15ff3bd1518d86c84fa8e91d7aa72cfdb41dccc8

commit 8725dbc5b5fcc3e326fc71189ef8dba4333362cc
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Apr 9 17:02:17 2025 +1000

    update version numbers

commit cc7feb9458ad3b893b53dc9c7500d1affd208bde
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Apr 9 07:00:21 2025 +0000

    upstream: openssh-10.0
    
    OpenBSD-Commit-ID: db5b4a1f1c9e988f8f166b56dc5643606294b403

commit fc86875e6acb36401dfc1dfb6b628a9d1460f367
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Apr 9 07:00:03 2025 +0000

    upstream: Fix logic error in DisableForwarding option. This option
    
    was documented as disabling X11 and agent forwarding but it failed to do so.
    Spotted by Tim Rice.
    
    OpenBSD-Commit-ID: fffc89195968f7eedd2fc57f0b1f1ef3193f5ed1

commit dd73459e351b0a2908aed90910c8ff9b0b381c6d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Apr 9 01:24:40 2025 +0000

    upstream: oops, I accidentally backed out the typo fix
    
    OpenBSD-Commit-ID: f485f79bf3e9ebbe1de13ac96150cf458956cfd8

commit 0cb945891944bada5850e85d60afa3c807cf1af6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Apr 9 01:23:47 2025 +0000

    upstream: typo
    
    OpenBSD-Commit-ID: f912725c7d303720706b3ccfb2cb846d46296d13

commit cd4a6bd50b658d707867caa1f5aa40b35c2b6c19
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Apr 9 09:49:55 2025 +1000

    initialise websafe_allowlist in agent fuzzer

commit 55b7cb48af96c1102ef8ab5a73bb329cbed30945
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 8 23:10:46 2025 +0000

    upstream: typo
    
    OpenBSD-Regress-ID: 08477b936d1d0c1e8a98aa1c0e1bdde8871894c9

commit 985d8cbcd3438cc36b4e709476f1783e358ddfb1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 8 23:10:08 2025 +0000

    upstream: typo
    
    OpenBSD-Commit-ID: 6e683e13e72bf1e43bbd3bbc6a8332d5a98bdc99

commit 000c3d14e94d8f7597087c457260ea9417045b65
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Apr 7 08:12:22 2025 +0000

    upstream: Include time.h for time().
    
    Fixes warning on some platforms when building without openssl.
    
    OpenBSD-Commit-ID: 04ca29b8eaae1860c7adde3e770baa1866e30a54

commit 49b8b9bf829e08af22366530614a5e59ac341ca9
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Wed Apr 2 04:28:03 2025 +0000

    upstream: Wrap #include <openssl/dsa.h> in #ifdef WITH_DSA
    
    ok djm
    
    OpenBSD-Commit-ID: ed01a7c102243f84e4a317aefb431916d98aab15

commit f80fb819e5521e13f167edbcc3eed66e22ad0c2a
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Apr 3 09:10:19 2025 +1100

    remove all instances of -pie from LDFLAGS
    
    Previously only the first instance of this flag was removed.
    Unbreaks build on OpenSUSE Tumbleweed. Patch from Antonio Larrosa

commit 6c9872faa1c297a84c6d3e3b95a927be99eadbf6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 1 23:23:20 2025 +0000

    upstream: remove ability to enable DSA support. Actual code will be
    
    g/c'd separately. ok deraadt@
    
    OpenBSD-Commit-ID: 2a032b75156c4d922e8343fa97ff6bc227f09819

commit 8460aaa4e1f8680f03cc5334556b9440b401f010
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Mar 28 21:45:55 2025 +0000

    upstream: Add TEST_SSH_SSHD_ENV to sshd lines here too.
    
    OpenBSD-Regress-ID: 045f2c88b42d694b404db51c5de5eca20d748ff1

commit 5e60f5937b9c33190b9d7614f72d85d4a9b38d3d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Mar 28 06:04:07 2025 +0000

    upstream: Pass "ControlMaster no" to ssh when invoked by scp & sftp.
    
    If you have ControlMaster auto (or yes) in your config, and the
    first connection you make is via scp or sftp, then you may get a
    few unexpected options applied to it (eg ForwardX11 no), since sftp
    and sftp explicitly disable those for reasons.  These effects will
    persist beyond the initial scp or sftp command.
    
    This explicitly disables persistent session *creation* by scp and sftp.
    It will not prevent them from using an existing session if one has
    already been created.
    
    From Github PR#557, ok djm@ kn@
    
    OpenBSD-Commit-ID: 9dad7c737466837e0150c4318920f46d844770c4

commit bbd36869dfb4b770cc9e6a345c04a585a0955aec
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Mar 28 05:41:15 2025 +0000

    upstream: Set sshd environment variables during sshd test run too.
    
    OpenBSD-Regress-ID: 50cb325d92c390a2909662c901f6ac5d80b6f74d

commit 98f05b1484daddef2f56b79e24540523b5016143
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Mar 28 05:36:24 2025 +0000

    upstream: Add TEST_SSH_SSHD_ENV variable which is added to sshd's
    
    environment. Will be used in Portable to tweak behaviour of tcmalloc's
    debugging.
    
    OpenBSD-Regress-ID: 67e38c3c4517ddb72c8a3549a3325a166d7bb6d6

commit 8cd9ed4df0eccc825eca0c45354a37332e125e38
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Mar 28 05:33:30 2025 +0000

    upstream: chown log directory in addition to log files.
    
    OpenBSD-Regress-ID: b520d54a0bbf2c6554413c798218bda26b385ad9

commit e32de6bf4f3229d4838beb127de45eed1377ccc5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 28 16:47:58 2025 +1100

    Be explicit about environment variables for tests.
    
    This will make it easier to reproduce a test failure by cut-and-paste of
    the corresponding line from the github log.

commit 77a3e6ba47381547b3fe4b29223256f276fbd07e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 28 16:46:40 2025 +1100

    Add tcmalloc flags to TEST_SSH_SSHD_ENV.
    
    This will get passed to sshd via test-exec.sh.

commit a73890e340fbd6121251854b658a72d738b86c84
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Mar 27 23:04:44 2025 +1100

    Add PuTTY 0.81, 0.82 and 0.83 to tests.

commit 90a28de0d49570324d1695c0b4686354ef3bcae0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Mar 27 22:30:40 2025 +1100

    Include TCMALLOC_STACKTRACE_METHOD in output.
    
    If TCMALLOC_STACKTRACE_METHOD happens to be set, include it in the debug
    output to make reproducing test cases easier.

commit fd5a6bb6dd7657c4bd8cd0ee11d5c8ddf0d927b2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Mar 27 20:15:11 2025 +1100

    Test with-linux-memlock-onfault in kitchensink.

commit 22330711e2459c23d9736ee16e0e2ee0fcc30b9a
Author: Collin Funk <collin.funk1@gmail.com>
Date:   Wed Mar 26 18:24:59 2025 -0700

    Include fcntl.h so AT_FDCWD does not get redefined.

commit 6c49e5f7dcaf886b4a702a6c003cae9dca04d3ea
Author: Daniil Tatianin <d-tatianin@yandex-team.ru>
Date:   Thu Feb 27 11:37:13 2025 +0300

    Add support for locking memory on Linux
    
    Linux wakes up kcompactd threads in order to make more contiguous memory
    available on the system, it does this by migrating live movable pages
    (actively modifying live processes' page tables and constantly flooding
    them with page invalidation IPIs, which can be up to millions per
    second), which causes the process to become unresponsive for up to
    seconds or even minutes in some severe cases. In case of sshd, we want
    to always be able to connect to the system, even if it's under heavy
    kcompactd load.
    
    Introduce an option to protect sshd and its children sessions from being
    compacted by kcompactd (this works in cojunction with
    compact_unevictable_allowed = 0). Note that we depend on MCL_ONFAULT
    being available, which was introduced in linux 4.4. MCL_ONFAULT allows
    the system to lock pages lazily, thus drastically reducing memory usage
    of a locked process (without MCL_ONFAULT, every existing mapping in the
    process is instantly write-faulted).

commit fdc4853c5b1567934d43ab13282f03033cc21325
Author: Daniil Tatianin <d-tatianin@yandex-team.ru>
Date:   Thu Feb 27 11:46:25 2025 +0300

    platform: introduce a way to hook new session start
    
    Previously this was possible via post_fork_child, but ever since sshd
    was split into multiple binaries, this is now no longer possible becase
    of execv.

commit 1b311b6b17be81577514c38e8be4f5740d7df496
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Mar 19 06:11:15 2025 +0000

    upstream: Prevent theoretical NULL deref in throughlocal_sftp.
    
    Coverity CID 405019, although at the moment it's not reachable. ok djm@
    
    OpenBSD-Commit-ID: 630d46c1021b69fbb470e349976c70e9a48b7644

commit 96493ebd6ff48bbb802576e208794a26928569b0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Mar 19 17:35:10 2025 +1100

    Fix workflow syntax again.

commit 575c43fd4c44d376b1771c0fdaf4941021ba88c9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Mar 18 20:54:48 2025 +1100

    Differentiate logfiles better.

commit 8a1294638f3a47d46263ea574fa85c8e115ea893
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Mar 18 20:27:46 2025 +1100

    Fix another typo in workflow.

commit bd9e6bbcc864b3e10c4e11f5aec1b3a5e3a89b55
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Mar 18 18:16:12 2025 +1100

    Fix syntax error in workflow.

commit ce88a1bb4a2e6425752094f7a2eb4adfb0ca7971
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Mar 18 18:13:14 2025 +1100

    Identify each logfile while printing them.

commit b58e429960c4791fc4e30bb7c70d1f77d538b546
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Mar 18 04:53:14 2025 +0000

    upstream: fix NULL dereference for Match conditions missing
    
    arguments, e.g. "Match user". Spotted by Coverity (CID 477813)
    
    OpenBSD-Commit-ID: 13584281cfa23b8ebc41f9d128a6b9464ae960d4

commit 0ce5281f017c3ad7bdcc2bbd9745119a73e0cbb8
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Fri Mar 14 09:49:49 2025 +0000

    upstream: Fix EVP_CIPHER_CTX_ctrl() return checks
    
    While this API tries to translate negative return values (i.e. -1) to 0
    in BoringSSL and LibreSSL, it is still possible for it to return negative
    values in prinicple. We even incorrectly document that -1 can be returned
    while Boring and OpenSSL plead the Fifth.
    
    In OpenSSL 3 there are now code paths that explicitly return -1 and they
    started shifting their return checks to <= 0 - of course they do this in
    inconsistent and sometimes incorrect manner. While these paths aren't
    reachable from ssh right now, who can really tell what happens in the two
    hundred lines of inscrutable bloated mess this has become.
    
    So error check with <= 0 to ensure that we don't accidentally translate an
    error to success.
    
    ok markus schwarze
    
    OpenBSD-Commit-ID: a855c833cf4ecfce43bedc761f26ad924f70483c

commit 2e81100763d5885e500f065b04c16ed87ce74318
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Mar 17 21:35:55 2025 +1100

    Fix debug log path.

commit 442a44970179d70ebb62bba792699eaec978a1db
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 14 16:24:06 2025 +1100

    Also lazily unmount workspace in case of straggers.

commit 20427f6735fe5ddab31911ce5315adc71acf47d8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 14 16:17:39 2025 +1100

    Make sure upstream tests run on correct hardware.

commit 91a2f70a56827ae31649baf17227b0914ac5aa36
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 14 13:47:27 2025 +1100

    Add OpenBSD upstream test on obsdsnap-arm64.

commit c20f7413525602b0ea786d8974d03a81f7ca2a92
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Mar 13 10:45:53 2025 +1100

    rebuild .depend

commit d47ef958b89c6fa809302d654009d3dfabe11b75
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 12 22:43:44 2025 +0000

    upstream: remove assumption that the sshd_config and any configs
    
    included from it can fit in a (possibly enlarged) socket buffer, by having
    the sshd listener mainloop actively manage sending the configuration to the
    sshd-session subprocess.
    
    work by markus@ w/ a little feedback from me;
    ok me and committing on his behalf
    
    OpenBSD-Commit-ID: 8f54451483f64951853074adb76bc4f838eaf3ae

commit 9c90b563943c16418d737433ac478974b8761ee5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 11:46:44 2025 +0000

    upstream: Prime caches for DNS names needed for tests.
    
    When running the SSHFP tests, particularly on an ephemeral VM, the first
    query or two can fail for some reason, presumably because something isn't
    fully initialized or something.  To work around this, issue queries for the
    names we'll need before we need them.
    
    OpenBSD-Regress-ID: 900841133540e7dead253407db5a874a6ed09eca

commit 10124eefe875a3e4e1cfb84ebe6a613ed3213b78
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 09:06:50 2025 +0000

    upstream: Some dd's don't understand "1m", so handle seperately.
    
    OpenBSD-Regress-ID: 1d983b27c96f28f69d3a288c19e8d8c58e1b2ee3

commit c21c8fc319376c2f5e0da166e9e89a97a245ae72
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Mar 11 19:17:46 2025 +1100

    Lazily unmount github workspace at end of workflow.
    
    Sometimes when a test times out the workspace is still busy when we try
    to unmount it, which leaves the runner unusable until it's cleaned up
    manually. We try to unmount this in the first step, but that usually
    doesn't work since it fails during setup before it starts our workflow.
    Move it to the end and make it a lazy unmount so it hopefully works
    eventually.

commit 4bcbac742968f5086cfd4c570a51de25ef77931f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 07:50:20 2025 +0000

    upstream: Add regress test for sftp resume.
    
    OpenBSD-Regress-ID: 37f629b3014338fa23a85df1e1bb320ea12282e1

commit e2c4f070b43a4fd7d59a9350e2fe78df605830b5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 07:46:02 2025 +0000

    upstream: Use ssh binary instead of the (smaller) script when
    
    preparing test data files since it's faster.
    
    OpenBSD-Regress-ID: 4215e42682fdb73e131e10645d4a1a23a91d64f5

commit 62f02e95ba5cda4649c482d30f4370e2360eb94d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 07:43:45 2025 +0000

    upstream: Set up dbclient's known_hosts as it expects.
    
    OpenBSD-Regress-ID: 9e0898e8423237ce5023be53787bb4062e0d0418

commit 395284bd52887dbaf7e78200c857d7f2d9ce398e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 07:43:03 2025 +0000

    upstream: Use $DBCLIENT to access dbclient for consistency.
    
    OpenBSD-Regress-ID: 81e1b41e1ffc49aba1e6fcaeb6242f3b7875ea3c

commit 97e10c0005a784622c61cb4e8bb7858b410bbcc6
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 07:42:08 2025 +0000

    upstream: Check if dbclient supports SHA1 before trying SHA1-based
    
    KEX.
    
    Dropbear 2025.87 removed SHA1 support by default, which means
    diffie-hellman-group14-sha1 is not available.  Unfortunately there isn't a
    flag to query supported KEX, so instead check MACs and if it doesn't have
    SHA1 methods, assuming SHA1 based KEXes are likewise not available.  Spotted
    by anton@.
    
    OpenBSD-Regress-ID: acfa8e26c001cb18b9fb81a27271c3b51288d304

commit 29a5127f808d00aa539fd27d83a65c2c56179b0e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Mar 11 07:48:51 2025 +0000

    upstream: Set highwater when resuming a "put". Prevents bogus "server
    
    reordered acks" debug message.  ok djm@
    
    OpenBSD-Commit-ID: aa7f6d0fc2e893c8c278ea3e6e0974c2eca83f5d

commit 6575859d7acb110acf408707f98ed9744ca7d692
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Mar 3 06:54:37 2025 +0000

    upstream: Test for %-token and env var expansion in SetEnv.
    
    OpenBSD-Regress-ID: bd6139a6177ac4afb29a0ce4afc23567b22ef9f9

commit fd7ad8d7bf7dbdeb8f11a8b51aa9d31df1a17e52
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Mar 2 07:41:06 2025 +0000

    upstream: Also test User expansions when supplied via -l option and
    
    user@host.
    
    OpenBSD-Regress-ID: 56415859260b53ef0dd20f71225ba5fdf6320f50

commit e6cfd783f1491b502db9322aa970822c63f1667d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Mar 1 06:12:47 2025 +0000

    upstream: Tests for User expansion of %-tokens and environment
    
    variables.
    
    OpenBSD-Regress-ID: 7ed21dd0e09fb1f3537b8b177f171018aa501628

commit 197e503b8e4b642ce0f405a5d65da4256fa96431
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 16:25:58 2024 +0000

    upstream: use glob(3) wildcards in AuthorizedKeys/PrincipalsFile
    
    tests to exercise this feature; ok dtucker
    
    OpenBSD-Regress-ID: 7f7b19c0b05b1862cc6521ce61b2b301a3f9cc3b

commit 396202180180a4ac16788d469508a348789dafa1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 10:37:42 2024 +0000

    upstream: implement attestation verification for ED25519 keys
    
    OpenBSD-Regress-ID: c44fa5cdb434375a8b5545fdb4fc651061afca1f

commit b49875428cda9c16c5bd52552100da2b419cda5f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Mar 3 06:53:09 2025 +0000

    upstream: Add %-token and environment variable expansion to SetEnv.
    
    feedback deraadt@ jmc@, nits and ok djm@
    
    OpenBSD-Commit-ID: 2f6e5070481cb73e6f35fd1c6608c1eeff88a5c1

commit b6bba67e6c31d268480773e4fed16d0a32b4218e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Mar 2 22:44:00 2025 +0000

    upstream: fix PerSourcePenalty incorrectly using "crash" penalty when
    
    LoginGraceTime was exceeded. Reported by irwin AT princeton.edu via bz3797
    
    OpenBSD-Commit-ID: 1ba3e490a5a9451359618c550d995380af454d25

commit 38d69fee1b06948f160d94abd07b6b297630d30a
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Mar 2 22:06:53 2025 +1100

    include __builtin_popcount replacement function
    
    Some systems/compilers lack __builtin_popcount(), so replace it as
    necessary. Reported by Dennis Clarke; ok dtucker@

commit c94138d02a45dda5015f38f5a60b0bdde29019c1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Mar 2 11:03:13 2025 +0000

    upstream: whitespace
    
    OpenBSD-Commit-ID: 1bd8953a37451ef7e0991f9fceec5e8005fe986a

commit 65d2c59628e68e166046efa69e76c1d395a8df6e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Mar 2 07:02:49 2025 +0000

    upstream: Make a copy of the user when handling ssh -l, so that
    
    later during User token expansion we don't end up freeing a member of argv.
    Spotted by anton@'s regress tests.
    
    OpenBSD-Commit-ID: 2f671a4f5726b66d123b88b1fdd1a90581339955

commit bd30cf784d6e825ef71592fb723c41d4f2fd407b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Mar 1 06:11:26 2025 +0000

    upstream: Allow %-token and environment variable expansion in User,
    
    with the exception of %r and %C which are self-referential.  Requested in
    bz#3477, ok djm@, man page improvements jmc@
    
    OpenBSD-Commit-ID: caeb46251ee073662f6f5864c6f7b92d8ac80fa8

commit 94f59dcfc57f95ae044f75c3ce544329c8956c35
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Mar 1 10:28:59 2025 +1100

    Rebuild config files if Makefile changes.
    
    This ensures paths are updated if they are changed by re-running configure.
    Patch from rapier at psc.edu.

commit dfd9880585db1570656022f9fe1519df673f7b8a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Feb 26 18:16:03 2025 +1100

    Check for le32toh, le64toh, htole64 individually.
    
    It appears that at least some versions of endian.h in glibc do not have
    the latter two, so check for and replace each one individually.
    bz#3794, ok djm@

commit cb99e8eb228df366af33f4fe88d7a9dd0dbf0756
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 25 06:25:30 2025 +0000

    upstream: ressurect fix for "match invalid-user" that got clobbered
    
    by 1.423
    
    OpenBSD-Commit-ID: d18bf0945976e0f3467d710d4bc8bdbe181c0567

commit 487cf4c18c123b66c1f3f733398cd37e6b2ab6ab
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Fri Feb 21 18:22:41 2025 +0000

    upstream: Also prohibit , (comma) in hostnames, proposed by David
    
    Leadbeater ok djm millert
    
    OpenBSD-Commit-ID: 2837fa31dc6e81976f510f0a259edaa559b20b07

commit 3bc6de98c830bd5207f6c371ba69c5874f06305b
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Feb 24 17:27:50 2025 +1100

    Try to fix github tcmalloc target failure
    
    tcmalloc may, depending on the stacktrace generator it uses, create
    pipe(2) fds during shared library initialisation. These will later
    get clobbered by ssh/sshd calling closefrom() and chaos will ensue.
    Tell tcmalloc to use an unwinder that doesn't pull this stuff.

commit 922e54bbfe8c8479453693ef52350338f0c19124
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Feb 21 13:44:35 2025 +1100

    cleanup last mention of ubuntu-20.04

commit bc4b3f6dc1738d389e5c9dcca8c56d7e153fee49
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Feb 21 13:44:13 2025 +1100

    prune gcc/clang versions to be tested
    
    Test only the oldest and latest versions of each

commit 94b73755f931d592a612ef5cb998694643eab5ff
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Feb 21 11:30:22 2025 +1100

    Update AWS-LC version number
    
    Patch from Shubham Mittal bz bz3792

commit 6887099fae6d9f3482e1075d034e9343dc413200
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Feb 21 11:22:34 2025 +1100

    adjust workflows for ubuntu version transition
    
    remove workflows for unsupported compilers, add a few for additional
    supported compilers, move some workflows to run on ubuntu-latest

commit 33bb47e6f74f2ca8093946e6f462d655a9ae46d3
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Feb 20 17:10:32 2025 +1100

    Add ubuntu-*-arm test runners

commit a0c95fbb215b2168fa51b15906e2d6990d7fef6b
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Feb 20 17:03:28 2025 +1100

    remove ubuntu-20.04 Github action runners
    
    ubuntu-20.04 is deprecated now, so migrate all its unique runners
    to ubuntu-22.04.
    
    ok dtucker@

commit 0cbeedba81b57c56379e1d202b9ccd3b72af7ddc
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Feb 18 19:03:42 2025 +1100

    openssh-9.9p2

commit 0832aac79517611dd4de93ad0a83577994d9c907
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 18 08:02:48 2025 +0000

    upstream: Fix cases where error codes were not correctly set
    
    Reported by the Qualys Security Advisory team. ok markus@
    
    OpenBSD-Commit-ID: 7bcd4ffe0fa1e27ff98d451fb9c22f5fae6e610d

commit 6ce00f0c2ecbb9f75023dbe627ee6460bcec78c2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 18 08:02:12 2025 +0000

    upstream: Don't reply to PING in preauth phase or during KEX
    
    Reported by the Qualys Security Advisory team. ok markus@
    
    OpenBSD-Commit-ID: c656ac4abd1504389d1733d85152044b15830217

commit 9e5bd74a85192c00a842f63d7ab788713b4284c3
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Sat Feb 15 06:48:56 2025 +0000

    upstream: - use \& when contructs like "e.g." end a line, to avoid
    
    double spacing - macro is Qq not Oq
    
    OpenBSD-Commit-ID: 17e5d2d7f288cc7fc536e3af252224525f9fb43a

commit f519e71fb7a46314ae16e2a75490649dc0bd01a2
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Feb 15 13:12:40 2025 +1100

    depend

commit 9131ac64b0ebe66dc1de9d44bf8d1bd64a24c350
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Feb 15 01:52:07 2025 +0000

    upstream: add "Match version" support to ssh_config. Allows
    
    matching on the local version of OpenSSH, e.g. "Match version OpenSSH_10.*"
    
    ok markus@
    
    OpenBSD-Commit-ID: c0cb504d0b9e43ccf12e68a544a7cd625e89758d

commit 192a20df00c8a56fe7d92ffa23d959c865d7fb9e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Feb 15 01:50:47 2025 +0000

    upstream: Add support for "Match sessiontype" to ssh_config. Allows
    
    matching on the type of session requested, either "shell" for interactive
    sessions, "exec" for command execution sessions, "subsystem" for subsystem
    requests, such as sftp, or "none" for transport/forwarding-only sessions.
    
    ok markus@
    
    OpenBSD-Commit-ID: eff5c001aecb2283d36639cfb28c0935a8bfd468

commit caa3c0c77082888236b0b0c4feb3e6879731b3ba
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Feb 15 01:48:30 2025 +0000

    upstream: "Match command ..." support for ssh_config to allow
    
    matching on the remote command specified on the commandline.
    
    Also relaxes matching rules for `Match tagged` to allow
    `Match tagged ""` to match an empty tag value. This also works
    for command.
    
    ok markus@
    
    OpenBSD-Commit-ID: 00dcfea425bf58d824bf5e3464cfc2409121b60d

commit 38f6000e9851a00e2e4b8e1eb4ea6a243ef7e6a3
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Feb 11 10:32:26 2025 +1100

    depend

commit aa1409e7a0a5605f0127651a3ba5a348666325bc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Feb 10 23:19:26 2025 +0000

    upstream: include arguments the command was invoked with, and
    
    operating system name, version and architecture in startup debugging output;
    ok dtucker
    
    OpenBSD-Commit-ID: 2a509d319aaf31a6bf9998e1842832883fbc3edd

commit 857ac20f5fe19f183defba5dbf4b7d9e6400230c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Feb 10 23:16:51 2025 +0000

    upstream: include line number in Match debug messages, makes it a
    
    little easier to see what's going on
    
    OpenBSD-Commit-ID: 1fcf4aa2ee667711b9497ded0fa52d757c69b1df

commit af49d474e481d2d78b2f06b06a06b0b37629358e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Feb 10 23:00:29 2025 +0000

    upstream: fix "Match invalid-user" from incorrectly being activated
    
    in initial configuration pass when no other predicates were present on the
    match line
    
    OpenBSD-Commit-ID: 02703b4bd207fafd03788bc4e7774bf80be6c9a8

commit 1c67bae3f5834e48ded71c406f2039dea6e536db
Author: schwarze@openbsd.org <schwarze@openbsd.org>
Date:   Sun Feb 9 18:24:08 2025 +0000

    upstream: In a section 1 manual, use the plain English words
    
    "standard output" rather than the overly technical abbreviation "stdout" - we
    are not talking about a device file or a FILE * object here. Issue reported
    by <onf at disroot dot org> on the groff mailing list.
    
    OpenBSD-Commit-ID: a0816999f970e6159523bed8484f62c42ec93109

commit 85b3d68dd931416ede657f371f1d60cdc3a66f34
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 17 00:09:41 2025 +0000

    upstream: Fix debug logging of user specific delay. Patch from
    
    Achim Leitner (fjl5) via github PR#552.
    
    OpenBSD-Commit-ID: 834a869ed9b15058d3c1ef0cd75402ef989255d8

commit e4e5b06fdf4532705669c0ae944b364022d16b9d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jan 16 06:37:10 2025 +0000

    upstream: Call log_init in sshd-auth and sshd-session immediately
    
    after parsing the config file so that any log settings set in the config file
    take effect immediately.  Move version banners to immediately after that, and
    make them distinct per binary.  ok djm@
    
    OpenBSD-Commit-ID: acf3d090638edf9b6e6f78eed96b537fe671f0f5

commit 0643994b20f2cc54bca80842a984b3052ff1a6a9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jan 15 22:23:13 2025 +0000

    upstream: Use strprefix helper when processing sshd -C test args
    
    instead of counting bytes by hand.  ok djm@
    
    OpenBSD-Commit-ID: 2866d369d96fe04bf76112260ac37e489f98a9a9

commit 66efd0fbb6b8b95f8a520f2cdf8ede14e62b30b3
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Feb 6 09:38:09 2025 +1100

    add support for AWS-LC (AWS libcrypto)
    
    Patch from Shubham Mittal via bz3784; ok dtucker

commit 826483d51a9fee60703298bbf839d9ce37943474
Author: Tim Rice <tim@multitalents.net>
Date:   Mon Dec 16 15:36:54 2024 -0800

    fix old typo (s/SYSVINITSTOPT/SYSVINITSTOP/)

commit 1a8ce460f1d0c3f7304edba0733783b57b430e21
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Dec 12 09:09:09 2024 +0000

    upstream: Plug leak on error path, spotted by Coverity. ok djm@
    
    OpenBSD-Commit-ID: b1859959374b4709569760cae0866d22a16606d3

commit 924f996144fc0ae1a659fadcfc2237d1ae935fc4
Author: Xavier Hsinyuan <me@lstlx.com>
Date:   Mon Dec 9 11:21:05 2024 +0800

    Add $(srcdir) for standalone sk-libfido2 make target.
    
    Fix out-of-tree build failure due to incorrect path for `sk-usbhid.c`.

commit bbc9c18e84de29c83fa03e69290979fcca54a2b2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Dec 7 10:12:19 2024 +0000

    upstream: replace bespoke logging of MaxSessions enforcement with
    
    new ratelimited logging infrastructure.
    
    Add ratelimits to logging of connections dropped by PerSourcePenalties
    
    ok dtucker
    
    OpenBSD-Commit-ID: f22fe7c39607e4361aadf95e33773ffd68c59489

commit 5a6ddf946cf105189c2c99a04f86ce95edc55fc5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Dec 7 10:05:36 2024 +0000

    upstream: add infrastructure for ratelimited logging; feedback/ok
    
    dtucker
    
    OpenBSD-Commit-ID: 18a83e5ac09d59aaf1e834fd6b796db89dd842e7

commit 85f0c1e75e8f6c5d83b8070918ee2f6ab16d403e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 16:24:27 2024 +0000

    upstream: allow glob(3) patterns for sshd_config AuthorizedKeysFile
    
    and AuthorizedPrincipalsFile directives; bz2755 ok dtucker
    
    OpenBSD-Commit-ID: 3e3e05a17fca39bba78b993a07b44664519adf7f

commit 9a9ffee6e10bcd039f1f9385599577441ebe542a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 16:21:48 2024 +0000

    upstream: support VersionAddendum in the client, mirroring the
    
    option of the same name in the server; bz2745 ok dtucker@
    
    OpenBSD-Commit-ID: 6ff7905b3f9806649bde750515786553fb89cdf4

commit 41ab0ccecd68232e196efae5e224b31ca104c423
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 16:02:12 2024 +0000

    upstream: clarify encoding of options/extensions; bz2389
    
    OpenBSD-Commit-ID: c4e92356d44dfe6d0a4416deecb33d1d1eba016c

commit 5488810359f0fd91e2f7b919c70a3798e46376cb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 15:17:15 2024 +0000

    upstream: ignore SIGPIPE here; some downstreams have had this for
    
    years...
    
    OpenBSD-Commit-ID: 73674ee4f8ceb8fc9cb8de71d8ddea0c721eb035

commit 4389a792d9078212366eba124a3eed36e009d09e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 6 15:12:56 2024 +0000

    upstream: sync -o option lists with ssh.1; requested jmc@
    
    OpenBSD-Commit-ID: a7ac295b444da7b2ca7a33a52370594f6897f6bb

commit 6b9cd095565ddc5402d5096dce248fa0521dbda3
Author: Fabio Pedretti <pedretti.fabio@gmail.com>
Date:   Mon Oct 16 17:12:24 2023 +0200

    Remove ancient RHL 6.x config in RPM spec.
    
    It looks like build6x options were intended for RHL 6.x
    (the Red Hat distro predating Fedora, not RHEL), but were
    then applied to RHEL.
    
    Completely remove support for this ancient configuration.
    
    Successfully built, installed and run on RHEL 6. This also
    remove a build warning about deprecation of PreReq.

commit 5cacfa798f92b707491375fed748d1d1bcb33ec9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Dec 6 23:54:45 2024 +1100

    Add new hardware-backed signing key for myself.
    
    Retire old non-hardware based signing key.

commit f129b6ee1d4361799e65307216e3a4d5544356b7
Author: Jonas 'Sortie' Termansen <sortie@maxsi.org>
Date:   Sat Nov 2 22:05:45 2024 +0100

    Fix configure implicit declaration and format warnings.

commit 11a5e5179077f73c2d45bcdf3f60153ae3f17815
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Dec 6 07:05:54 2024 +0000

    upstream: Expand $SSH to absolute path if it's not already.
    
    Prevents problem later in increase_datafile_size if ssh is not in
    the path.  Patch from quaresmajose via GHPR#510.
    
    OpenBSD-Regress-ID: 2670a66af8b827410ca7139f0a89f4501cece77b

commit dc2ef8f0944a4ff7ba19e52fd17b4654e6bd9b93
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Dec 6 06:55:28 2024 +0000

    upstream: Change "login again" to "log in again"
    
    in password change message.  From ThinLinc-Zeijlon via github PR#532.
    
    OpenBSD-Commit-ID: fea5e9bc04caf613a118c419f16863733b340cf1

commit 8252f346eb21cd6b30816f905b7d94f10962373e
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Thu Dec 5 22:45:03 2024 +0000

    upstream: catch up documentation: AES-GCM is preferred to AES-CTR
    
    OpenBSD-Commit-ID: 63360924b6834507fe70020edb936f5075043a9e

commit 9a2f4c75081769bd45eba2bf3fab0a32b25f1879
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Dec 6 17:56:17 2024 +1100

    Change text from "login to" to "log in to".
    
    From ThinLinc-Zeijlon via GHPR#532.

commit 24dcf368d816b06136a02845ebd0c7846bf18927
Author: Xavier Hsinyuan <me@lstlx.com>
Date:   Fri Dec 6 11:56:34 2024 +0800

    Fix configure message typo in sk-libfido2 standalone.

commit 1a0cac2f3411a22d69ae6918eff48456b805e73b
Author: Alexander Kanavin <alex@linutronix.de>
Date:   Thu Dec 5 16:26:46 2024 +0100

    Skip 2038 key expiry test on 64 bit time_t systems.
    
    This allows testing Y2038 with system time set to after that (i.e. 2040),
    so that actual Y2038 issues can be exposed, and not masked by key expiry
    errors.
    
    Signed-off-by: Alexander Kanavin <alex@linutronix.de>

commit 6b4611dc1232c5d2c8e43201f580f19aab320c87
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Dec 6 01:45:52 2024 +1100

    Skip 64bit expiry time test on 32bit time_t.

commit c9b7866a7dc5e6c30f5aa9d22dd0bbafda0d496f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Dec 5 14:28:39 2024 +0000

    upstream: Add key expiry test in the 64bit time_t range for additional
    
    coverage. From Alexander Kanavin via bz#3684.
    
    OpenBSD-Regress-ID: bdf6eb3c2421f2e1e11483d03b34c7931d1bccf7

commit 790c913b5fc6ee93ae14793443dc85a0f574b7eb
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Dec 5 19:24:56 2024 +1100

    typo

commit d23a23aaeeabc228792e3fd7eb5f2fa6ae13c482
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Dec 5 08:47:02 2024 +1100

    add a Makefile target for ssh-verify-attestation
    
    Not built by default, but easier than doing it by hand

commit d0ac63d0f8b5f778d5fd326701ef4489bc27635e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Dec 5 06:49:26 2024 +0000

    upstream: De-magic the x11 base port number into a define. ok djm@
    
    OpenBSD-Commit-ID: 23b85ca9d222cb739b9c33ee5e4d6ac9fdeecbfa

commit 9998c93d57bf0f1df2bc93e0bc2d8112c6f8c720
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Dec 5 06:47:00 2024 +0000

    upstream: Prevent integer overflow in x11 port handling. These are
    
    theoretically possible if the admin misconfigures X11DisplayOffset or the
    user misconfigures their own $DISPLAY, but don't happen in normal operation.
    From Suhov Roman via bz#3730, ok djm@
    
    OpenBSD-Commit-ID: e9e3860f1a19b862ccf07dc8ecbe8f1e1034f4ed

commit 8c9ee046d40e4254c6c1711783ea11027b72c3e9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Dec 4 16:42:49 2024 +0000

    upstream: add a work-in-progress tool to verify FIDO attestation
    
    blobs that ssh-keygen can write when enrolling FIDO keys.
    
    OpenBSD-Regress-ID: 6c97bf3f46e48866677ad69f54b77683eb92437f

commit 50c640d874d0246dd0a0d949398c3d7f757c716a
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Dec 4 10:51:13 2024 +0000

    upstream: Don't assume existence of SK provider in test. Patch from
    
    balu.gajjala at gmail via bz#3402.
    
    OpenBSD-Regress-ID: d571932016d07d135b54433d07520b9e1901db43

commit 73d782693144262570d3585b62f16b183170c014
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Dec 4 14:37:55 2024 +0000

    upstream: sync the list of options accepted by -o with ssh_config.5
    
    prompted by bz3455
    
    OpenBSD-Commit-ID: 0ecbfa70aea6c769bcc259defe07182edf461f57

commit 6993d9f0959534b0b7d52e17b95e9e79fb0b3d0a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Dec 4 14:24:20 2024 +0000

    upstream: don't screw up ssh-keygen -l output when the file
    
    contains CR characters; GHPR236 bz3385, fix from Dmitry Belyavskiy
    
    OpenBSD-Commit-ID: e458cf6b0adcea5b69ef4c7ba38e590841d02ef4

commit c0b03c2534946fc114880092177aa4a3683ced2d
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Tue Dec 3 22:30:03 2024 +0000

    upstream: spelling; ok djm@
    
    OpenBSD-Commit-ID: c8ff3f70020451eef214e598117b7ce1a29853ef

commit 97eb247f40167f44324e88a537d5b4fe771a63b2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Dec 3 16:27:53 2024 +0000

    upstream: Remove fallback to compiled-in gropup for dhgex when the
    
    moduli file exists, but does not contain moduli within the client-requested
    range. The fallback behaviour remains for the case where the moduli file does
    not exist (typically, running tests prior to installing). From bz#2793, based
    in part on patch from Joe Testa, ok djm@
    
    OpenBSD-Commit-ID: b1a8c5dbbedf249b42474679ebaf14db7332b1ab

commit 30c746265ebde29806dba77c92fb1fd3803cbf5c
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Tue Dec 3 15:53:51 2024 +0000

    upstream: Remove redundant field of definition check
    
    This will allow us to get rid of EC_GROUP_method_of() in the near future.
    
    ok djm
    
    OpenBSD-Commit-ID: b4a3d2e00990cf5c2ec6881c21ddca67327c2df8

commit eaa1744f34c30740328fd0a0d84b5f2f9e6918c1
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Dec 5 00:59:19 2024 +1100

    don't ignore changes in regress Makefiles
    
    reported by Torben Hansen in bz2880

commit 66e986880b2472fefaad781f10113b138b65ff27
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Dec 5 00:01:33 2024 +1100

    Support systemd-style socket activation in agent
    
    Adds support for systemd LISTEN_PID/LISTEN_FDS socket activation to
    ssh-agent. Activated when these environment variables are set and
    the agent is started with the -d or -D option and no socket path
    is set.
    
    Based on GHPR502 by Daniel Kahn Gillmor, ok dtucker

commit 9b57c099f57152e6c94f633c114f544087f4bdaa
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Dec 4 21:36:01 2024 +1100

    Update readme files to better reflect reality.
    
    Prompted by bz#3738, ok djm@.

commit ffa885db1b960451d426455045d2f51288e48ee8
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Dec 3 14:12:47 2024 +0000

    upstream: Improve description of KbdInteractiveAuthentication.
    
    Based on bz#3658, fixes jmc@ ok markus@ djm@.
    
    OpenBSD-Commit-ID: 9fadb56b9afed554d501acbba911c685acd6ffc2

commit b460f82a67795bba37c6cc6c78f788e5b435b4cb
Author: Jonas 'Sortie' Termansen <sortie@maxsi.org>
Date:   Sat Nov 2 17:53:23 2024 +0100

    Inherit DESTDIR from the environment.
    
    autoconf packages conventionally inherit the DESTDIR variable from the
    environment.

commit 9da7fa7c7464df241ae5d17da94e4ebed9013719
Author: Jonas 'Sortie' Termansen <sortie@maxsi.org>
Date:   Sat Nov 2 22:10:39 2024 +0100

    Define u_short and u_long if needed.

commit d3a7ff7cecbc23cc37044bdf02e7118d05bf3c35
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 3 08:31:49 2024 +0000

    upstream: support FIDO tokens that return no attestation data, e.g.
    
    recent WinHello. From Michael Braun via GHPR542
    
    OpenBSD-Commit-ID: a71b0542f2f7819ba0e33a88908e01b6fc49e4ce

commit 96b64056c812620014b65371a9e3ac86bfcd08d5
Author: Thorsten Kukuk <kukuk@suse.com>
Date:   Tue Nov 19 10:53:28 2024 +0100

    Add wtmpdb support as Y2038 safe wtmp replacement

commit 1d9563a56f2ad5b0c0aeef20e19c1a03ad54f88a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Dec 2 14:06:42 2024 +0000

    upstream: unbreak
    
    OpenBSD-Commit-ID: 05b6c31f4a6e385338f43cc0e08776cea75802a1

commit d75837b9f6d0d6cc18ed5078789ea0f3dad08f00
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Dec 2 13:37:18 2024 +0000

    upstream: prefer AES-GCM to AES-CTR; ok deraadt markus
    
    OpenBSD-Commit-ID: 8366a72e0f300ee31c5dab2c95025387ec15bbc9

commit e19cd494b567a73dc390e09b47c1e21545e6116b
Author: Shiva Kaul <shiva.kaul@gmail.com>
Date:   Mon Dec 2 02:04:20 2024 -0500

    Fix compilation with DEBUG_SK enabled
    
    In `ssh_ecdsa_sk_verify`, the `datalen` variable was renamed to `dlen` -- but not in this debugging block.

commit 67ace92be0718df7e0f52c0a76684fc2ebae4089
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Nov 29 00:13:36 2024 +0000

    upstream: Import regenerated moduli.
    
    OpenBSD-Commit-ID: 311d271bf0fab8a119e84f4f696d8cd40731692f

commit ca0697a90e5720ba4d76cb0ae9d5572b5260a16c
Author: Jeremy Stott <jeremy@stott.co.nz>
Date:   Sat Oct 19 12:10:52 2024 +1300

    Add make target for standalone sk-libfido2
    
    Add a Makefile target for sk-libfido2, the standalone fido2 security
    key shared library, suitable for use with the SecurityKeyProvider
    option.
    
    Add a new configure option `--with-security-key-standalone` that
    optionally sets the shared library target sk-libfido2$(SHLIBEXT), and
    adds it to $(TARGETS).
    
    misc.h is required when SK_STANDALONE is defined, because of the use
    of `monotime_tv` in `sk_select_by_touch`.
    
    Sets the shared library extension for sk-libfido2 is by setting
    `SHLIBEXT` depending on the platform in configure.ac.
    
    Add the shared library to the CI builds in the `sk` target config to
    make sure it can compile under the same conditions as
    `--with-security-key-builtin`.
    
    Add a libssh-pic.a static library that compiles with `-fPIC` reusing
    .c.lo method in sk-dummy.so for use in the shared library sk-libfido2.
    
    Note, a separate static library libssh-pic.a is needed, since defining
    -DSK_STANDALONE excludes some symbols needed in sshkey.lo.

commit 74d70841efbf41b9fcc8e6f6f4777d2e9d7e2004
Author: Arnout Engelen <arnout@bzzt.net>
Date:   Fri Oct 18 13:42:38 2024 +0200

    mdoc2man: balance nested square brackets
    
    I noticed the square brackets in `destination [command [argument...]`
    in the synopsis for the `ssh.1` manpage were not balanced,
    this balances them.
    
    Signed-off-by: Arnout Engelen <arnout@bzzt.net>

commit 8eabd2ae2ca1d7756417a1ee5b41f09c5d997634
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Nov 27 16:07:08 2024 +0000

    upstream: fix argument of "Compression" directive in ssh -G config
    
    dump, which used to work but broke in 9.8
    
    OpenBSD-Commit-ID: c79936242d29c70d01941b28d2d07fd0b85fe46f

commit 53c03961769d8879a81398074ea3cb36253d4f2e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Nov 27 13:27:34 2024 +0000

    upstream: new name/link for agent I-D
    
    OpenBSD-Commit-ID: e3420f3925a297a1b2ab7dfe7c7d274cfc8e1193

commit 785e3c9110df8f2d30e42ce8b45969c49700f35b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Nov 27 13:00:23 2024 +0000

    upstream: mention that biometrics may be used for FIDO key user
    
    verification as well as PIN. Prompted by Zack Newman, ok jmc@
    
    OpenBSD-Commit-ID: b774a4438c9be70012661ee278450790d21277b8

commit fd2e64c9ec9ea3e89e396be0db41aaf982ae1210
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Nov 26 22:05:51 2024 +0000

    upstream: g/c outdated XXX comments
    
    OpenBSD-Commit-ID: 74d0c0b74994d9a4343c4d7ea4948cb34f609a6c

commit 0ad34a6193357d286042322ea7347262a6fb0778
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Nov 26 22:02:28 2024 +0000

    upstream: regression test for UpdateHostkeys with multiple keys backed
    
    by ssh-agent. Patch from Maxime Rey.
    
    OpenBSD-Regress-ID: 1777ab6e639e57c0e20cbcb6df60455b49fd8bb3

commit 84023656d91b78f1ef86c8321ec563f2e90f7227
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Nov 26 22:01:37 2024 +0000

    upstream: Explicitly specify the signature algorithm when signing
    
    hostkeys-prove requests.
    
    Fixes a corner-case triggered by UpdateHostKeys with one or more unknown
    host keys stored in ssh-agent where sshd refuses to accept the signature
    coming back from the agent.
    
    Report/fix from Maxime Rey
    
    OpenBSD-Commit-ID: 460c7d527a24f92b7e5f68ca1a2fa242ebf0d086

commit d1c1cfc5e4e9b43593d4642810ea8135e4c7db49
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Nov 26 21:23:35 2024 +0000

    upstream: when using RSA keys to sign messages, select the
    
    signature algorithm based on the requested hash algorithm ("-Ohashalg=xxx").
    
    This allows using something other than rsa-sha2-512, which may not
    be supported on all signing backends, e.g. some smartcards only
    support SHA256.
    
    Patch from Morten Linderud; ok markus@
    
    OpenBSD-Commit-ID: 246353fac24e92629263996558c6788348363ad7

commit ac7544654441280071b90a4129a47467d40f2389
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Nov 24 23:47:50 2024 +0000

    upstream: turn off CDIAGFLAGS and turn back on INSTALL_STRIP
    
    accidentally changed in last commit
    
    OpenBSD-Commit-ID: 6d07e4606997e36b860621a14dd41975f2902f8f

commit 953fa5b59afb04c3c74ed82d7bace65c13cd8baa
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Nov 9 11:41:44 2024 +1100

    Disable security key for bigendian interop.
    
    It doesn't currently work.  It's not clear why, but I suspect
    sk-dummy.so ends up being built for the wrong architecture.

commit a80eb71c428c474098087c672398f200be8fabdf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Nov 9 05:14:16 2024 +1100

    Reshuffle OpenWRT test configs.
    
    Move the the flags used by the OpenWRT distro to mipsel target and
    enable OpenSSL on all targets to improve coverage.
    
    Explicitly disable security key and openssl on mips target so that host
    end of the bigendian interop tests don't attempt them and fail (since
    they're not enabled on the target side).

commit d2709c461359e4129311cdff81ee05242d6c53cd
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Nov 9 03:26:08 2024 +1100

    Add keytype to bigendian interop test.

commit 50ac0f0e0627d29fd9becf5e15e8ceca5ad18078
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Nov 9 03:24:29 2024 +1100

    Ignore chown failure, eg due to dangling symlinks.

commit 9e528e65a03245cf28e814f09b88c701bec935d1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Nov 2 18:05:41 2024 +1100

    Test bigendian interop.
    
    Where our test target is a bigendian system, do an additional build on
    the runner host (which is little endian) and test interop between the two.
    Should hopefully catch obvious endianness bugs.

commit dd416f5bfa96ac1ff44b27a93f7b55ee627c6baf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 1 19:44:29 2024 +1100

    Allow overridding TEST_SSH_SSHD.
    
    This will allow tests to specify an alternative sshd, eg on a remote
    machine with different endianness.

commit 82662d562cf54829df8a941cdfb2fd307e1d9a90
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Nov 6 22:51:26 2024 +0000

    upstream: ssh-agent implemented an all-or-nothing allow-list of
    
    FIDO application IDs for security key-backed keys, to prevent web key handles
    from being used remotely as this would likely lead to unpleasant surprises.
    By default, only application IDs that start with "ssh:*" are allowed.
    
    This adds a -Owebsafe-allow=... argument that can override the default
    list with a more or less restrictive one. The default remains unchanged.
    
    ok markus@
    
    OpenBSD-Commit-ID: 957c1ed92a8d7c87453b9341f70cb3f4e6b23e8d

commit 593a0b65c55c1e06a8c22b084aefc395aedb0127
Author: jca@openbsd.org <jca@openbsd.org>
Date:   Mon Nov 4 21:59:15 2024 +0000

    upstream: Ignore extra groups that don't fit in the buffer passed
    
    to getgrouplist(3)
    
    Our kernel supports 16 groups (NGROUPS_MAX), but nothing prevents
    an admin from adding a user to more groups.  With that tweak we'll keep
    on ignoring them instead of potentially reading past the buffer passed to
    getgrouplist(3).  That behavior is explicitely described in initgroups(3).
    
    ok millert@ gilles@
    
    OpenBSD-Commit-ID: a959fc45ea3431b36f52eda04faefc58bcde00db

commit e7adebeff3a9d038d0eaeeb0fcefedf29acb7e90
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Nov 4 14:39:27 2024 +1100

    Add git signing key for Tim Rice

commit da4b84845e874f12af7e0686170fa391c919d1df
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 1 18:51:22 2024 +1100

    Correct path to c-cpp.yml file in workflow config.

commit 28740aa2c75392a9c4191eb9523f9b20853e2932
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 1 18:44:42 2024 +1100

    Test new OpenSSL and LibreSSL releases.`

commit a74809fe06540f16231b354ffe21fcbf39e81f73
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 1 18:44:00 2024 +1100

    Add nbsd10 default test config.

commit 88b35cbdc1500efece65cd6a9a20a72cf7e46eaa
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Oct 30 14:25:14 2024 +1100

    fix uint64_t types; reported by Tom G. Christensen

commit ef7c26cd2f0f9a8222f851d1e551f6dfd3113f8b
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Oct 27 13:28:11 2024 +1100

    htole64() etc for systems without endian.h

commit 0c3927c45f8a57b511c874c4d51a8c89414f74ef
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 27 02:06:59 2024 +0000

    upstream: explicitly include endian.h
    
    OpenBSD-Commit-ID: 13511fdef7535bdbc35b644c90090013da43a318

commit cf3e48ee8ba1beeccddd2f203b558fa102be67a2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 27 02:06:01 2024 +0000

    upstream: fix ML-KEM768x25519 KEX on big-endian systems; spotted by
    
    jsg@ feedback/ok deraadt@
    
    OpenBSD-Commit-ID: 26d81a430811672bc762687166986cad40d28cc0

commit ae566d51b64fa3dce7063e7745b9b35f8f47abde
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Fri Oct 25 21:53:24 2024 +0000

    upstream: mlkem768x25519-sha256 has been promoted to default key
    
    exchange
    
    OpenBSD-Commit-ID: 5a3259a193fd42108a869ebf650b95b5f2d08dcf

commit 3af1dba1384ca896df6e973c70398c41d36de1ea
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Oct 25 19:04:30 2024 +1100

    Retire the minix3 test config.
    
    It got broken by the sshd-auth change, it's not obvious why, and the
    platform lacks the debugging tools (eg gdb, strace) to figure it out.
    The upstream project seems effectively dead (6 years since the last
    commit, 10 since the last release).  It was useful while it lasted
    (we found a real bug because of it) but its time seems to have passed.

commit 3b240cc44b8de9175280ddbe59331317d427b0e3
Author: Preetish Amballi <amballip@gmail.com>
Date:   Mon Oct 21 14:07:02 2024 +0000

    Updated gitignore to ignore sshd-session and sshd-auth targets

commit 326495744f06a0ab18ee0d16f87b3fe91cac92fb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Oct 25 19:01:02 2024 +1100

    Simplify pselect shim and remove side effects.
    
    Instead of maintaing state (pipe descriptors, signal handlers) across
    pselect-on-select invocations, set up and restore them each call.
    This prevents outside factors (eg a closefrom or signal handler
    installation) from potentially causing problems.  This does result in a
    drop in throughput of a couple of percent on geriatric platforms without
    a native pselect due to the extra overhead.  Tweaks & ok djm@

commit e53b615f3934ffac1efb3c1e491d126b9b09fd24
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 25 01:34:18 2024 +0000

    upstream: promote mlkem768x25519-sha256 to be the default key exchange;
    
    ok markus@
    
    OpenBSD-Commit-ID: fc673065e6505bb06b2e2b9362f78ccb4200a828

commit de644b1831b970f6655f871c051774cc871e8e74
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 24 03:28:34 2024 +0000

    upstream: test SIGUSR1 dropping all keys from ssh-agent
    
    OpenBSD-Regress-ID: 8654b9aa8eb695b1499fffc408c25319592bf0e0

commit e86d7a077ce9a2b9ee9d4138c358a17cbdb786f9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 24 03:15:47 2024 +0000

    upstream: amake ssh-agent drop all keys when it receives SIGUSR1;
    
    let's users zap keys without access to $SSH_AUTH_SOCK
    
    ok deraadt@
    
    OpenBSD-Commit-ID: dae9db0516b1011e5ba8c655ac702fce42e6c023

commit 94cdfebec852a2429c008cc2a55f8e4183f36972
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 24 03:14:37 2024 +0000

    upstream: relax valid_domain() checks to allow an underscore as the
    
    first character. ok deraadt@
    
    OpenBSD-Commit-ID: 3f8be6d32496e5596dd8b14e19cb067ddd7969ef

commit 1b05d5437bf45bee5e3104772dea06ed51764f1b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Oct 22 07:13:28 2024 +0000

    upstream: Remove sshd logfile in start_sshd
    
    ... and ssh and sshd log wrappers before recreating them.  Prevents "can't
    create" errors during tests when running tests without SUDO after having
    run them with SUDO.
    
    OpenBSD-Regress-ID: 2f0a83532e3dccd673a9bf0291090277268c69a6

commit 307ab3c7720f8879b835614b02687358ee4df9b9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Oct 22 06:16:26 2024 +0000

    upstream: Add a sshd debug wrapper
    
    ... to run all of the subprograms from the build directory while
    developing and debugging.  Should help prevent accidentally testing
    against unchanged installed sshd-auth and sshd-session binaries. ok djm@
    
    OpenBSD-Commit-ID: 61760cdc98c2bc8f1e9f83a6f97cca0f66b52e69

commit 87bd1cb3ccba5e91d2650eb7f753c898ee43858e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Oct 22 06:13:00 2024 +0000

    upstream: Make debug call printf("%s", NULL) safe.
    
    Prevents problems on platforms where this isn't safe (which it's not
    required to be).  ok djm@
    
    OpenBSD-Commit-ID: 8fa4ce3ad90915c925b81b99a79ab920b0523387

commit c44c349edd157b2c00c42bd5ef5f9dfb37de26f3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Oct 22 17:48:32 2024 +1100

    Resync cvsid missed in commit 6072e4c9.

commit fe4305c37ffe53540a67586854e25f05cf615849
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 05:53:26 2024 +0000

    upstream: mention that LocalForward and RemoteForward can accept Unix
    
    domain socket paths; GHPR115
    
    OpenBSD-Commit-ID: a8a34d0a0c51a9ddab3dfce615f9878fa76ef842

commit 9c97b6af8e052ab5ffe0f9096fadc8f9a4d0ed0f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 05:45:40 2024 +0000

    upstream: remove duplicate check; GHPR392 from Pedro Martelletto
    
    OpenBSD-Commit-ID: 597ab7dd3f0e78939d2659fc1904d0f39ee95487

commit d9cd208e89a471a3ff8adfcec68d6210af9e9fd5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 05:37:24 2024 +0000

    upstream: allow "-" as output file for moduli screening
    
    based on GHPR393
    
    OpenBSD-Commit-ID: 1517763764eb55d03a6092dd120d2909c6fef0e1

commit 5eb5c4b2820d0636b1eccee646fb32ec946c4a95
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 05:32:51 2024 +0000

    upstream: ssh-keyscan doesn't need it's own sshfatal() definition, it
    
    can use the shared one from fatal.c
    
    based on GHPR401 from lengyijun
    
    OpenBSD-Commit-ID: 8ea75ea99f27f464c9223cbc89cb046ccf9cd5c4

commit 0a1e75499e2c6fc258ee903645c878480949f362
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 05:14:51 2024 +0000

    upstream: in _ssh_order_hostkeyalgs() consider ECDSA curve type when
    
    arranging the hostkey algorithms. AFAIK this code is unused in OpenSSH, but I
    guess others are using it
    
    based on GHPR387 from Pawel Jakub Dawidek
    
    OpenBSD-Commit-ID: 4d462495ac0c40f7b7dd66178e0005b9b2128225

commit d01ee7a88c5f4b1aa8c75a7c739f8f3bc1ad8bde
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 05:03:34 2024 +0000

    upstream: require control-escape character sequences passed via the '-e
    
    ^x' commandline to be exactly two characters long. Avoids one by OOB read if
    ssh is invoked as "ssh -e^ ..."
    
    Spotted by Maciej Domanski in GHPR368
    
    OpenBSD-Commit-ID: baa72bc60898fc5639e6c62de7493a202c95823d

commit 74ff6382f5743e09930e6cbd195dac65cd6062c9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 04:30:09 2024 +0000

    upstream: remove addr.[ch] functions that are unused and
    
    visbility-restrict ones that are unused outside the implementation itself;
    based on GHPR#282 by tobias@
    
    OpenBSD-Commit-ID: a0140f2418b4d46cfaa7b33febc0a0931f9b2744

commit a9d6d7d93c533fa729f08b405e786d912553f33e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 04:14:59 2024 +0000

    upstream: unreachable POLLERR case; from ya0guang via GHPR485
    
    OpenBSD-Commit-ID: b3c82655190532b01eb817e532742cfaa4687eff

commit d76424bf279ff951383e21213eb3759ea4090674
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 18 04:11:54 2024 +0000

    upstream: s/Sx/Cm/ for external references; from Domen Puncer
    
    Kugler via GHPR501
    
    OpenBSD-Commit-ID: f864a34feb5d5ff17160cf7c42ad0f7744fe8a3f

commit ca204b994e2981e7bf95627b3105408917105649
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Mon Oct 14 23:53:34 2024 +0000

    upstream: mention SshdAuthPath option; ok djm@
    
    OpenBSD-Commit-ID: 9a5d3add25e4e77bd3805bc5583a842ecf34d85c

commit be27770e840c4dd9d9fcad1aa879400c727d7c2f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Oct 18 13:37:55 2024 +1100

    Remove references to systrace and pledge sandboxes.
    
    ok djm@

commit 49e64bf63fbf2f14961062dafe8ef08cb816bb08
Author: Pavel Miadzvedzeu <pmiadzvedzeu@gmail.com>
Date:   Wed Apr 24 10:19:56 2024 +0300

    Fix "undeclared 'ut'" error by replacing it with 'utx'

commit 67f684733f60f66479854a2867b953de731e71b2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Oct 17 20:50:29 2024 +1100

    Seed RNG when starting up sshd-auth.
    
    Makes builds configured --without-openssl work again since otherwise
    the first use of the RNG comes after the sandbox init and it can't
    open /dev/random.

commit c06c681aeebbe8e84e7410095514e7ee91f7e6cb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Oct 17 19:18:23 2024 +1100

    MacOS 12 runners are deprecated, replace with 15.

commit 39db1f23bafb48a7c0cc9c65c716a0370f4cc677
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Oct 17 13:28:47 2024 +1100

    Fix lookup path for sshd-auth; bz3745

commit c537eeb1ae5f069450053b0027e64efe5bdb37d2
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Oct 16 08:28:21 2024 +1100

    fix breakage; missing saved_argc symbol

commit 98a0883bdef28a06c7e017f27adf21ba57898bf4
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 14 17:17:50 2024 +1100

    fix capsicum sandbox

commit 164ea4380564a2a83713eacf71908e3946e5e4e4
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 14 17:16:41 2024 +1100

    put back some portable bits for sshd-auth.c

commit f8edf08c258ee2918689872c4702302052729726
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 14 14:49:25 2024 +1100

    there's only one sandbox, move to a static global

commit 4482f0042b41d3d63c3845d7ba9fcf47c9252a84
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Oct 14 14:49:20 2024 +1100

    depend

commit 74856204a353a187dc6e7706c6cf84b7f14d775d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Oct 14 03:02:08 2024 +0000

    upstream: regress support for split sshd-auth binary
    
    OpenBSD-Regress-ID: df7d18a87b475f70004770f0f4e404adba5f6ab7

commit 461741083d7254595fecea274e60fe3ebf3ce3f9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Sep 27 01:05:54 2024 +0000

    upstream: test some more Match syntax, including criteria=arg and
    
    negations
    
    OpenBSD-Regress-ID: 67476baccc60bf1a255fd4e329ada950047b8b8d

commit 6072e4c9385713e9c166f32cfca6a7e603d4f0b8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Oct 14 01:57:50 2024 +0000

    upstream: Split per-connection sshd-session binary
    
    This splits the user authentication code from the sshd-session
    binary into a separate sshd-auth binary. This will be executed by
    sshd-session to complete the user authentication phase of the
    protocol only.
    
    Splitting this code into a separate binary ensures that the crucial
    pre-authentication attack surface has an entirely disjoint address
    space from the code used for the rest of the connection. It also
    yields a small runtime memory saving as the authentication code will
    be unloaded after thhe authentication phase completes.
    
    Joint work with markus@ feedback deraadt@
    
    Tested in snaps since last week
    
    OpenBSD-Commit-ID: 9c3b2087ae08626ec31b4177b023db600e986d9c

commit fe6c6330c1a94c7a537efe9069853ce7a275c50a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 13 22:20:06 2024 +0000

    upstream: don't start the ObscureKeystrokeTiming mitigations if
    
    there has been traffic on a X11 forwarding channel recently.
    
    Should fix X11 forwarding performance problems when this setting is
    enabled. Patch from Antonio Larrosa via bz3655
    
    OpenBSD-Commit-ID: 820284a92eb4592fcd3d181a62c1b86b08a4a7ab

commit 538cd28598ae942c94b99855b06fdd937e2e7381
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Sat Oct 12 10:50:37 2024 +0000

    upstream: remove duplicate misc.h include ok dtucker@
    
    OpenBSD-Commit-ID: fdd056e7854294834d54632b4282b877cfe4c12e

commit 0051381a8c33740a77a1eca6859efa1c78887d80
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 6 23:37:17 2024 +0000

    upstream: Turn off finite field (a.k.a modp) Diffie-Hellman key
    
    exchange in sshd by default. Specifically, this removes the
    diffie-hellman-group* and diffie-hellman-group-exchange-* methods. The client
    is unchanged and continues to support these methods by default.
    
    Finite field Diffie Hellman is slow and computationally expensive for
    the same security level as Elliptic Curve DH or PQ key agreement while
    offering no redeeming advantages.
    
    ECDH has been specified for the SSH protocol for 15 years and some
    form of ECDH has been the default key exchange in OpenSSH for the last
    14 years.
    
    ok markus@
    
    OpenBSD-Commit-ID: 4e238ad480a33312667cc10ae0eb6393abaec8da

commit 67a115e7a56dbdc3f5a58c64b29231151f3670f5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 26 23:55:08 2024 +0000

    upstream: fix previous change to ssh_config Match, which broken on
    
    negated Matches; spotted by phessler@ ok deraadt@
    
    OpenBSD-Commit-ID: b1c6acec66cd5bd1252feff1d02ad7129ced37c7

commit 220b6c1290042acd5180d783dea01efe1365c265
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Wed Sep 25 23:01:39 2024 +0000

    upstream: remove some unused defines; ok djm@
    
    OpenBSD-Commit-ID: 3a63e4e11d455704f684c28715d61b17f91e0996

commit 3ef4f6e8a4d774f73852391fdccbb95f39fc71bf
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Wed Sep 25 06:13:01 2024 +0000

    upstream: remove some unneeded Xo/Xc calls; from evan silberman the
    
    original diff had a couple of errors, which i've fixed
    
    OpenBSD-Commit-ID: f37ad5888adbc0d4e1cd6b6de237841f4b1e650d

commit 3f02368e8e9121847727c46b280efc280e5eb615
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Sep 25 01:24:04 2024 +0000

    upstream: fix regression introduced when I switched the "Match"
    
    criteria tokeniser to a more shell-like one. Apparently the old tokeniser
    (accidentally?) allowed "Match criteria=argument" as well as the "Match
    criteria argument" syntax that we tested for.
    
    People were using this syntax so this adds back support for
    "Match criteria=argument"
    
    bz3739 ok dtucker
    
    OpenBSD-Commit-ID: d1eebedb8c902002b75b75debfe1eeea1801f58a

commit 9517cc58577f85a0ba5f8bb46778dff625f0688f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 24 02:28:17 2024 +0000

    upstream: some extra paranoia, reminded by jsg@
    
    OpenBSD-Commit-ID: 22072bfa1df1391858ae7768a6c627e08593a91e

commit 815a94e86a68c1000b8310cb47695cea9329516c
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Sep 25 11:15:45 2024 +1000

    gss-serv.c needs sys/param.h
    
    From Void Linux

commit 76a618d2842c34c16cd21a4efc7230e2f459008d
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Sep 25 11:13:05 2024 +1000

    build construct_utmp() when USE_BTMP is set
    
    Fixes compile error on Void Linux/Musl

commit d3aee17f6d395202eaa42a0c449b6da41f61527c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 24 18:41:44 2024 +1000

    Test the flags from OpenWRT's package.

commit 0f5d19e6fe4b58a89e6dc8c71a2aae30365d193e
Author: Christoph Ostarek <christoph@zededa.com>
Date:   Wed Jul 3 12:46:59 2024 +0200

    fix utmpx ifdef
    
    02e16ad95fb1f56ab004b01a10aab89f7103c55d did a copy-paste for
    utmpx, but forgot to change the ifdef appropriately

commit e03239f999acf9dc3da0f2f72bde36abbe678911
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Sun Sep 22 12:56:21 2024 +0000

    upstream: remove some unused defines; ok djm@
    
    OpenBSD-Commit-ID: 81869ee6356fdbff19dae6ff757095e6b24de712

commit a35f543d3a6275fef781e515c262d1c687c3bc28
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Fri Sep 20 02:00:46 2024 +0000

    upstream: remove unneeded semicolons; checked by millert@
    
    OpenBSD-Commit-ID: 3fb621a58e04b759a875ad6a33f35bb57ca80231

commit 1641f2d4d6e05d2147913442864cae546e64f08b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Sep 23 20:52:31 2024 +1000

    Add 9.9 branch to CI status console.

commit 46d1fb16b20e971b9ac15e86a3d3e350b49c9ad6
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Sep 20 08:20:13 2024 +1000

    update version numbers

commit 0bdca1f218971b38728a0a129f482476baff0968
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 19 22:17:44 2024 +0000

    upstream: openssh-9.9
    
    OpenBSD-Commit-ID: 303417285f1a73b9cb7a2ae78d3f493bbbe31f98

commit ef2d7f2d3e1b4c9ae71bacf963e76a92ab8be543
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Sep 18 16:03:23 2024 +1000

    include openbsd-compat/base64.c license in LICENSE

commit 7ef362b989c8d1f7596f557f22e5924b9c08f0ea
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Sep 18 09:01:23 2024 +1000

    conditionally include mman.h in arc4random code

commit 5fb2b5ad0e748732a27fd8cc16a7ca3c21770806
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Sep 17 11:53:24 2024 +1000

    fix bug in recently-added sntrup761 fuzzer
    
    key values need to be static to persist across invocations;
    spotted by the Qualys Security Advisory team.

commit 0ca128c9ee894f1b0067abd473bfb33171df67f8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 16 05:37:05 2024 +0000

    upstream: use 64 bit math to avoid signed underflow. upstream code
    
    relies on using -fwrapv to provide defined over/underflow behaviour, but we
    use -ftrapv to catch integer errors and abort the program. ok dtucker@
    
    OpenBSD-Commit-ID: 8933369b33c17b5f02479503d0a92d87bc3a574b

commit f82e5e22cad88c81d8a117de74241328c7b101c3
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Sun Sep 15 08:27:38 2024 +0000

    upstream: minor grammar/sort fixes for refuseconnection; ok djm
    
    OpenBSD-Commit-ID: 1c81f37b138b8b66abba811fec836388a0f3e6da

commit 0c1165fc78e8fe69b5df71f81a8f944554a68b53
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Sep 15 13:30:13 2024 +1000

    avoid gcc warning in fuzz test

commit ce171d0718104b643854b53443ff72f7283d33f2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 03:09:44 2024 +0000

    upstream: bad whitespace in config dump output
    
    OpenBSD-Commit-ID: d899c13b0e8061d209298eaf58fe53e3643e967c

commit 671c440786a5a66216922f15d0007b60f1e6733f
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Sep 15 12:53:59 2024 +1000

    use construct_utmp to construct btmp records
    
    Simpler and removes some code with the old-style BSD license.

commit 930cb02b6113df72fbc732b9feb8e4f490952a81
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 02:20:51 2024 +0000

    upstream: update the Streamlined NTRU Prime code from the "ref"
    
    implementation in SUPERCOP 20201130 to the "compact" implementation in
    SUPERCOP 20240808. The new version is substantially faster. Thanks to Daniel
    J Bernstein for pointing out the new implementation (and of course for
    writing it).
    
    tested in snaps/ok deraadt@
    
    OpenBSD-Commit-ID: bf1a77924c125ecdbf03e2f3df8ad13bd3dafdcb

commit 9306d6017e0ce5dea6824c29ca5ba5673c2923ad
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 01:19:56 2024 +0000

    upstream: document Match invalid-user
    
    OpenBSD-Commit-ID: 2c84a9b517283e9711e2812c1f268081dcb02081

commit 0118a4da21147a88a56dc8b90bbc2849fefd5c1e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 01:18:26 2024 +0000

    upstream: add a "Match invalid-user" predicate to sshd_config Match
    
    options.
    
    This allows writing Match conditions that trigger for invalid username.
    E.g.
    
    PerSourcePenalties refuseconnection:90s
    Match invalid-user
     RefuseConnection yes
    
    Will effectively penalise bots try to guess passwords for bogus accounts,
    at the cost of implicitly revealing which accounts are invalid.
    
    feedback markus@
    
    OpenBSD-Commit-ID: 93d3a46ca04bbd9d84a94d1e1d9d3a21073fbb07

commit 7875975136f275619427604900cb0ffd7020e845
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 01:11:26 2024 +0000

    upstream: Add a "refuseconnection" penalty class to sshd_config
    
    PerSourcePenalties
    
    This allows penalising connection sources that have had connections
    dropped by the RefuseConnection option. ok markus@
    
    OpenBSD-Commit-ID: 3c8443c427470bb3eac1880aa075cb4864463cb6

commit 8d21713b669b8516ca6d43424a356fccc37212bb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 01:09:40 2024 +0000

    upstream: Add a sshd_config "RefuseConnection" option
    
    If set, this will terminate the connection at the first authentication
    request (this is the earliest we can evaluate sshd_config Match blocks)
    
    ok markus@
    
    OpenBSD-Commit-ID: 43cc2533984074c44d0d2f92eb93f661e7a0b09c

commit acad117e66018fe1fa5caf41b36e6dfbd61f76a1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 00:58:01 2024 +0000

    upstream: switch sshd_config Match processing to the argv tokeniser
    
    too; ok markus@
    
    OpenBSD-Commit-ID: b74b5b0385f2e0379670e2b869318a65b0bc3923

commit baec3f7f4c60cd5aa1bb9adbeb6dfa4a172502a8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 00:57:36 2024 +0000

    upstream: switch "Match" directive processing over to the argv
    
    string tokeniser, making it possible to use shell-like quoting in Match
    directives, particularly "Match exec". ok markus@
    
    OpenBSD-Commit-ID: 0877309650b76f624b2194c35dbacaf065e769a5

commit dd424d7c382c2074ab70f1b8ad4f169a10f60ee7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 00:47:01 2024 +0000

    upstream: include pathname in some of the ssh-keygen passphrase
    
    prompts. Helps the user know what's going on when ssh-keygen is invoked via
    other tools. Requested in GHPR503
    
    OpenBSD-Commit-ID: 613b0bb6cf845b7e787d69a5b314057ceda6a8b6

commit 62bbf8f825cc390ecb0523752ddac1435006f206
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 15 00:41:18 2024 +0000

    upstream: Do not apply authorized_keys options when signature
    
    verification fails. Prevents restrictive key options being incorrectly
    applied to subsequent keys in authorized_keys. bz3733, ok markus@
    
    OpenBSD-Commit-ID: ba3776d9da4642443c19dbc015a1333622eb5a4e

commit 49f325fd47af4e53fcd7aafdbcc280e53f5aa5ce
Author: Wu Weixin <wuweixin@gmail.com>
Date:   Fri Aug 2 22:16:40 2024 +0800

    Fix without_openssl always being set to 1
    
    In Fedora systems, %{?rhel} is empty. In RHEL systems, %{?fedora} is
    empty. Therefore, the original code always sets without_openssl to 1.

commit c21c3a2419bbc1c59cb1a16ea356e703e99a90d9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Sep 12 00:36:27 2024 +0000

    upstream: Relax absolute path requirement back to what it was prior to
    
    OpenSSH 9.8, which incorrectly required that sshd was started with an
    absolute path in inetd mode. bz3717, patch from Colin Wilson
    
    OpenBSD-Commit-ID: 25c57f22764897242d942853f8cccc5e991ea058

commit 1bc426f51b0a5cfdcfbd205218f0b6839ffe91e9
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Mon Sep 9 14:41:21 2024 +0000

    upstream: document the mlkem768x25519-sha256 key exchange algorithm
    
    OpenBSD-Commit-ID: fa18dccdd9753dd287e62ecab189b3de45672521

commit 0a2db61a5ffc64d2e2961c52964f933879952fc7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 10 21:11:14 2024 +1000

    Spell omnios test host correctly.

commit 059ed698a47c9af541a49cf754fd09f984ac5a21
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 10 18:52:02 2024 +1000

    Add omnios test target.

commit f4ff91575a448b19176ceaa8fd6843a25f39d572
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Sep 10 18:45:55 2024 +1000

    Wrap stdint.h in ifdef.

commit ff714f001d20a9c843ee1fd9d92a16d40567d264
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Sep 9 19:31:54 2024 +1000

    Also test PAM on dfly64.

commit 509b757c052ea969b3a41fc36818b44801caf1cf
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Sep 9 21:50:14 2024 +1000

    stubs for ML-KEM KEX functions
    
    used for C89 compilers

commit 273581210c99ce7275b8efdefbb9f89e1c22e341
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Sep 9 17:30:38 2024 +1000

    declare defeat trying to detect C89 compilers
    
    I can't find a reliable way to detect the features the ML-KEM code
    requires in configure. Give up for now and use VLA support (that we
    can detect) as a proxy for "old compiler" and turn off ML-KEM if
    it isn't supported.

commit e8a0f19b56dfa20f98ea9876d7171ec315fb338a
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Sep 9 16:46:40 2024 +1000

    fix previous; check for C99 compound literals
    
    The previous commit was incorrect (or at least insufficient), the
    ML-KEM code is actually using compound literals, so test for them.

commit 7c07bec1446978bebe0780ed822c8fedfb377ae8
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Sep 9 16:06:21 2024 +1000

    test for compiler feature needed for ML-KEM
    
    The ML-KEM implementation we uses need the compiler to support
    C99-style named struct initialisers (e.g foo = {.bar = 1}). We
    still support (barely) building OpenSSH with older compilers, so
    add a configure test for this.

commit d469d5f348772058789d35332d1ccb0b109c28ef
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 9 03:13:39 2024 +0000

    upstream: test mlkem768x25519-sha256
    
    OpenBSD-Regress-ID: 7baf6bc39ae55648db1a2bfdc55a624954847611

commit 62fb2b51bb7f6863c3ab697f397b2068da1c993f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 9 02:39:57 2024 +0000

    upstream: pull post-quantum ML-KEM/x25519 key exchange out from
    
    compile-time flag now than an IANA codepoint has been assigned for the
    algorithm.
    
    Add mlkem768x25519-sha256 in 2nd KexAlgorithms preference slot.
    
    ok markus@
    
    OpenBSD-Commit-ID: 9f50a0fae7d7ae8b27fcca11f8dc6f979207451a

commit a8ad7a2952111c6ce32949a775df94286550af6b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Sep 6 02:30:44 2024 +0000

    upstream: make parsing user@host consistently look for the last '@' in
    
    the string rather than the first. This makes it possible to use usernames
    that contain '@' characters.
    MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: 8bit
    
    Prompted by Max Zettlmeißl; feedback/ok millert@
    
    OpenBSD-Commit-ID: 0b16eec246cda15469ebdcf3b1e2479810e394c5

commit 13cc78d016b67a74a67f1c97c7c348084cd9212c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Sep 4 05:33:34 2024 +0000

    upstream: be more strict in parsing key type names. Only allow
    
    shortnames (e.g "rsa") in user-interface code and require full SSH protocol
    names (e.g. "ssh-rsa") everywhere else.
    
    Prompted by bz3725; ok markus@
    
    OpenBSD-Commit-ID: b3d8de9dac37992eab78adbf84fab2fe0d84b187

commit ef8472309a68e319018def6f8ea47aeb40d806f5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Sep 4 05:11:33 2024 +0000

    upstream: fix RCSID in output
    
    OpenBSD-Commit-ID: 889ae07f2d2193ddc4351711919134664951dd76

commit ba2ef20c75c5268d4d1257adfc2ac11c930d31e1
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Tue Sep 3 06:17:48 2024 +0000

    upstream: envrionment -> environment;
    
    OpenBSD-Commit-ID: b719f39c20e8c671ec6135c832d6cc67a595af9c

commit e66c0c5673a4304a3a9fbf8305c6a19f8653740f
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Sep 4 15:35:29 2024 +1000

    add basic fuzzers for our import of sntrup761

commit d19dea6330ecd4eb403fef2423bd7e127f4c9828
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 3 05:58:56 2024 +0000

    upstream: regression test for Include variable expansion
    
    OpenBSD-Regress-ID: 35477da3ba1abd9ca64bc49080c50a9c1350c6ca

commit 8c4d6a628051e318bae2f283e8dc38b896400862
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Sep 3 05:29:55 2024 +0000

    upstream: allow the "Include" directive to expand the same set of
    
    %-tokens that "Match Exec" and environment variables.
    
    ok dtucker@
    
    OpenBSD-Commit-ID: 12ef521eaa966a9241e684258564f52f1f3c5d37

commit 51b82648b6827675fc0cde21175fd1ed8e89aab2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 2 12:18:35 2024 +0000

    upstream: missing ifdef
    
    OpenBSD-Commit-ID: 85f09da957dd39fd0abe08fe5ee19393f25c2021

commit f68312eb593943127b39ba79a4d7fa438c34c153
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 2 12:13:56 2024 +0000

    upstream: Add experimental support for hybrid post-quantum key exchange
    
    ML-KEM768 with ECDH/X25519 from the Internet-draft:
    https://datatracker.ietf.org/doc/html/draft-kampanakis-curdle-ssh-pq-ke-03
    
    This is based on previous patches from markus@ but adapted to use the
    final FIPS203 standard ML-KEM using a formally-verified implementation
    from libcrux.
    
    Note this key exchange method is still a draft and thus subject to
    change. It is therefore disabled by default; set MLKEM=yes to build it.
    We're making it available now to make it easy for other SSH
    implementations to test against it.
    
    ok markus@ deraadt@
    
    OpenBSD-Commit-ID: 02a8730a570b63fa8acd9913ec66353735dea42c

commit 05f2b141cfcc60c7cdedf9450d2b9d390c19eaad
Author: Antonio Larrosa <alarrosa@suse.com>
Date:   Fri Aug 23 12:21:06 2024 +0200

    Don't skip audit before exitting cleanup_exit
    
    This fixes an issue where the SSH_CONNECTION_ABANDON event is not
    audited because cleanup_exit overrides the regular _exit too soon and
    as a result, failed auth attempts are not logged correctly.
    
    The problem was introduced in 81c1099d22b81ebfd20a334ce986c4f753b0db29
    where the code from upstream was merged before the audit_event call when
    it should have been merged right before the _exit call in order to honor
    the comment that just mentions an override of the exit value.

commit 16eaf9d401e70996f89f3f417738a8db421aa959
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 28 12:08:26 2024 +0000

    upstream: fix test: -F is the argument to specify a non-default
    
    ssh_config, not -f (this is sadly not a new bug)
    
    OpenBSD-Regress-ID: 45a7bda4cf33f2cea218507d8b6a55cddbcfb322

commit 10ccf611ab8ecba9ce6b0548c5ccd8c1220baf92
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Fri Aug 23 04:51:00 2024 +0000

    upstream: As defined in the RFC, the SSH protocol has negotiable
    
    compression support (which is requested as the name "zlib"). Compression
    starts very early in the session. Relative early in OpenSSH lifetime, privsep
    was added to sshd, and this required a shared-memory hack so the two
    processes could see what was going on in the dataflow.  This shared-memory
    hack was soon recognized as a tremendous complexity risk, because it put libz
    (which very much trusts it's memory) in a dangerous place, and a new option
    ("zlib@openssh.com") was added begins compression after authentication (aka
    delayed-compression).  That change also permitted removal of the
    shared-memory hack. Despite removal from the server, the old "zlib" support
    remained in the client, to allow negotiation with non-OpenSSH daemons which
    lack the delayed-compression option. This commit deletes support for the
    older "zlib" option in the client. It reduces our featureset in a small way,
    and encourages other servers to move to a better design. The SSH protocol is
    different enough that compressed-key-material attacks like BEAST are
    unlikely, but who wants to take the chance? We encourage other ssh servers
    who care about optional compression support to add delayed-zlib support.
    (Some already do "zlib@openssh.com") ok djm markus
    
    OpenBSD-Commit-ID: 6df986f38e4ab389f795a6e39e7c6857a763ba72

commit aee54878255d71bf93aa6e91bbd4eb1825c0d1b9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 22 23:11:30 2024 +0000

    upstream: sntrup761x25519-sha512 now has an IANA codepoint assigned, so
    
    we can make the algorithm available without the @openssh.com suffix too. ok
    markus@ deraadt@
    
    OpenBSD-Commit-ID: eeed8fcde688143a737729d3d56d20ab4353770f

commit a76a6b85108e3032c8175611ecc5746e7131f876
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Aug 22 20:36:12 2024 +1000

    Move rekey test into valgrind-2.
    
    Now that the rekey test has been optimized it's fast enough to not be in
    its own valgrind test, so move it into valgrind-2, which is currently
    the quickest of the others, bringing all of them to roughly the same
    runtime of ~1.1 hours.

commit 7e75e3f57c41b9a6e6401e7674d7c2ff5c33975b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Aug 22 10:21:02 2024 +0000

    upstream: Use aes128-ctr for MAC tests since default has implicit MAC.
    
    Also verify that the Cipher or MAC we intended to use is actually the one
    selected during the test.
    
    OpenBSD-Regress-ID: ff43fed30552afe23d1364526fe8cf88cbfafe1d

commit ebc890b8b4ba08c84cd1066b7b94b2b11f6c4cb4
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 22 09:45:49 2024 +1000

    fix incorrect default for PasswordAuthentication
    
    merge botch spotted by gsgleason

commit 15ace435ea1c2fab2a1cc7d9c3157fe20c776b80
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Aug 21 10:33:27 2024 +0000

    upstream: Some awks won't match on the \r so delete it instead. Fixes
    
    regress in portable on, eg Solaris.
    
    OpenBSD-Regress-ID: 44a96d6d2f8341d89b7d5fff777502b92ac9e9ba

commit 51c96b6ed627779a04493a8fe25747996a37f3c2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Aug 21 07:06:27 2024 +0000

    upstream: Import regenerated moduli.
    
    OpenBSD-Commit-ID: 5db7049ad5558dee5b2079d3422e8ddab187c1cc

commit 25c52f37a82c4da48ec537de37d7c168982b8d6d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Aug 21 06:59:08 2024 +0000

    upstream: Use curve25519-sha256 kex where possible.
    
    Except where we're explicitly testing a different kex, use
    curve25519-sha256 since it's faster than the default and supported even
    when configured without OpenSSL.  Add a check to ensure that the kex we
    intended to test is the one we actually tested. Speeds test up by ~5%.
    
    OpenBSD-Regress-ID: 3b27fcc2ae953cb08fd82a0d3155c498b226d6e0

commit 3eb62b7ba49483c309b483eb9002a679014f3887
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Aug 20 12:36:59 2024 +0000

    upstream: Send only as much data as needed to trigger rekeying. Speeds
    
    up tests by about 10% in the common case, hopefully more when instrumented
    with something like valgrind.
    
    OpenBSD-Regress-ID: 7bf9292b4803357efcf0baf7cfbdc8521f212da1

commit cbd3f034bbf7853618fac99d7d868a2250154ea7
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Aug 21 09:18:29 2024 +1000

    simplify sshkey_prekey_alloc(); always use mmap

commit 4442bbc2fc661277a6dabfedb756a7e15ee8b8b8
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Aug 20 09:15:49 2024 +0000

    upstream: Merge AEAD test into main test loop.
    
    Removes 3 duplicate tests and speeds overall test up by about 1%.
    
    OpenBSD-Regress-ID: 5e5c9ff3f7588091ed369e34ac28520490ad2619

commit 829976a63fd1efae3a4c3e7c16fded59d92edb67
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Aug 20 09:02:45 2024 +0000

    upstream: Set a default RekeyLimit of 256k.
    
    Used unless overridden by a command-line flag, which simplifies some of
    the ssh command lines.
    
    OpenBSD-Regress-ID: e7cffa57027088e10336e412b34113969f88cb87

commit 57d02c9ea36aebad4e7146d46e041b6b2e582f7f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Aug 20 07:52:43 2024 +0000

    upstream: Add Compression=no to default ssh_config.
    
    All of the rekey tests use it (otherwise the encrypted byte counts would
    not match) so this lets us simplify the command lines.
    
    OpenBSD-Regress-ID: dab7ce10f4cf6c68827eb8658141272aab3ea262

commit 7254eb26f7c0772c4b47c3b32f6d1b15855cdd8c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Aug 20 07:41:35 2024 +0000

    upstream: Remove duplicate curve25519-sha256 kex.
    
    curve25519-sha256@libssh.org is the pre-standardization name for the same
    thing, so remove it as a duplicate.  Speeds up test by a tiny amount.
    
    OpenBSD-Regress-ID: 5a5ee5fa1595a6e140b1cc16040bedf5996a5715

commit 749896b874928c2785256cae4d75161dc3bfcc7d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Aug 20 07:27:25 2024 +0000

    upstream: Unnest rekey param parsing test and use ssh not sshd.
    
    ssh uses the same parsing code, now has "-G" to dump its config and is
    slightly faster to start up.  This speeds up the test slightly (~5%) in the
    common case but should help more during instrumented tests, eg under
    valgrind, where startup costs are magnified.
    
    OpenBSD-Regress-ID: 07c3acaf4c728e641033071f4441afc88141b0d0

commit 2b1762115481ff2b7a60fd4db2ae69b725437462
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 20 11:10:04 2024 +0000

    upstream: actually use the length parameter that was passed in rather
    
    than a constant (this makes no difference in practice because the length is
    always the same); reported by martin AT nmkd.net
    
    OpenBSD-Commit-ID: 4aecce232c2fe9b16e9217ff6bcb3c848d853e7e

commit d922762ca16a7381131b242f49d7376c41fabcb5
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Aug 20 13:55:30 2024 +1000

    private key coredump protection for Linux/FreeBSD
    
    platforms not supporting coredump exclusion using mmap/madvise flags
    fall back to plain old malloc(3).

commit cc048ca536d6bed6f2285b07040b0d57cd559ba5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 20 03:48:30 2024 +0000

    upstream: place shielded keys (i.e. keys at rest in RAM) into memory
    
    allocated using mmap(3) with MAP_CONCEAL set. This prevents exposure of the
    key material in coredumps, etc (this is in addition to other measures we take
    in this area).
    
    ok deraadt@
    
    OpenBSD-Commit-ID: cbbae59f337a00c9858d6358bc65f74e62261369

commit a0b35c791cad1f85481b23ba46373060292e1c80
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 17 08:35:04 2024 +0000

    upstream: mention that ed25519 is the default key type generated and
    
    clarify that rsa-sha2-512 is the default signature scheme when RSA is in use.
    Based on GHPR505 from SebastianRzk
    
    OpenBSD-Commit-ID: 1d90df71636a04601685d2a10a8233bcc8d4f4c5

commit 127a50f2c80572ed1a021feb11ecf941e92cbbef
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 17 08:23:04 2024 +0000

    upstream: fix minor memory leak in Subsystem option parsing; from
    
    Antonio Larrosa via GHPR515
    
    OpenBSD-Commit-ID: fff3bbefd1b2c45c98cbe45c6b857b15d8a2d364

commit 171427261d2079941eb1041079dbae875da37cbc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 17 08:09:50 2024 +0000

    upstream: fix swapping of source and destination addresses in some sshd
    
    log messages
    
    OpenBSD-Commit-ID: 24d4cbb86325275df1f037545aa3b91456e52d25

commit 2a50a8f1fa57857a5e124a2280bcf61cc63c77f7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Aug 17 11:10:19 2024 +1000

    Add compat functions for EVP_Digest{Sign,Verify}.
    
    This should make LibreSSL 3.1.x through 3.3.x work again.  Code from
    tb@, ok djm@.  Restore the test configs covering those.

commit 1c3a7145260e03037cc18715b883880836fd122d
Author: Philip Hands <phil@hands.com>
Date:   Thu Aug 8 13:03:51 2024 +0200

    make sure that usage & man page match
    
    SSH-Copy-ID-Upstream: da5b1abe55b72a16e0430e7598e1573da01779c0

commit cd0d681645b9adcf2467e7838bfd9d5142de4c4e
Author: Philip Hands <phil@hands.com>
Date:   Thu Aug 8 13:01:47 2024 +0200

    update copyright notices
    
    Bump the year to 2024, but also reflect the fact that hands.com Ltd. has
    been wound up in the UK, and its assets (including this copyright) have
    now reverted to its owner, Philip Hands.
    
    SSH-Copy-ID-Upstream: 0e4c4d072747a6568b11a790c29dd1b4ce663d7f

commit 7fc9ccdce18841ebd0a97e31e43258512ab32a32
Author: Philip Hands <phil@hands.com>
Date:   Sun Aug 4 20:45:00 2024 +0200

    restore optionality of -i's argument
    
    SSH-Copy-ID-Upstream: f70e3abb510e4eeb040b47894e41828246c1b720

commit c37aa7012b1a3c2c322fd19e71310aadc90fc674
Author: Philip Hands <phil@hands.com>
Date:   Fri Aug 2 15:52:07 2024 +0200

    avoid exploring .ssh/id*.pub subdirectories
    
    SSH-Copy-ID-Upstream: 0b9e08b7707ad16de3c8e6a0410d9f42fbd56997

commit 777dce9e2e0d12f7e81e162f77749f30899869fe
Author: Philip Hands <phil@hands.com>
Date:   Fri Aug 2 10:07:11 2024 +0200

    ensure that we're always told the source of keys
    
    SSH-Copy-ID-Upstream: 1bee96f4793e8ec3fab9f9361204ae58f5cc7cae

commit fb94fd2339848e40cad6c9bb42b822244cc1a7bc
Author: Philip Hands <phil@hands.com>
Date:   Wed Jul 31 23:19:51 2024 +0200

    add $HOME to ERROR if one cannot write to ~/.ssh
    
    SSH-Copy-ID-Upstream: ebef3e9c06e0447bff06e9d84b33023cf592e0ba

commit eb5aafa1ffaeee75799141ec5ded406a65ec7d18
Author: Philip Hands <phil@hands.com>
Date:   Wed Jul 31 23:19:03 2024 +0200

    assert that SCRATCH_DIR is a writable directory
    
    SSH-Copy-ID-Upstream: ecb2b9d10883b9a16df56c83896c9bb47a80cde2

commit abcc460a2af46f0d812f8433d97a8eae1d80724c
Author: Philip Hands <phil@hands.com>
Date:   Wed Jul 31 23:17:54 2024 +0200

    quote to avoid potential for word splitting
    
    SSH-Copy-ID-Upstream: f379adbe06ac2ef1daf0f130752234c7f8b97e3c

commit b3f91411fd1473605f74c40c1a91a024c7171e27
Author: Philip Hands <phil@hands.com>
Date:   Wed Jul 31 23:15:11 2024 +0200

    ensure ERROR output goes to STDERR
    
    SSH-Copy-ID-Upstream: ac394b05eead3b91feb7c2ae4129a3e9b892f1e2

commit 674b8f30f0dbacd787eb1e4e7e1ece34b5543d8f
Author: Philip Hands <phil@hands.com>
Date:   Thu Aug 1 14:03:06 2024 +0200

    avoid extra space when no arg given to -i option
    
    SSH-Copy-ID-Upstream: feca9e67e6e37c5653445d1c733569d7abb1770e

commit 0efa0e1c41427c0c6ba839a18c72c1afcd7b7cc0
Author: Philip Hands <phil@hands.com>
Date:   Wed Jul 31 23:28:36 2024 +0200

    put the -i before -[pP] (matching man pages)
    
    The man pages (ssh, sftp & ssh-copy-id) all list -i before the port
    setting, so make the output match that order, which also seems more
    natural with the port being next to the server.
    
    SSH-Copy-ID-Upstream: 34d5d614172c78f9a42249466c4b81975b8883a1

commit 87831345e9745f2d13bd7a4a7972809f6788f331
Author: Shreyas Mahangade <smahanga@redhat.com>
Date:   Mon Jul 29 15:26:05 2024 +0000

    Minor space issue fixed
    
    SSH-Copy-ID-Upstream: 335e44d7be78b03962a54c3a5c99a2ff45294a54

commit 2f3010f4736b4b3f5c10a4be97a24e90ff04c5e7
Author: Shreyas Mahangade <smahanga@redhat.com>
Date:   Mon Jul 29 16:55:28 2024 +0530

    Show identity file in 'ssh' command
    
    - Previously no identity file is shown in "ssh" command output on the line "Now try logging into the..."
    - This commit makes sure whenever "ssh-copy-id" with "-i" is invoked, it also reflects in "ssh" command
    
    SSH-Copy-ID-Upstream: 58e022ec26cb2315eb3be581d01e0ba787082428

commit a13856374b894397a7682b32257ed0bf67cfede9
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Aug 16 08:30:20 2024 +1000

    more OPENSSL_HAS_ECC

commit 4da2a1a7f648979bea6eaf3b17f5f250faed4afc
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 15 23:35:54 2024 +1000

    fix merge botch that broke !OPENSSL_HAS_ECC

commit 2c53d2f32b8e3992b61682c909ae5bc5122b6e5d
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 15 15:09:45 2024 +1000

    missed OPENSSL_HAS_ECC case

commit 342dd7a219f39119b8b686b5aaa99c8e15ede368
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 15 15:06:55 2024 +1000

    retire testing aginst older LibreSSL versions
    
    libressl prior to 3.4.x lack support for the EVP_DigestSign and
    EVP_DigestVerify APIs that we need now that sshkey is converted
    to EVP_PKEY.
    
    If someone makes a good case for why we should support these versions
    then we could bring back support with wrappers.

commit a7c6ea8eebe0f179141ec5dbf0c9e5354417930f
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 15 12:44:17 2024 +1000

    sync TEST_MALLOC_OPTIONS for OpenBSD

commit 60c2cf22e8f64f35d8b1175e4671257313f2e4d3
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 15 12:43:47 2024 +1000

    remove gratuitious difference from OpenBSD

commit 339c4fc60a6250429d41fa8713f783d82aad4551
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 15 00:52:23 2024 +0000

    upstream: adapt to EVP_PKEY conversion
    
    OpenBSD-Regress-ID: 0e2d4efb0ed0e392e23cd8fda183fe56531ac446

commit 63a94f99b9d7c8a48182a40192e45879d1ba8791
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 19 04:33:36 2024 +0000

    upstream: test transfers in mux proxy mode too
    
    OpenBSD-Regress-ID: 2edfc980628cfef3550649cab8d69fa23b5cd6c4

commit 7bdfc20516e288b58c8c847958059c7b141eeff9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 15 00:51:51 2024 +0000

    upstream: Convert RSA and ECDSA key to the libcrypto EVP_PKEY API.
    
    DSA remains unconverted as it will be removed within six months.
    
    Based on patches originally from Dmitry Belyavskiy, but significantly
    reworked based on feedback from Bob Beck, Joel Sing and especially
    Theo Buehler (apologies to anyone I've missed).
    
    ok tb@
    
    OpenBSD-Commit-ID: d098744e89f1dc7e5952a6817bef234eced648b5

commit 0af06e2c5b898992a18c74333e75a0136506acc6
Author: tobias@openbsd.org <tobias@openbsd.org>
Date:   Wed Aug 14 15:42:18 2024 +0000

    upstream: Reorder calloc arguments
    
    The first argument should be the amount, the second argument should be the
    element size. Fixing this also silences some gcc compiler warnings for
    portable.
    
    Spotted with Benny Baumann (BenBE at geshi dot org).
    
    ok djm@
    
    OpenBSD-Commit-ID: 711ad6f7bd7fb48bf52208f2cf9f108cddb6d41a

commit 56ce0aa3c6cf28d9fcbce3207457abeac91b5050
Author: tobias@openbsd.org <tobias@openbsd.org>
Date:   Wed Aug 14 15:40:30 2024 +0000

    upstream: Extend sshbuf validation
    
    Multiple sshbuf structs can be linked through a parent/child relationship.
    Make sure that a single sshbuf cannot be its own parent. If this would ever
    happen, it would result in reference counting issues.
    
    This is a cheap way of testing this with very little overhead. It does not
    detect A->B->A linkages though for performance reason and the fact that it
    takes a programming error for this to occur anyway.
    
    Authored with Benny Baumann (BenBE at geshi dot org).
    
    ok djm@
    
    OpenBSD-Commit-ID: fb3fa9ee2cad3c7e842ebadfd7f5db220c4aaf16

commit fc48ddf6998188517af42dce807e2088b6a0c0be
Author: tobias@openbsd.org <tobias@openbsd.org>
Date:   Wed Aug 14 15:37:11 2024 +0000

    upstream: Use freezero for better readability
    
    It has the same meaning as the current pair of calling explicit_bzero
    and free. Spotted with Benny Baumann (BenBE at geshi dot org).
    
    ok djm@
    
    OpenBSD-Commit-ID: 939fbe9ccf52d0d48c5fa53694d6f3bb9927970c

commit 1ff6907ec26dac6ac59fe9fe232899a63b4c14d8
Author: tobias@openbsd.org <tobias@openbsd.org>
Date:   Wed Aug 14 15:35:23 2024 +0000

    upstream: Fix typo in comment
    
    Spotted with Benny Baumann (BenBE at geshi dot org).
    
    ok djm@
    
    OpenBSD-Commit-ID: 829160ac8ef3ad3409695ce3a3ade835061cae57

commit 487faaed8f3bb9ffb19e8f807a3da72895b16421
Author: dlg@openbsd.org <dlg@openbsd.org>
Date:   Wed Jul 31 12:00:18 2024 +0000

    upstream: add a random amount of time (up to 4 seconds) to the
    
    grace login time.
    
    ok deraadt@ djm@
    
    OpenBSD-Commit-ID: abd3c57aaa5861517529b322df79b6be35ee67f4

commit 2865f5b7520bed3e74fbbb5f8d7a44193d7a4314
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Fri Jul 26 15:24:49 2024 +0000

    upstream: document the reduced logingrace penalty
    
    OpenBSD-Commit-ID: 9b63e0e3599d524ddc10edc4f978081382c3548b

commit 1ec0a64c5dc57b8a2053a93b5ef0d02ff8598e5c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jul 28 21:26:51 2024 +1000

    Explicitly install libssl-devel cygwin.
    
    Should fix CI tests for cygwin default config.

commit 0bf6e5bb750b66b25c20a1c5a471f91850de3748
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 25 23:44:01 2024 +0000

    upstream: reduce logingrace penalty.
    
    A single forgotton login that times out should be below the penalty
    threshold.
    
    ok deraadt/claudio
    
    OpenBSD-Commit-ID: cee1f7d17597c97bff8e5092af5d136fdb08f81d

commit 29fb6f6d46b67770084b4f12bcf8a01bd535041b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 25 22:40:08 2024 +0000

    upstream: Fix proxy multiplexing (-O proxy) bug
    
    If a mux started with ControlPersist then later has a forwarding added using
    mux proxy connection and the forwarding was used, then when the mux proxy
    session terminates, the mux master process will send a channel close to the
    server with a bad channel ID and crash the connection.
    
    This was caused by my stupidly reusing c->remote_id for mux channel
    associations when I should have just added another member to struct channel.
    
    ok markus@
    
    OpenBSD-Commit-ID: c9f474e0124e3fe456c5e43749b97d75e65b82b2

commit 53d1d307438517805989c7d5616d752739a97e03
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 18 01:47:27 2024 +0000

    upstream: mention mux proxy mode
    
    OpenBSD-Commit-ID: fd77a77779f06d316a314e4540dc57c93fc3369a

commit a9b90859d252c2f5a24142f985d38610ac74685f
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Sun Jul 14 10:19:23 2024 +0000

    upstream: fix double word; ok dtucker@
    
    OpenBSD-Commit-ID: e6aff005914fa350b896d2be030be3d3b56ec0e8

commit b05fda224bbcd2f641254534ed2175c42487f3c8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jul 25 17:59:35 2024 +1000

    Check for SA_RESTART before using it.
    
    ok djm@

commit c276672fc0e99f0c4389988d54a84c203ce325b6
Author: Yuichiro Naito <naito.yuichiro@gmail.com>
Date:   Wed Sep 1 10:19:32 2021 +0900

    Class-imposed login restrictions
    
    If the following functions are available,
    add an additional check if users are allowed to login imposed by login class.
    
    * auth_hostok(3)
    * auth_timeok(3)
    
    These functions are implemented on FreeBSD.

commit 7717b9e9155209916cc6b4b4b54f4e8fa578e889
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 10 21:58:34 2024 +0000

    upstream: correct keyword; from Yatao Su via GHPR509
    
    OpenBSD-Commit-ID: 81c778c76dea7ef407603caa157eb0c381c52ad2

commit f2b78bb8f149d6b4d1f62c21aa1f06995dccf4ce
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 8 03:04:34 2024 +0000

    upstream: don't need return at end of void function
    
    OpenBSD-Commit-ID: 42d322d37f13aa075ae7b1ad9eef591e20b89717

commit a395d37a813c0177cb5bfc4bebf5a52badb73cf0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jul 4 22:53:59 2024 +0000

    upstream: fix grammar: "a pattern lists" -> "one or more pattern
    
    lists"
    
    OpenBSD-Commit-ID: f3c844763398faa9800687e8ff6621225498202a

commit 8b664df75966e5aed8dabea00b8838303d3488b8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jul 7 18:46:19 2024 +1000

    Cast to sockaddr * in systemd interface.
    
    Fixes build with musl libx.  bz#3707.

commit 30c8c81da2169e78357d08dbb0ddd823b60e93bc
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jul 4 20:12:26 2024 +1000

    Add 9.8 branch to ci-status page.

commit ee6b9e661633fcefd29dba0c811cecbc4d027f6f
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Tue Mar 26 22:15:08 2024 +0100

    Fix detection of setres*id on GNU/Hurd
    
    Like Linux, proper _SOURCE macros need to be set to get declarations of
    various standard functions, notably setres*id. Now that Debian is using
    -Werror=implicit-function-declaration this is really required. While at
    it, define other _SOURCE macros like on GNU/Linux, since GNU/Hurd uses
    the same glibc.

commit fa41f6592ff1b6ead4a652ac75af31eabb05b912
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jul 1 14:33:26 2024 +1000

    version numbers

commit bfebb8a5130a792c5356bd06e1ddef72a0a0449f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 1 04:31:59 2024 +0000

    upstream: openssh-9.8
    
    OpenBSD-Commit-ID: 5f8b89e38a4c5f7c6d52ffa19f796d49f36fab19

commit 146c420d29d055cc75c8606327a1cf8439fe3a08
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 1 04:31:17 2024 +0000

    upstream: when sending ObscureKeystrokeTiming chaff packets, we
    
    can't rely on channel_did_enqueue to tell that there is data to send. This
    flag indicates that the channels code enqueued a packet on _this_ ppoll()
    iteration, not that data was enqueued in _any_ ppoll() iteration in the
    timeslice. ok markus@
    
    OpenBSD-Commit-ID: 009b74fd2769b36b5284a0188ade182f00564136

commit 637e4dfea4ed81264e264b6200172ce319c64ead
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 1 03:10:19 2024 +0000

    upstream: use "lcd" to change directory before "lls" rather then "cd",
    
    since the directory we're trying to list is local. Spotted by Corinna
    Vinschen
    
    OpenBSD-Regress-ID: 821feca4a4bebe491944e624c8f7f2990b891415

commit c8cfe258cee0b8466ea84597bf15e1fcff3bc328
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 27 23:01:15 2024 +0000

    upstream: delete obsolete comment
    
    OpenBSD-Commit-ID: 5fb04f298ed155053f3fbfdf0c6fe7cdf84bbfa2

commit 94b9d37100f6fa536aaa1d1a0e4926fe44fbf04d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 27 22:36:44 2024 +0000

    upstream: retire unused API
    
    OpenBSD-Commit-ID: 3e30d7b0615e2707f6bbe70f61b1c2f72f78161b

commit 268c3a7f5783e731ed60f4e28da66ee3743581d3
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Thu Jun 27 21:02:16 2024 +0000

    upstream: ssl(8) no longer contains a HISTORY section;
    
    OpenBSD-Commit-ID: 83b7ff34433d79595e9c2a5d2a561a6660251245

commit 12b6cc09ce6c430681f03af2a8069e37a664690b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jun 26 23:47:46 2024 +0000

    upstream: move child process waitpid() loop out of SIGCHLD handler;
    
    ok deraadt
    
    OpenBSD-Commit-ID: 65815a39564e431414aed7c5ace8076f4e9ca741

commit d6bcd13297c2ab8b528df5a6898f994734849031
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Wed Jun 26 23:16:52 2024 +0000

    upstream: Instead of using possibly complex ssh_signal(), write all
    
    the parts of the grace_alarm_handler() using the exact things allowed by the
    signal-safe rules.  This is a good rule of thumb: Handlers should be written
    to either set a global volatile sig_atomic_t inspected from outside, and/or
    directly perform only safe operations listed in our sigaction(2) manual page.
    ok djm markus
    
    OpenBSD-Commit-ID: 14168ae8368aab76e4ed79e17a667cb46f404ecd

commit b8793e2b0851f7d71b97554fa5260b23796d6277
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Wed Jun 26 23:14:14 2024 +0000

    upstream: save_errno wrappers inside two small signal handlers that
    
    perform system calls, for systems with libc that do perform libc sigtramps.
    ok djm markus
    
    OpenBSD-Commit-ID: 7749b56419a7c9dcfe4c6c04811e429813346c62

commit f23e9332c4c8df37465c4a4f38275ea98980ed7e
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Mon Jun 24 06:59:39 2024 +0000

    upstream: - uppercase start of sentence - correct sentence grammar
    
    ok djm
    
    OpenBSD-Commit-ID: 1ec4b0fdb633a43667f2c8fff1d600bd647dde25

commit 1839e3eb71a759aa795602c1e4196300f4ac2615
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 24 04:05:11 2024 +0000

    upstream: mention SshdSessionPath option
    
    OpenBSD-Commit-ID: c29734d36c21003973b15c1c9965c35f36cef30c

commit 603193e32aef5db7d60c58066d5de89806e79312
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jun 20 18:45:14 2024 +1000

    Rerun upstream tests on .sh file changes too.

commit dbbf9337c19381786a8e5a8a49152fe6b80c780d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 20 08:23:18 2024 +0000

    upstream: Work around dbclient cipher/mac query bug.
    
    Unlike earlier versions, recent Dropbear (at least v2024.85) requires
    a host arg when querying supported ciphers and macs via "-c/-m
    help".  Earlier versions accept but do not require it, so always
    provide it.  If these queries fail, skip the test with a warning.
    
    OpenBSD-Regress-ID: 98eb863a3f0363416922efb273885e6b3c7f68d4

commit 8de2c8cebc46bbdb94b7a2c120fcadfb66a3cccc
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 20 08:18:34 2024 +0000

    upstream: Remove dropbear key types not supported
    
    by current OpenSSH. Allows subsequent test runs to work if OpenSSH is
    rebuilt w/out OpenSSL.
    
    OpenBSD-Regress-ID: e0129eb2b1d31771105903a8055216fbba20a770

commit e9b6471c59b21e5d9ef1b3832d4bf727338add85
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 20 00:18:05 2024 +0000

    upstream: stricter check for overfull tables in penalty record path
    
    OpenBSD-Commit-ID: 7df01e648a0723418c554e64a9f2b6d38db060a6

commit d9336d344eb2a1e898c5e66147b3f108c7214694
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jun 19 23:24:47 2024 +0000

    upstream: put back reaping of preauth child process when writes
    
    from the monitor fail. Not sure how this got lost in the avalanche of
    patches.
    
    OpenBSD-Commit-ID: eb7eb36371e1ac01050b32b70fb2b3e5d98e72f5

commit 579d9adb70ec0206a788eb5c63804c31a67e9310
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Mon Jun 17 13:50:18 2024 +0000

    upstream: remove one more mention of DSA
    
    OpenBSD-Commit-ID: 8515f55a15f02836ba657df341415f63c60526ca

commit 7089b5f8436ef0b8d3d3ad9ce01045fb9e7aab15
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 19 23:09:05 2024 +1000

    Move -f to the place needed to restart sshd.

commit d5f83cfd852b14a25f347f082ab539a9454702ad
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 19 21:04:01 2024 +1000

    Need to supply "-f" to restart sshd.

commit fad34b4ca25c0ef31e5aa841d461b6f21da5b8c1
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 19 10:15:51 2024 +0000

    upstream: Provide defaults for ciphers and macs
    
    if querying for them fails since on some versions of Dropbear (at least
    v2024.85) "-m help" doesn't seem to work.  Enable all supported pubkey
    algorithms in the server.
    
    OpenBSD-Regress-ID: 4f95556a49ee9f621789f25217c367a33d2745ca

commit 5521060e35ada9f957cecdddc06d0524e75409ef
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 19 10:10:46 2024 +0000

    upstream: Use ed25519 keys for kex tests
    
    since that's supported by OpenSSH even when built without OpenSSL.
    Only test diffie-hellman kex if OpenSSH is compiled with support for it.
    
    OpenBSD-Regress-ID: a5d09ef9bbd171f9e4ec73ed0d9eeb49a8878e97

commit dbd3b833f6e3815e58f2dc6e14f61a51bcd4d6bd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 19 10:08:34 2024 +0000

    upstream: Rework dropbear key setup
    
    to always generate ed25519 keys, other types only if OpenSSH has support
    for the corresponding key type.
    
    OpenBSD-Regress-ID: 8f91f12604cddb9f8d93aa34f3f93a3f6074395d

commit d6218504e11ae9148adf410fc69b0710a052be36
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 19 20:20:24 2024 +1000

    Restart sshd after installing it for testing.
    
    When installing an sshd built without OpenSSL the mismatch between
    the running sshd and newly installed sshd-session will cause the
    remainder of the test to fail.

commit 786a4465b6bb702daf4fb17b7c3bcb42b52f0b46
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 18 19:59:59 2024 +1000

    Remove macos-11 runner.
    
    Github is retiring them soon.

commit df1c72a55edbebac14363b57de66ac6a147ecc67
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Jun 19 09:34:34 2024 +1000

    PAMServiceName may appear in a Match block

commit de1c2e70e5a5dc3c8d2fe04b24cc93d8ef6930e7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 18 08:11:48 2024 +0000

    upstream: Re-enable ssh-dss tests
    
    ... if ssh is compiled with DSA support
    
    OpenBSD-Regress-ID: bbfaf8c17f2b50a2d46ac35cb97af99b990c990d

commit dabc2c7cf3c141e8e5d5a1a60d6c1d2d2422cf43
Author: anton@openbsd.org <anton@openbsd.org>
Date:   Tue Jun 18 06:14:27 2024 +0000

    upstream: Stop using DSA in dropbear interop tests.
    
    OpenBSD-Regress-ID: abfd4457d99d8cc1417fd22ca2c570270f74c1cf

commit 761438012710169445acc179e3870c53c862bda0
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Jun 18 12:29:45 2024 +1000

    missed a bit of DSA in the fuzzer

commit 3f9cc47da588e8de520720e59f98438043fdaf93
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Jun 18 09:35:53 2024 +1000

    DSA support is disabled, so remove from fuzzers

commit 00eb95957dea5484b2c7c043f7d2bbc87301bef2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 17 08:30:29 2024 +0000

    upstream: disable the DSA signature algorithm by default; ok
    
    markus@
    
    (yes, I know this expands to "the Digitial Signature Algorithm
    signature algorithm)
    
    OpenBSD-Commit-ID: 961ef594e46dd2dcade8dd5721fa565cee79ffed

commit 5603befe11c9464ea26fe77cbacc95a7cc0b1ea7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 17 08:28:31 2024 +0000

    upstream: promote connection-closed messages from verbose to info
    
    log level; they could be the only record of the connection terminating if the
    client doesn't send a SSH2_MSG_DISCONNECT message. ok dtucker@
    
    OpenBSD-Commit-ID: 0c8bfaf5e9fdff945cee09ac21e641f6c5d65d3c

commit b00331402fe5c60d577f3ffcc35e49286cdc6b47
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 17 17:02:18 2024 +1000

    propagate PAM crashes to PerSourcePenalties
    
    If the PAM subprocess crashes, exit with a crash status that will be
    picked up by the sshd(8) listener process where it can be used by
    PerSourcePenalties to block the client. This is similar handling to
    the privsep preauth process.

commit 1c207f456ace38987deda047758d13fbf857f948
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 17 15:06:01 2024 +1000

    minix doesn't have loopback, so skip penalty tests
    
    pointed out by dtucker@

commit 48443d202eaec52d4d39defdd709a4499a7140c6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 16 11:54:49 2024 +0000

    upstream: same treatment for this test
    
    OpenBSD-Regress-ID: d0cc9efca7833e673ea7b0cb3a679a3acee8d4c7

commit 45562a95ea11d328c22d97bf39401cd29684fb1f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 16 08:18:06 2024 +0000

    upstream: penalty test is still a bit racy
    
    OpenBSD-Regress-ID: 90c9ac224db454637baf1ebee5857e007321e824

commit 8d0f7eb147ef72d18acb16c0b18672d44941a8ca
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jun 15 03:59:10 2024 +0000

    upstream: crank up penalty timeouts so this should work on even the
    
    slowest of test builders
    
    OpenBSD-Regress-ID: 70bda39c83e3fc9d0f3c1fad4542ed33e173d468

commit 93c75471a1202ab3e29db6938648d4e2602c0475
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri Jun 14 05:20:34 2024 +0000

    upstream: sort -q in the options list;
    
    OpenBSD-Commit-ID: 6839b38378f38f754de638a5e988c13b4164cc7c

commit dd7807bbe80a93ffb4616f2bd5cf83ad5a5595fb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 14 05:01:22 2024 +0000

    upstream: clarify KEXAlgorithms supported vs available. Inspired by
    
    bz3701 from Colin Watson.
    
    OpenBSD-Commit-ID: e698e69bea19bd52971d253f2b1094490c4701f7

commit d172ad56df85b68316dbadbedad16761a1265874
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 14 05:00:42 2024 +0000

    upstream: ssh-keyscan -q man bits
    
    OpenBSD-Commit-ID: ba28d0e1ac609a4c99c453e57e86560c79079db1

commit 092e4ff9ccaacbe035f286feb1b56ed499604743
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jun 14 14:46:35 2024 +1000

    skip penalty-expire test in valgrind test env

commit 2866ad08a9c50d7b67ce9424ca990532b806a21a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 14 04:43:11 2024 +0000

    upstream: split the PerSourcePenalties test in two: one tests penalty
    
    enforcement but not penalty expiry, the other tests penalty expiry.
    
    This lets us disable the expiry testing in certain CI test environments.
    
    OpenBSD-Regress-ID: f56811064f3e3cb52ee73a206b8c2a06af1c8791

commit b2c64bc170d75823622a37cab3ca1804ca87ad16
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jun 14 14:19:23 2024 +1000

    add a sshd_config PamServiceName option
    
    Allows selecting which PAM service name to use when UsePAM is
    enabled. Defaults to "sshd" unless overridden at compile time
    by defining SSHD_PAM_SERVICE.
    
    bz2102, ok dtucker@

commit 9f032a4dd17bf0ae6066223d82aa5e784285d987
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 14 00:26:12 2024 +0000

    upstream: don't redirect stderr for ssh-keyscan we expect to succeed
    
    OpenBSD-Regress-ID: 8878b8eb4e070ed2e343166d3eb86db4a08a216c

commit 1e84d0cf40e94ae3a77d6a7ca8c036d8e3d55a40
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 14 00:25:25 2024 +0000

    upstream: make host/banner comments go to stderr instead of stdout,
    
    so they are useful as comments without extra shell redirection and so they
    don't clutter actual errors on stderr.
    
    Add a -q flag to shut them up.
    
    ok dtucker@
    
    OpenBSD-Commit-ID: bec813de56a71adb5c1a76adcf49621130d24264

commit 3e806d011855d6bd648ec95b9df630ebbd11c3bf
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Thu Jun 13 15:06:33 2024 +0000

    upstream: separate keywords with comma
    
    OpenBSD-Commit-ID: d65a99666202a8188c4991c18d14374a229f7be5

commit abfd1f7a3cbd0a92581a0febba254b2f6649c0d9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 14 00:23:55 2024 +0000

    upstream: specify an algorithm for ssh-keyscan, otherwise it will make
    
    multiple attempts simultaneously and confuse the test
    
    OpenBSD-Regress-ID: 6e910f3315c4345053db1bf5cbf61826b194d0b9

commit a8fbe2f7d0d96d299ee8e69769e3b51067978748
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jun 13 16:41:29 2024 +1000

    sshd: don't use argv[0] as PAM service name
    
    sshd would implicitly use argv[0] as the PAM service name to
    allow people to select different PAM service names by making
    differently-named copies/links to the sshd binary.
    
    Splitting sshd into sshd/sshd-session broke this, as the process
    that starts PAM is always sshd-session and the user has no control
    over this.
    
    Hardcode "sshd" as the default PAM service name unless/until we
    figure out a better way. Should unbreak OSX integration tests.

commit bf204bd05c3ae650f87e2b96527688579f59774c
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jun 13 15:00:28 2024 +1000

    prepare for checking in autogenerated files
    
    We plan to check in automatically generated files (config.h.in, etc) on
    release branches. These files are normally ignored by .gitignore, but
    this shuffles the contents of this file to make it easy to un-ignore
    them.

commit 425f79a837489904c343b349ef00e09aeaa4e752
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jun 13 14:41:33 2024 +1000

    typo in comment

commit afe10313c1fa8d478af399ee7d54c8f85503013b
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jun 13 14:35:25 2024 +1000

    fix PTY allocation on Cygwin, broken by sshd split
    
    Cygwin doesn't support FD passing and so used to disable post-auth
    privilege separation entirely because privsep requires PTY allocation
    to happen in the privileged monitor process with the PTY file
    descriptors being passed back to the unprivileged process.
    
    This brings back a minimal version of the previous special treatment
    for Cygwin (and any other platform that sets DISABLE_FD_PASSING):
    privilege separation remains enabled, but PTY allocation happens in
    the post-auth user process rather than the monitor.
    
    This either requires PTY allocation to not need privilege to begin
    with (this appears to be the case on Cygwin), or the post-auth
    privsep process retain privilege (other platforms that set the
    DISABLE_FD_PASSING option).
    
    Keeping privileges here is bad, but the non-Cygwin systems that set
    DISABLE_FD_PASSING are so deeply legacy that this is likely to be the
    least of their problems.

commit f66d4df5749551380a8c4ae642347675a0b6a2e9
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jun 13 11:33:09 2024 +1000

    delay lookup of privsep user until config loaded
    
    sshd-session attempting to use options.kerberos_authentication to
    decide whether it needed to lookup the privsep user before the
    configuration was loaded. This caused it to get a placeholder value
    that caused it always to try to lookup the privsep user, breaking at
    least one test environment.

commit f1c42858b94f5d9b58867b34dce3afb39c6b56a8
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jun 13 11:16:57 2024 +1000

    missing file for PerSourcePenalties regress test

commit 4de80ff4e6fab5a6bb0028e7d57c6c23d1485adb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jun 12 22:36:00 2024 +0000

    upstream: split PerSourcePenalties address tracking. Previously it
    
    used one shared table and overflow policy for IPv4 and IPv6 addresses, now it
    will use separate tables and optionally different overflow policies.
    
    This prevents misbehaviour from IPv6 addresses (which are vastly easier
    to obtain many of) from affecting IPv4 connections and may allow for
    stricter overflow policies.
    
    ok deraadt@
    
    OpenBSD-Commit-ID: 12637ed0aa4d5f1f3e702da42ea967cbd8bfdfd9

commit 06ab4c6931b0aaa4334db2faaa7e1069e76d0df6
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Tue Jun 11 05:24:39 2024 +0000

    upstream: do not mark up "(default: 20ms)";
    
    OpenBSD-Commit-ID: 54151ecdecfa1b67dcdda4fd24826ef6e2148ad4

commit cfe243cd9fde148ed060637876e27bb55ac78be9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 02:54:51 2024 +0000

    upstream: reap preauth net child if it hangs up during privsep message
    
    send, not just message receive
    
    OpenBSD-Commit-ID: 02a093f4ab4f8f83f0cd1ea2bb35b9ca420448f0

commit b0a711c00b9c64afd1c9d6fb538275c6604a2676
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 01:58:27 2024 +0000

    upstream: fix PIDFILE handling, broken for SUDO=doas in last commit
    
    here
    
    OpenBSD-Regress-ID: 96fec579af228f87a036e94801eb294af9074625

commit 90fb801e2d9241be50a2a7ff79428386442a041f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 02:00:30 2024 +0000

    upstream: reap the pre-auth [net] child if it hangs up during privsep
    
    message sending, not just receiving
    
    OpenBSD-Commit-ID: f7341605bf08c4c15830910446e6775323f2f8cb

commit ef878d58798f6688c7f4d4e417dc0c29023ea831
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 01:23:25 2024 +0000

    upstream: a little more RB_TREE paranoia
    
    OpenBSD-Commit-ID: 8dc2fd21eebd8830c4a4d25461ac4fe228e11156

commit fc4e96b2174d6a894d2033421699d091679baced
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 01:22:25 2024 +0000

    upstream: fix off-by-one comparison for PerSourcePenalty
    
    OpenBSD-Commit-ID: af4f5d01c41ef870b23e55655bfbf73474a6c02b

commit 82c836df4ff41145553cd7adb11c5b985aeaa06f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 01:21:41 2024 +0000

    upstream: move tree init before possible early return
    
    OpenBSD-Commit-ID: 72e2c5b69f151c08a7c5bf5ad929b97a92c273df

commit a2300f015cc4939c4d9c564b58b74e71202dc978
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 01:07:35 2024 +0000

    upstream: update to mention that PerSourcePenalties default to
    
    being enabled and document the default values for each parameter.
    
    OpenBSD-Commit-ID: b981288bddfb097aad269f62df4081c688ce0034

commit 41987efd356d3fc30139aeab4b09374acf8f91a0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 00:44:52 2024 +0000

    upstream: reap the [net] child if it hangs up while writing privsep
    
    message payloads, not just the message header
    
    OpenBSD-Commit-ID: 24dbd400aa381ac96be7ed2dd49018487dfef6ce

commit 6211aa085fa91155a24922e5329576ac9a8f3175
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 00:40:21 2024 +0000

    upstream: log waitpid() status for abnormal exits
    
    OpenBSD-Commit-ID: b317930e06b51819c1a2bc6a4359764fecfb1c2d

commit a59634c7adb9ae988748d99963dfafb3070d8d41
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 11 00:36:20 2024 +0000

    upstream: correct error message
    
    OpenBSD-Commit-ID: 581f60f73099083392887206860229ab104620ed

commit fa7d7a667f2ee031e72873e36de2d2a36bca973b
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Fri Jun 7 13:23:30 2024 +0000

    upstream: avoid shadowing issues which some compilers won't accept
    
    ok djm
    
    OpenBSD-Commit-ID: 1e89572397dda83433d58c4fa6333a08f51170d4

commit 3ad4cd9eeca5c9bc6706db44b6de88e2e4513fd6
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Thu Jun 6 21:14:49 2024 +0000

    upstream: escape the final dot at eol in "e.g." to avoid double
    
    spacing;
    
    OpenBSD-Commit-ID: 0a9fb10bc9f7d577afe2da3f498a08bc431115b9

commit 0e0c69761a4c33ccd4a256560f522784a753d1a8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 20:25:48 2024 +0000

    upstream: enable PerSourcePenalties by default.
    
    ok markus
    
    NB. if you run a sshd that accepts connections from behind large NAT
    blocks, proxies or anything else that aggregates many possible users
    behind few IP addresses, then this change may cause legitimate traffic
    to be denied.
    
    Please read the PerSourcePenalties, PerSourcePenaltyExemptList and
    PerSourceNetBlockSize options in sshd_config(5) for how to tune your
    sshd(8) for your specific circumstances.
    
    OpenBSD-Commit-ID: 24a0e5c23d37e5a63e16d2c6da3920a51078f6ce

commit bd1f74741daabeaf20939a85cd8cec08c76d0bec
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 20:20:42 2024 +0000

    upstream: mention that PerSourcePenalties don't affect concurrent
    
    in-progress connections.
    
    OpenBSD-Commit-ID: 20389da6264f2c97ac3463edfaa1182c212d420c

commit 9774b938578327d88a651f4c63c504809717590a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 19:49:25 2024 +0000

    upstream: regress test for PerSourcePenalties
    
    OpenBSD-Regress-ID: a1af13d411b25a727742644459d26480b9a1b0f1

commit b8ebd86cefe9812204a10c028dc90de29918667d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 19:48:40 2024 +0000

    upstream: make sure logs are saved from sshd run via start_sshd
    
    OpenBSD-Regress-ID: de4ef0e32e3ab85ff3a6c36eb08d1909c0dd1b4a

commit d7b2070bdaa4ebbfafb9975c1d5a62b73289d31f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 19:47:48 2024 +0000

    upstream: simplify
    
    OpenBSD-Regress-ID: 50316e0d1ae0c0a057a45af042253e54ce23d11c

commit e6ea3d224513b6bfb93818809d4c7397f5995ba2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 18:48:13 2024 +0000

    upstream: prepare for PerSourcePenalties being enabled by default
    
    in future
    
    OpenBSD-Regress-ID: 5236c6d1c823997aac5a35e2915da30f1903bec7

commit c0cb3b8c837761816a60a3cdb54062668df09652
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 19:50:01 2024 +0000

    upstream: disable stderr redirection before closing fds
    
    OpenBSD-Commit-ID: d42cb895ee4542098050367fc35321c9303f003a

commit 81c1099d22b81ebfd20a334ce986c4f753b0db29
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 6 17:15:25 2024 +0000

    upstream: Add a facility to sshd(8) to penalise particular
    
    problematic client behaviours, controlled by two new sshd_config(5) options:
    PerSourcePenalties and PerSourcePenaltyExemptList.
    
    When PerSourcePenalties are enabled, sshd(8) will monitor the exit
    status of its child pre-auth session processes. Through the exit
    status, it can observe situations where the session did not
    authenticate as expected. These conditions include when the client
    repeatedly attempted authentication unsucessfully (possibly indicating
    an attack against one or more accounts, e.g. password guessing), or
    when client behaviour caused sshd to crash (possibly indicating
    attempts to exploit sshd).
    
    When such a condition is observed, sshd will record a penalty of some
    duration (e.g. 30 seconds) against the client's address. If this time
    is above a minimum threshold specified by the PerSourcePenalties, then
    connections from the client address will be refused (along with any
    others in the same PerSourceNetBlockSize CIDR range).
    
    Repeated offenses by the same client address will accrue greater
    penalties, up to a configurable maximum. A PerSourcePenaltyExemptList
    option allows certain address ranges to be exempt from all penalties.
    
    We hope these options will make it significantly more difficult for
    attackers to find accounts with weak/guessable passwords or exploit
    bugs in sshd(8) itself.
    
    PerSourcePenalties is off by default, but we expect to enable it
    automatically in the near future.
    
    much feedback markus@ and others, ok markus@
    
    OpenBSD-Commit-ID: 89ded70eccb2b4926ef0366a4d58a693de366cca

commit 916b0b6174e203cf2c5ec9bcf409472eb7ffbf43
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jun 7 03:31:02 2024 +1000

    whitespace

commit 49b55e44182b8294419aa580cbf043d5b9e3d953
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Tue Jun 4 15:14:45 2024 +0000

    upstream: enable -fret-clean on amd64, for libc libcrypto ld.so
    
    kernel, and all the ssh tools.  The dynamic objects are entirely ret-clean,
    static binaries will contain a blend of cleaning and non-cleaning callers.
    
    OpenBSD-Commit-ID: 112aacedd3b61cc5c34b1fa6d9fb759214179172

commit cc80d51d034bcb24fd0f2564a4bdf1612000a2a2
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Jun 5 02:21:30 2024 +1000

    remove PRIVSEP macros for osx

commit 8785491123d4d722b310c20f383570be758f8263
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jun 1 07:03:37 2024 +0000

    upstream: be really strict with fds reserved for communication with the
    
    separate sshd-session process - reserve them early and fatal if we can't
    dup2(2) them later. The pre-split fallback to re-reading the configuration
    files is not possible, so sshd-session absolutely requires the fd the
    configuration is passed over to be in order.
    
    ok deraadt@
    
    OpenBSD-Commit-ID: 308a98ef3c8a6665ebf92c7c9a0fc9600ccd7065

commit f1c8918cb98459910fb159373baea053ba4108c0
Author: Damien Miller <djm@mindrot.org>
Date:   Fri May 31 19:12:26 2024 +1000

    depend

commit 94b4866cb1f4b0ed29a9f367047b30f81002316f
Author: Damien Miller <djm@mindrot.org>
Date:   Fri May 31 19:11:14 2024 +1000

    rename need_privsep to need_chroot
    
    privsep is mandatory, chroot is optional (disabled when running
    sshd as non-root)

commit e68a95142e5024b144f8eeccd5ffdee42c34f44c
Author: Damien Miller <djm@mindrot.org>
Date:   Fri May 31 19:05:34 2024 +1000

    remove remaining use_privsep mention

commit b21d271f651d2536dca819cc6d74032fe98634db
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 31 09:01:08 2024 +0000

    upstream: warn when -r (deprecated option to disable re-exec) is
    
    passed
    
    OpenBSD-Commit-ID: 73145ef5150edbe3ce7889f0844ed8fa6155f551

commit a4b5bc246cbca476deeeb4462aa31746a56e3021
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 31 08:49:35 2024 +0000

    upstream: typos
    
    OpenBSD-Commit-ID: edfa72eb06bfa65da30fabf7d2fe76d2d33f77bf

commit 8054b906983ceaed01fabd8188d3dac24c05ba39
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 27 01:52:26 2024 +0000

    upstream: don't need sys/queue.h here
    
    OpenBSD-Commit-ID: dd137396828171eb19e4911581812ca58de6c578

commit 210d4239733da6180ce853538aeb9413d5c62ad5
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Sun May 26 20:35:12 2024 +0000

    upstream: remove references to SSH1 and DSA server keys
    
    OpenBSD-Commit-ID: 57cc1c98d4f998981473734f144b904af7d178a2

commit f0b9261d7fdd0ef86806b49fe76344bd16770cd0
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Thu May 23 23:47:16 2024 +0000

    upstream: remove unused struct fwd_perm_list, no decl with complete
    
    type ok djm@
    
    OpenBSD-Commit-ID: 416fb3970b7e73c76d2963c4f00cf96f2b2ee2fb

commit 2477a98c3ef78e63b11a1393656e00288f52ae97
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Wed May 22 15:24:55 2024 +0000

    upstream: Do not pass -Werror twice when building with clang.
    
    OpenBSD-Commit-ID: 5f378c38ad8976d507786dc4db9283a879ec8cd0

commit 435844f5675245b4271f8581f15e6d1f34fde3bc
Author: miod@openbsd.org <miod@openbsd.org>
Date:   Wed May 22 11:49:36 2024 +0000

    upstream: Do not pass -Werror if building with gcc 3, for asn1.h
    
    and bio.h cause (admittedly bogus) warnings with gcc 3.
    
    OpenBSD-Commit-ID: fb39324748824cb0387e9d67c41d1bef945c54ea

commit fc5dc092830de23767c6ef67baa18310a64ee533
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 22 04:20:00 2024 +0000

    upstream: this test has been broken since 2014, and has been
    
    testing the same key exchange algorithm repeatedly instead of testing all of
    them. Spotted by nreilly AT blackberry.com in bz3692
    
    Who broke the test? me.
    
    OpenBSD-Regress-ID: 48f4f5946276f975667141957d25441b3c9a50e2

commit fd4816791beaed2fdae7eea3e1494d1972b2a39d
Author: anton@openbsd.org <anton@openbsd.org>
Date:   Sun May 19 19:10:01 2024 +0000

    upstream: Add missing kex-names.c source file required since the
    
    ssh split.
    
    OpenBSD-Regress-ID: ca666223f828fc4b069cb9016bff1eb50faf9fbb

commit beccb7319c5449f6454889013403c336446d622e
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Fri May 17 14:42:00 2024 +0000

    upstream: remove duplicate copy of relink kit for sshd-session
    
    OpenBSD-Commit-ID: 6d2ded4cd91d4d727c2b26e099b91ea935bed504

commit dcd79fa141311c287e0595ede684b7116122fae0
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Fri May 17 06:42:04 2024 +0000

    upstream: remove prototypes with no matching function; ok djm@
    
    OpenBSD-Commit-ID: 6d9065dadea5f14a01bece0dbfe2fba1be31c693

commit 6454a05e7c6574d70adf17efe505a8581a86ca4f
